/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0, 
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0, 
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0, 
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0, 
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0, 
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0, 
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0, 
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0, 
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0, 
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0, 
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0, 
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0, 
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0, 
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0, 
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0, 
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0, 
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0, 
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0, 
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0, 
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0, 
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0, 
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0, 
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0, 
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0, 
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0, 
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0, 
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0, 
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0, 
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0, 
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0, 
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0, 
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0, 
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0, 
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0, 
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0, 
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0, 
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0, 
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0, 
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0, 
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0, 
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0, 
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0, 
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0, 
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0, 
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0, 
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0, 
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0, 
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0, 
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0, 
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0, 
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0, 
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0, 
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0, 
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0, 
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0, 
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0, 
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0, 
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0, 
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0, 
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0, 
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0, 
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0, 
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0, 
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0, 
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0, 
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0, 
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0, 
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0, 
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0, 
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0, 
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0, 
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0, 
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0, 
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::STORE),// ->2981
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, MVT::v16i8,
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0, 
/*  2103*/     OPC_EmitConvertToTarget2,
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0, 
/*  2127*/     OPC_EmitConvertToTarget2,
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, MVT::v8i16,
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0, 
/*  2168*/     OPC_EmitConvertToTarget2,
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0, 
/*  2192*/     OPC_EmitConvertToTarget2,
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, MVT::v4i32,
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0, 
/*  2230*/     OPC_EmitConvertToTarget2,
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0, 
/*  2251*/     OPC_EmitConvertToTarget2,
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, MVT::v2i64,
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0, 
/*  2289*/     OPC_EmitConvertToTarget2,
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0, 
/*  2310*/     OPC_EmitConvertToTarget2,
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 15|128,5/*655*/, /*->2980*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 10 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0, 
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0, 
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0, 
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0, 
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0, 
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0, 
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0, 
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0, 
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0, 
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0, 
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0, 
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 12, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0, 
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0, 
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0, 
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, MVT::f32,
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0, 
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0, 
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, MVT::f64,
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0, 
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0, 
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, MVT::v16i8,
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0, 
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0, 
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, MVT::v8i16,
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0, 
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0, 
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, MVT::v4i32,
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0, 
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0, 
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, MVT::v2i64,
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0, 
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0, 
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, MVT::v4f32,
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0, 
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0, 
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 43, /*->2979*/
/*  2936*/    OPC_CheckChild1Type, MVT::v2f64,
/*  2938*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2939*/    OPC_Scope, 18, /*->2959*/ // 2 children in Scope
/*  2941*/     OPC_CheckChild2TypeI32,
/*  2942*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2943*/     OPC_CheckPredicate5,  // Predicate_store
/*  2944*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2945*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2947*/     OPC_EmitMergeInputChains1_0,
/*  2948*/     OPC_EmitInteger32, 0, 
/*  2950*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2959*/    /*Scope*/ 18, /*->2978*/
/*  2960*/     OPC_CheckChild2TypeI64,
/*  2961*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2962*/     OPC_CheckPredicate5,  // Predicate_store
/*  2963*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2964*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2966*/     OPC_EmitMergeInputChains1_0,
/*  2967*/     OPC_EmitInteger32, 0, 
/*  2969*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2978*/    0, /*End of Scope*/
/*  2979*/   0, /*End of Scope*/
/*  2980*/  0, /*End of Scope*/
/*  2981*/ /*SwitchOpcode*/ 22|128,2/*278*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3263
/*  2985*/  OPC_Scope, 40, /*->3027*/ // 3 children in Scope
/*  2987*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  2988*/   OPC_CheckChild1Integer, 52|128,62|128,1/*24372*/, 
/*  2992*/   OPC_MoveChild2,
/*  2993*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2996*/   OPC_RecordChild0, // #1 = $table1
/*  2997*/   OPC_MoveChild0,
/*  2998*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3001*/   OPC_MoveParent,
/*  3002*/   OPC_MoveSibling3,
/*  3003*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3006*/   OPC_RecordChild0, // #2 = $table2
/*  3007*/   OPC_MoveChild0,
/*  3008*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3011*/   OPC_MoveParent,
/*  3012*/   OPC_MoveParent,
/*  3013*/   OPC_RecordChild4, // #3 = $d
/*  3014*/   OPC_RecordChild5, // #4 = $s
/*  3015*/   OPC_RecordChild6, // #5 = $n
/*  3016*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3017*/   OPC_EmitMergeInputChains1_0,
/*  3018*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12186:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3027*/  /*Scope*/ 44, /*->3072*/
/*  3028*/   OPC_RecordMemRef,
/*  3029*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3030*/   OPC_CheckChild1Integer, 44|128,62|128,1/*24364*/, 
/*  3034*/   OPC_RecordChild2, // #1 = $val
/*  3035*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3036*/   OPC_Scope, 16, /*->3054*/ // 2 children in Scope
/*  3038*/    OPC_CheckChild3TypeI32,
/*  3039*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  3040*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3042*/    OPC_EmitMergeInputChains1_0,
/*  3043*/    OPC_EmitInteger32, 0, 
/*  3045*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12182:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3054*/   /*Scope*/ 16, /*->3071*/
/*  3055*/    OPC_CheckChild3TypeI64,
/*  3056*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  3057*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3059*/    OPC_EmitMergeInputChains1_0,
/*  3060*/    OPC_EmitInteger32, 0, 
/*  3062*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12182:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3071*/   0, /*End of Scope*/
/*  3072*/  /*Scope*/ 60|128,1/*188*/, /*->3262*/
/*  3074*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3075*/   OPC_Scope, 26, /*->3103*/ // 7 children in Scope
/*  3077*/    OPC_CheckChild1Integer, 76|128,62|128,1/*24396*/, 
/*  3081*/    OPC_MoveChild2,
/*  3082*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3085*/    OPC_RecordChild0, // #1 = $table
/*  3086*/    OPC_MoveChild0,
/*  3087*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3090*/    OPC_MoveParent,
/*  3091*/    OPC_MoveParent,
/*  3092*/    OPC_RecordChild3, // #2 = $i
/*  3093*/    OPC_RecordChild4, // #3 = $val
/*  3094*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3095*/    OPC_EmitMergeInputChains1_0,
/*  3096*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12198:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3103*/   /*Scope*/ 28, /*->3132*/
/*  3104*/    OPC_CheckChild1Integer, 58|128,62|128,1/*24378*/, 
/*  3108*/    OPC_MoveChild2,
/*  3109*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3112*/    OPC_RecordChild0, // #1 = $table
/*  3113*/    OPC_MoveChild0,
/*  3114*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3117*/    OPC_MoveParent,
/*  3118*/    OPC_MoveParent,
/*  3119*/    OPC_RecordChild3, // #2 = $i
/*  3120*/    OPC_RecordChild4, // #3 = $val
/*  3121*/    OPC_RecordChild5, // #4 = $n
/*  3122*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3123*/    OPC_EmitMergeInputChains1_0,
/*  3124*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12189:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3132*/   /*Scope*/ 26, /*->3159*/
/*  3133*/    OPC_CheckChild1Integer, 74|128,62|128,1/*24394*/, 
/*  3137*/    OPC_MoveChild2,
/*  3138*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3141*/    OPC_RecordChild0, // #1 = $table
/*  3142*/    OPC_MoveChild0,
/*  3143*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3146*/    OPC_MoveParent,
/*  3147*/    OPC_MoveParent,
/*  3148*/    OPC_RecordChild3, // #2 = $i
/*  3149*/    OPC_RecordChild4, // #3 = $val
/*  3150*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3151*/    OPC_EmitMergeInputChains1_0,
/*  3152*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12197:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3159*/   /*Scope*/ 28, /*->3188*/
/*  3160*/    OPC_CheckChild1Integer, 56|128,62|128,1/*24376*/, 
/*  3164*/    OPC_MoveChild2,
/*  3165*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3168*/    OPC_RecordChild0, // #1 = $table
/*  3169*/    OPC_MoveChild0,
/*  3170*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3173*/    OPC_MoveParent,
/*  3174*/    OPC_MoveParent,
/*  3175*/    OPC_RecordChild3, // #2 = $i
/*  3176*/    OPC_RecordChild4, // #3 = $val
/*  3177*/    OPC_RecordChild5, // #4 = $n
/*  3178*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3179*/    OPC_EmitMergeInputChains1_0,
/*  3180*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12188:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3188*/   /*Scope*/ 27, /*->3216*/
/*  3189*/    OPC_CheckChild1Integer, 72|128,62|128,1/*24392*/, 
/*  3193*/    OPC_MoveChild2,
/*  3194*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3197*/    OPC_RecordChild0, // #1 = $table
/*  3198*/    OPC_MoveChild0,
/*  3199*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3202*/    OPC_MoveParent,
/*  3203*/    OPC_MoveParent,
/*  3204*/    OPC_RecordChild3, // #2 = $i
/*  3205*/    OPC_RecordChild4, // #3 = $val
/*  3206*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3208*/    OPC_EmitMergeInputChains1_0,
/*  3209*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12196:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3216*/   /*Scope*/ 29, /*->3246*/
/*  3217*/    OPC_CheckChild1Integer, 54|128,62|128,1/*24374*/, 
/*  3221*/    OPC_MoveChild2,
/*  3222*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3225*/    OPC_RecordChild0, // #1 = $table
/*  3226*/    OPC_MoveChild0,
/*  3227*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3230*/    OPC_MoveParent,
/*  3231*/    OPC_MoveParent,
/*  3232*/    OPC_RecordChild3, // #2 = $i
/*  3233*/    OPC_RecordChild4, // #3 = $val
/*  3234*/    OPC_RecordChild5, // #4 = $n
/*  3235*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3237*/    OPC_EmitMergeInputChains1_0,
/*  3238*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12187:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3246*/   /*Scope*/ 14, /*->3261*/
/*  3247*/    OPC_CheckChild1Integer, 38|128,62|128,1/*24358*/, 
/*  3251*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasExceptionHandling())
/*  3253*/    OPC_EmitMergeInputChains1_0,
/*  3254*/    OPC_EmitInteger32, 0, 
/*  3256*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::RETHROW),
                  1/*#Ops*/, 1, 
              // Src: (intrinsic_void 12179:{ *:[iPTR] }) - Complexity = 8
              // Dst: (RETHROW 0:{ *:[i32] })
/*  3261*/   0, /*End of Scope*/
/*  3262*/  0, /*End of Scope*/
/*  3263*/ /*SwitchOpcode*/ 78|128,3/*462*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3729
/*  3267*/  OPC_Scope, 22|128,1/*150*/, /*->3420*/ // 3 children in Scope
/*  3270*/   OPC_RecordMemRef,
/*  3271*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3272*/   OPC_Scope, 45, /*->3319*/ // 3 children in Scope
/*  3274*/    OPC_CheckChild1Integer, 106|128,61|128,1/*24298*/, 
/*  3278*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3279*/    OPC_Scope, 18, /*->3299*/ // 2 children in Scope
/*  3281*/     OPC_CheckChild2TypeI32,
/*  3282*/     OPC_RecordChild3, // #2 = $count
/*  3283*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3284*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3286*/     OPC_EmitMergeInputChains1_0,
/*  3287*/     OPC_EmitInteger32, 0, 
/*  3289*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12149:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3299*/    /*Scope*/ 18, /*->3318*/
/*  3300*/     OPC_CheckChild2TypeI64,
/*  3301*/     OPC_RecordChild3, // #2 = $count
/*  3302*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3303*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3305*/     OPC_EmitMergeInputChains1_0,
/*  3306*/     OPC_EmitInteger32, 0, 
/*  3308*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12149:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3318*/    0, /*End of Scope*/
/*  3319*/   /*Scope*/ 49, /*->3369*/
/*  3320*/    OPC_CheckChild1Integer, 108|128,61|128,1/*24300*/, 
/*  3324*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3325*/    OPC_Scope, 20, /*->3347*/ // 2 children in Scope
/*  3327*/     OPC_CheckChild2TypeI32,
/*  3328*/     OPC_RecordChild3, // #2 = $exp
/*  3329*/     OPC_RecordChild4, // #3 = $timeout
/*  3330*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3331*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3333*/     OPC_EmitMergeInputChains1_0,
/*  3334*/     OPC_EmitInteger32, 0, 
/*  3336*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12150:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3347*/    /*Scope*/ 20, /*->3368*/
/*  3348*/     OPC_CheckChild2TypeI64,
/*  3349*/     OPC_RecordChild3, // #2 = $exp
/*  3350*/     OPC_RecordChild4, // #3 = $timeout
/*  3351*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3352*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3354*/     OPC_EmitMergeInputChains1_0,
/*  3355*/     OPC_EmitInteger32, 0, 
/*  3357*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12150:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3368*/    0, /*End of Scope*/
/*  3369*/   /*Scope*/ 49, /*->3419*/
/*  3370*/    OPC_CheckChild1Integer, 110|128,61|128,1/*24302*/, 
/*  3374*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3375*/    OPC_Scope, 20, /*->3397*/ // 2 children in Scope
/*  3377*/     OPC_CheckChild2TypeI32,
/*  3378*/     OPC_RecordChild3, // #2 = $exp
/*  3379*/     OPC_RecordChild4, // #3 = $timeout
/*  3380*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3381*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3383*/     OPC_EmitMergeInputChains1_0,
/*  3384*/     OPC_EmitInteger32, 0, 
/*  3386*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12151:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3397*/    /*Scope*/ 20, /*->3418*/
/*  3398*/     OPC_CheckChild2TypeI64,
/*  3399*/     OPC_RecordChild3, // #2 = $exp
/*  3400*/     OPC_RecordChild4, // #3 = $timeout
/*  3401*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3402*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3404*/     OPC_EmitMergeInputChains1_0,
/*  3405*/     OPC_EmitInteger32, 0, 
/*  3407*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12151:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3418*/    0, /*End of Scope*/
/*  3419*/   0, /*End of Scope*/
/*  3420*/  /*Scope*/ 6|128,2/*262*/, /*->3684*/
/*  3422*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3423*/   OPC_Scope, 25, /*->3450*/ // 9 children in Scope
/*  3425*/    OPC_CheckChild1Integer, 64|128,62|128,1/*24384*/, 
/*  3429*/    OPC_MoveChild2,
/*  3430*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3433*/    OPC_RecordChild0, // #1 = $table
/*  3434*/    OPC_MoveChild0,
/*  3435*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3438*/    OPC_MoveParent,
/*  3439*/    OPC_MoveParent,
/*  3440*/    OPC_RecordChild3, // #2 = $i
/*  3441*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3442*/    OPC_EmitMergeInputChains1_0,
/*  3443*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  MVT::funcref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12192:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3450*/   /*Scope*/ 27, /*->3478*/
/*  3451*/    OPC_CheckChild1Integer, 70|128,62|128,1/*24390*/, 
/*  3455*/    OPC_MoveChild2,
/*  3456*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3459*/    OPC_RecordChild0, // #1 = $table
/*  3460*/    OPC_MoveChild0,
/*  3461*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3464*/    OPC_MoveParent,
/*  3465*/    OPC_MoveParent,
/*  3466*/    OPC_RecordChild3, // #2 = $val
/*  3467*/    OPC_RecordChild4, // #3 = $n
/*  3468*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3469*/    OPC_EmitMergeInputChains1_0,
/*  3470*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12195:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3478*/   /*Scope*/ 25, /*->3504*/
/*  3479*/    OPC_CheckChild1Integer, 62|128,62|128,1/*24382*/, 
/*  3483*/    OPC_MoveChild2,
/*  3484*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3487*/    OPC_RecordChild0, // #1 = $table
/*  3488*/    OPC_MoveChild0,
/*  3489*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3492*/    OPC_MoveParent,
/*  3493*/    OPC_MoveParent,
/*  3494*/    OPC_RecordChild3, // #2 = $i
/*  3495*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3496*/    OPC_EmitMergeInputChains1_0,
/*  3497*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  MVT::externref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12191:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3504*/   /*Scope*/ 27, /*->3532*/
/*  3505*/    OPC_CheckChild1Integer, 68|128,62|128,1/*24388*/, 
/*  3509*/    OPC_MoveChild2,
/*  3510*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3513*/    OPC_RecordChild0, // #1 = $table
/*  3514*/    OPC_MoveChild0,
/*  3515*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3518*/    OPC_MoveParent,
/*  3519*/    OPC_MoveParent,
/*  3520*/    OPC_RecordChild3, // #2 = $val
/*  3521*/    OPC_RecordChild4, // #3 = $n
/*  3522*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3523*/    OPC_EmitMergeInputChains1_0,
/*  3524*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12194:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3532*/   /*Scope*/ 26, /*->3559*/
/*  3533*/    OPC_CheckChild1Integer, 60|128,62|128,1/*24380*/, 
/*  3537*/    OPC_MoveChild2,
/*  3538*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3541*/    OPC_RecordChild0, // #1 = $table
/*  3542*/    OPC_MoveChild0,
/*  3543*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3546*/    OPC_MoveParent,
/*  3547*/    OPC_MoveParent,
/*  3548*/    OPC_RecordChild3, // #2 = $i
/*  3549*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3551*/    OPC_EmitMergeInputChains1_0,
/*  3552*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  MVT::exnref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 12190:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3559*/   /*Scope*/ 28, /*->3588*/
/*  3560*/    OPC_CheckChild1Integer, 66|128,62|128,1/*24386*/, 
/*  3564*/    OPC_MoveChild2,
/*  3565*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3568*/    OPC_RecordChild0, // #1 = $table
/*  3569*/    OPC_MoveChild0,
/*  3570*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3573*/    OPC_MoveParent,
/*  3574*/    OPC_MoveParent,
/*  3575*/    OPC_RecordChild3, // #2 = $val
/*  3576*/    OPC_RecordChild4, // #3 = $n
/*  3577*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3579*/    OPC_EmitMergeInputChains1_0,
/*  3580*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12193:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3588*/   /*Scope*/ 23, /*->3612*/
/*  3589*/    OPC_CheckChild1Integer, 78|128,62|128,1/*24398*/, 
/*  3593*/    OPC_MoveChild2,
/*  3594*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3597*/    OPC_RecordChild0, // #1 = $table
/*  3598*/    OPC_MoveChild0,
/*  3599*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3602*/    OPC_MoveParent,
/*  3603*/    OPC_MoveParent,
/*  3604*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3605*/    OPC_EmitMergeInputChains1_0,
/*  3606*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  MVT::i32, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12199:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3612*/   /*Scope*/ 32, /*->3645*/
/*  3613*/    OPC_CheckChild1Integer, 114|128,61|128,1/*24306*/, 
/*  3617*/    OPC_RecordChild2, // #1 = $flags
/*  3618*/    OPC_MoveChild2,
/*  3619*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3622*/    OPC_MoveParent,
/*  3623*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->3634
/*  3626*/     OPC_EmitMergeInputChains1_0,
/*  3627*/     OPC_EmitConvertToTarget1,
/*  3628*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7400MEMORY_SIZE_A32),
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12153:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7400MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3634*/    /*SwitchType*/ 8, MVT::i64,// ->3644
/*  3636*/     OPC_EmitMergeInputChains1_0,
/*  3637*/     OPC_EmitConvertToTarget1,
/*  3638*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7401MEMORY_SIZE_A64),
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12153:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7401MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3644*/    0, // EndSwitchType
/*  3645*/   /*Scope*/ 37, /*->3683*/
/*  3646*/    OPC_CheckChild1Integer, 112|128,61|128,1/*24304*/, 
/*  3650*/    OPC_RecordChild2, // #1 = $flags
/*  3651*/    OPC_MoveChild2,
/*  3652*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3655*/    OPC_MoveParent,
/*  3656*/    OPC_RecordChild3, // #2 = $delta
/*  3657*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->3670
/*  3660*/     OPC_CheckChild3TypeI32,
/*  3661*/     OPC_EmitMergeInputChains1_0,
/*  3662*/     OPC_EmitConvertToTarget1,
/*  3663*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7400MEMORY_GROW_A32),
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12152:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_7400MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3670*/    /*SwitchType*/ 10, MVT::i64,// ->3682
/*  3672*/     OPC_CheckChild3TypeI64,
/*  3673*/     OPC_EmitMergeInputChains1_0,
/*  3674*/     OPC_EmitConvertToTarget1,
/*  3675*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7401MEMORY_GROW_A64),
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12152:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_7401MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3682*/    0, // EndSwitchType
/*  3683*/   0, /*End of Scope*/
/*  3684*/  /*Scope*/ 43, /*->3728*/
/*  3685*/   OPC_RecordMemRef,
/*  3686*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3687*/   OPC_CheckChild1Integer, 102|128,61|128,1/*24294*/, 
/*  3691*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3692*/   OPC_Scope, 16, /*->3710*/ // 2 children in Scope
/*  3694*/    OPC_CheckChild2TypeI32,
/*  3695*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  3696*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3698*/    OPC_EmitMergeInputChains1_0,
/*  3699*/    OPC_EmitInteger32, 0, 
/*  3701*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::f32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12147:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3710*/   /*Scope*/ 16, /*->3727*/
/*  3711*/    OPC_CheckChild2TypeI64,
/*  3712*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  3713*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3715*/    OPC_EmitMergeInputChains1_0,
/*  3716*/    OPC_EmitInteger32, 0, 
/*  3718*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::f32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12147:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3727*/   0, /*End of Scope*/
/*  3728*/  0, /*End of Scope*/
/*  3729*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4018
/*  3733*/  OPC_RecordMemRef,
/*  3734*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3735*/  OPC_Scope, 119, /*->3856*/ // 2 children in Scope
/*  3737*/   OPC_MoveChild1,
/*  3738*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3741*/   OPC_RecordChild0, // #1 = $val
/*  3742*/   OPC_MoveParent,
/*  3743*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3744*/   OPC_Scope, 54, /*->3800*/ // 2 children in Scope
/*  3746*/    OPC_CheckChild2TypeI32,
/*  3747*/    OPC_Scope, 16, /*->3765*/ // 3 children in Scope
/*  3749*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3750*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3751*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3753*/     OPC_EmitMergeInputChains1_0,
/*  3754*/     OPC_EmitInteger32, 0, 
/*  3756*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3765*/    /*Scope*/ 16, /*->3782*/
/*  3766*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3767*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3768*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3770*/     OPC_EmitMergeInputChains1_0,
/*  3771*/     OPC_EmitInteger32, 0, 
/*  3773*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3782*/    /*Scope*/ 16, /*->3799*/
/*  3783*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3784*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3785*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3787*/     OPC_EmitMergeInputChains1_0,
/*  3788*/     OPC_EmitInteger32, 0, 
/*  3790*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3799*/    0, /*End of Scope*/
/*  3800*/   /*Scope*/ 54, /*->3855*/
/*  3801*/    OPC_CheckChild2TypeI64,
/*  3802*/    OPC_Scope, 16, /*->3820*/ // 3 children in Scope
/*  3804*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3805*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3806*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3808*/     OPC_EmitMergeInputChains1_0,
/*  3809*/     OPC_EmitInteger32, 0, 
/*  3811*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3820*/    /*Scope*/ 16, /*->3837*/
/*  3821*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3822*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3823*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3825*/     OPC_EmitMergeInputChains1_0,
/*  3826*/     OPC_EmitInteger32, 0, 
/*  3828*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3837*/    /*Scope*/ 16, /*->3854*/
/*  3838*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3839*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3840*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3842*/     OPC_EmitMergeInputChains1_0,
/*  3843*/     OPC_EmitInteger32, 0, 
/*  3845*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3854*/    0, /*End of Scope*/
/*  3855*/   0, /*End of Scope*/
/*  3856*/  /*Scope*/ 31|128,1/*159*/, /*->4017*/
/*  3858*/   OPC_RecordChild1, // #1 = $val
/*  3859*/   OPC_Scope, 114, /*->3975*/ // 2 children in Scope
/*  3861*/    OPC_CheckChild1TypeI32,
/*  3862*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3863*/    OPC_Scope, 54, /*->3919*/ // 2 children in Scope
/*  3865*/     OPC_CheckChild2TypeI32,
/*  3866*/     OPC_Scope, 16, /*->3884*/ // 3 children in Scope
/*  3868*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3869*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3870*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3872*/      OPC_EmitMergeInputChains1_0,
/*  3873*/      OPC_EmitInteger32, 0, 
/*  3875*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3884*/     /*Scope*/ 16, /*->3901*/
/*  3885*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3886*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3887*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3889*/      OPC_EmitMergeInputChains1_0,
/*  3890*/      OPC_EmitInteger32, 0, 
/*  3892*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3901*/     /*Scope*/ 16, /*->3918*/
/*  3902*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3903*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3904*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3906*/      OPC_EmitMergeInputChains1_0,
/*  3907*/      OPC_EmitInteger32, 0, 
/*  3909*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3918*/     0, /*End of Scope*/
/*  3919*/    /*Scope*/ 54, /*->3974*/
/*  3920*/     OPC_CheckChild2TypeI64,
/*  3921*/     OPC_Scope, 16, /*->3939*/ // 3 children in Scope
/*  3923*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3924*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3925*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3927*/      OPC_EmitMergeInputChains1_0,
/*  3928*/      OPC_EmitInteger32, 0, 
/*  3930*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3939*/     /*Scope*/ 16, /*->3956*/
/*  3940*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3941*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3942*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3944*/      OPC_EmitMergeInputChains1_0,
/*  3945*/      OPC_EmitInteger32, 0, 
/*  3947*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3956*/     /*Scope*/ 16, /*->3973*/
/*  3957*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3958*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3959*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3961*/      OPC_EmitMergeInputChains1_0,
/*  3962*/      OPC_EmitInteger32, 0, 
/*  3964*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3973*/     0, /*End of Scope*/
/*  3974*/    0, /*End of Scope*/
/*  3975*/   /*Scope*/ 40, /*->4016*/
/*  3976*/    OPC_CheckChild1TypeI64,
/*  3977*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3978*/    OPC_Scope, 17, /*->3997*/ // 2 children in Scope
/*  3980*/     OPC_CheckChild2TypeI32,
/*  3981*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  3982*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3983*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3985*/     OPC_EmitMergeInputChains1_0,
/*  3986*/     OPC_EmitInteger32, 0, 
/*  3988*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3997*/    /*Scope*/ 17, /*->4015*/
/*  3998*/     OPC_CheckChild2TypeI64,
/*  3999*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  4000*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4001*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4003*/     OPC_EmitMergeInputChains1_0,
/*  4004*/     OPC_EmitInteger32, 0, 
/*  4006*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4015*/    0, /*End of Scope*/
/*  4016*/   0, /*End of Scope*/
/*  4017*/  0, /*End of Scope*/
/*  4018*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4368
/*  4022*/  OPC_Scope, 118, /*->4142*/ // 6 children in Scope
/*  4024*/   OPC_MoveChild0,
/*  4025*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4028*/   OPC_Scope, 55, /*->4085*/ // 2 children in Scope
/*  4030*/    OPC_CheckChild0Integer, 78|128,61|128,1/*24270*/, 
/*  4034*/    OPC_RecordChild1, // #0 = $x
/*  4035*/    OPC_Scope, 11, /*->4048*/ // 4 children in Scope
/*  4037*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4039*/     OPC_MoveParent,
/*  4040*/     OPC_CheckChild1Integer, 2, 
/*  4042*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4048*/    /*Scope*/ 11, /*->4060*/
/*  4049*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4051*/     OPC_MoveParent,
/*  4052*/     OPC_CheckChild1Integer, 2, 
/*  4054*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4060*/    /*Scope*/ 11, /*->4072*/
/*  4061*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4063*/     OPC_MoveParent,
/*  4064*/     OPC_CheckChild1Integer, 2, 
/*  4066*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4072*/    /*Scope*/ 11, /*->4084*/
/*  4073*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4075*/     OPC_MoveParent,
/*  4076*/     OPC_CheckChild1Integer, 2, 
/*  4078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4084*/    0, /*End of Scope*/
/*  4085*/   /*Scope*/ 55, /*->4141*/
/*  4086*/    OPC_CheckChild0Integer, 76|128,61|128,1/*24268*/, 
/*  4090*/    OPC_RecordChild1, // #0 = $x
/*  4091*/    OPC_Scope, 11, /*->4104*/ // 4 children in Scope
/*  4093*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4095*/     OPC_MoveParent,
/*  4096*/     OPC_CheckChild1Integer, 2, 
/*  4098*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4104*/    /*Scope*/ 11, /*->4116*/
/*  4105*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4107*/     OPC_MoveParent,
/*  4108*/     OPC_CheckChild1Integer, 2, 
/*  4110*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4116*/    /*Scope*/ 11, /*->4128*/
/*  4117*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4119*/     OPC_MoveParent,
/*  4120*/     OPC_CheckChild1Integer, 2, 
/*  4122*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4128*/    /*Scope*/ 11, /*->4140*/
/*  4129*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4131*/     OPC_MoveParent,
/*  4132*/     OPC_CheckChild1Integer, 2, 
/*  4134*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4140*/    0, /*End of Scope*/
/*  4141*/   0, /*End of Scope*/
/*  4142*/  /*Scope*/ 29, /*->4172*/
/*  4143*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4146*/   OPC_MoveChild0,
/*  4147*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4150*/   OPC_RecordChild0, // #0 = $vec
/*  4151*/   OPC_CheckChild0Type, MVT::v16i8,
/*  4153*/   OPC_RecordChild1, // #1 = $idx
/*  4154*/   OPC_MoveChild1,
/*  4155*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4158*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/*  4160*/   OPC_CheckTypeI32,
/*  4161*/   OPC_MoveParent,
/*  4162*/   OPC_MoveParent,
/*  4163*/   OPC_CheckTypeI32,
/*  4164*/   OPC_EmitConvertToTarget1,
/*  4165*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4172*/  /*Scope*/ 30, /*->4203*/
/*  4173*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4177*/   OPC_MoveChild0,
/*  4178*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4181*/   OPC_RecordChild0, // #0 = $vec
/*  4182*/   OPC_CheckChild0Type, MVT::v8i16,
/*  4184*/   OPC_RecordChild1, // #1 = $idx
/*  4185*/   OPC_MoveChild1,
/*  4186*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4189*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  4191*/   OPC_CheckTypeI32,
/*  4192*/   OPC_MoveParent,
/*  4193*/   OPC_MoveParent,
/*  4194*/   OPC_CheckTypeI32,
/*  4195*/   OPC_EmitConvertToTarget1,
/*  4196*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4203*/  /*Scope*/ 73, /*->4277*/
/*  4204*/   OPC_RecordChild0, // #0 = $lhs
/*  4205*/   OPC_Scope, 21, /*->4228*/ // 2 children in Scope
/*  4207*/    OPC_RecordChild1, // #1 = $rhs
/*  4208*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->4218
/*  4211*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4218*/    /*SwitchType*/ 7, MVT::i64,// ->4227
/*  4220*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4227*/    0, // EndSwitchType
/*  4228*/   /*Scope*/ 47, /*->4276*/
/*  4229*/    OPC_MoveChild1,
/*  4230*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4233*/    OPC_RecordChild0, // #1 = $rhs
/*  4234*/    OPC_MoveChild1,
/*  4235*/    OPC_CheckImmAllOnesV,
/*  4236*/    OPC_MoveParent,
/*  4237*/    OPC_MoveParent,
/*  4238*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4248
/*  4241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4248*/    /*SwitchType*/ 7, MVT::v8i16,// ->4257
/*  4250*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4257*/    /*SwitchType*/ 7, MVT::v4i32,// ->4266
/*  4259*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4266*/    /*SwitchType*/ 7, MVT::v2i64,// ->4275
/*  4268*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4275*/    0, // EndSwitchType
/*  4276*/   0, /*End of Scope*/
/*  4277*/  /*Scope*/ 48, /*->4326*/
/*  4278*/   OPC_MoveChild0,
/*  4279*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4282*/   OPC_RecordChild0, // #0 = $rhs
/*  4283*/   OPC_MoveChild1,
/*  4284*/   OPC_CheckImmAllOnesV,
/*  4285*/   OPC_MoveParent,
/*  4286*/   OPC_MoveParent,
/*  4287*/   OPC_RecordChild1, // #1 = $lhs
/*  4288*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4298
/*  4291*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4298*/   /*SwitchType*/ 7, MVT::v8i16,// ->4307
/*  4300*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4307*/   /*SwitchType*/ 7, MVT::v4i32,// ->4316
/*  4309*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4316*/   /*SwitchType*/ 7, MVT::v2i64,// ->4325
/*  4318*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4325*/   0, // EndSwitchType
/*  4326*/  /*Scope*/ 40, /*->4367*/
/*  4327*/   OPC_RecordChild0, // #0 = $lhs
/*  4328*/   OPC_RecordChild1, // #1 = $rhs
/*  4329*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4339
/*  4332*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4339*/   /*SwitchType*/ 7, MVT::v8i16,// ->4348
/*  4341*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4348*/   /*SwitchType*/ 7, MVT::v4i32,// ->4357
/*  4350*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4357*/   /*SwitchType*/ 7, MVT::v2i64,// ->4366
/*  4359*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4366*/   0, // EndSwitchType
/*  4367*/  0, /*End of Scope*/
/*  4368*/ /*SwitchOpcode*/ 124|128,11/*1532*/, TARGET_VAL(ISD::SETCC),// ->5904
/*  4372*/  OPC_Scope, 126|128,1/*254*/, /*->4629*/ // 2 children in Scope
/*  4375*/   OPC_MoveChild0,
/*  4376*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4379*/   OPC_Scope, 123, /*->4504*/ // 2 children in Scope
/*  4381*/    OPC_CheckChild0Integer, 78|128,61|128,1/*24270*/, 
/*  4385*/    OPC_RecordChild1, // #0 = $x
/*  4386*/    OPC_Scope, 28, /*->4416*/ // 4 children in Scope
/*  4388*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4390*/     OPC_MoveParent,
/*  4391*/     OPC_CheckTypeI32,
/*  4392*/     OPC_Scope, 10, /*->4404*/ // 2 children in Scope
/*  4394*/      OPC_CheckChild1Integer, 0, 
/*  4396*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4398*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4404*/     /*Scope*/ 10, /*->4415*/
/*  4405*/      OPC_CheckChild1Integer, 2, 
/*  4407*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4409*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4415*/     0, /*End of Scope*/
/*  4416*/    /*Scope*/ 28, /*->4445*/
/*  4417*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4419*/     OPC_MoveParent,
/*  4420*/     OPC_CheckTypeI32,
/*  4421*/     OPC_Scope, 10, /*->4433*/ // 2 children in Scope
/*  4423*/      OPC_CheckChild1Integer, 0, 
/*  4425*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4427*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4433*/     /*Scope*/ 10, /*->4444*/
/*  4434*/      OPC_CheckChild1Integer, 2, 
/*  4436*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4438*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4444*/     0, /*End of Scope*/
/*  4445*/    /*Scope*/ 28, /*->4474*/
/*  4446*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4448*/     OPC_MoveParent,
/*  4449*/     OPC_CheckTypeI32,
/*  4450*/     OPC_Scope, 10, /*->4462*/ // 2 children in Scope
/*  4452*/      OPC_CheckChild1Integer, 0, 
/*  4454*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4456*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4462*/     /*Scope*/ 10, /*->4473*/
/*  4463*/      OPC_CheckChild1Integer, 2, 
/*  4465*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4467*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4473*/     0, /*End of Scope*/
/*  4474*/    /*Scope*/ 28, /*->4503*/
/*  4475*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4477*/     OPC_MoveParent,
/*  4478*/     OPC_CheckTypeI32,
/*  4479*/     OPC_Scope, 10, /*->4491*/ // 2 children in Scope
/*  4481*/      OPC_CheckChild1Integer, 0, 
/*  4483*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4485*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4491*/     /*Scope*/ 10, /*->4502*/
/*  4492*/      OPC_CheckChild1Integer, 2, 
/*  4494*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4496*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4502*/     0, /*End of Scope*/
/*  4503*/    0, /*End of Scope*/
/*  4504*/   /*Scope*/ 123, /*->4628*/
/*  4505*/    OPC_CheckChild0Integer, 76|128,61|128,1/*24268*/, 
/*  4509*/    OPC_RecordChild1, // #0 = $x
/*  4510*/    OPC_Scope, 28, /*->4540*/ // 4 children in Scope
/*  4512*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4514*/     OPC_MoveParent,
/*  4515*/     OPC_CheckTypeI32,
/*  4516*/     OPC_Scope, 10, /*->4528*/ // 2 children in Scope
/*  4518*/      OPC_CheckChild1Integer, 0, 
/*  4520*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4522*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4528*/     /*Scope*/ 10, /*->4539*/
/*  4529*/      OPC_CheckChild1Integer, 2, 
/*  4531*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4533*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4539*/     0, /*End of Scope*/
/*  4540*/    /*Scope*/ 28, /*->4569*/
/*  4541*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4543*/     OPC_MoveParent,
/*  4544*/     OPC_CheckTypeI32,
/*  4545*/     OPC_Scope, 10, /*->4557*/ // 2 children in Scope
/*  4547*/      OPC_CheckChild1Integer, 0, 
/*  4549*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4551*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4557*/     /*Scope*/ 10, /*->4568*/
/*  4558*/      OPC_CheckChild1Integer, 2, 
/*  4560*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4562*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4568*/     0, /*End of Scope*/
/*  4569*/    /*Scope*/ 28, /*->4598*/
/*  4570*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4572*/     OPC_MoveParent,
/*  4573*/     OPC_CheckTypeI32,
/*  4574*/     OPC_Scope, 10, /*->4586*/ // 2 children in Scope
/*  4576*/      OPC_CheckChild1Integer, 0, 
/*  4578*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4580*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4586*/     /*Scope*/ 10, /*->4597*/
/*  4587*/      OPC_CheckChild1Integer, 2, 
/*  4589*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4591*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4597*/     0, /*End of Scope*/
/*  4598*/    /*Scope*/ 28, /*->4627*/
/*  4599*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4601*/     OPC_MoveParent,
/*  4602*/     OPC_CheckTypeI32,
/*  4603*/     OPC_Scope, 10, /*->4615*/ // 2 children in Scope
/*  4605*/      OPC_CheckChild1Integer, 0, 
/*  4607*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4609*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4615*/     /*Scope*/ 10, /*->4626*/
/*  4616*/      OPC_CheckChild1Integer, 2, 
/*  4618*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4620*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4626*/     0, /*End of Scope*/
/*  4627*/    0, /*End of Scope*/
/*  4628*/   0, /*End of Scope*/
/*  4629*/  /*Scope*/ 120|128,9/*1272*/, /*->5903*/
/*  4631*/   OPC_RecordChild0, // #0 = $src
/*  4632*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, MVT::i32,// ->5128
/*  4636*/    OPC_Scope, 118, /*->4756*/ // 4 children in Scope
/*  4638*/     OPC_CheckChild0TypeI32,
/*  4639*/     OPC_Scope, 10, /*->4651*/ // 2 children in Scope
/*  4641*/      OPC_CheckChild1Integer, 0, 
/*  4643*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4645*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4651*/     /*Scope*/ 103, /*->4755*/
/*  4652*/      OPC_RecordChild1, // #1 = $rhs
/*  4653*/      OPC_Scope, 9, /*->4664*/ // 10 children in Scope
/*  4655*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4657*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4664*/      /*Scope*/ 9, /*->4674*/
/*  4665*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4667*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4674*/      /*Scope*/ 9, /*->4684*/
/*  4675*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4677*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4684*/      /*Scope*/ 9, /*->4694*/
/*  4685*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4687*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4694*/      /*Scope*/ 9, /*->4704*/
/*  4695*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4697*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4704*/      /*Scope*/ 9, /*->4714*/
/*  4705*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4707*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4714*/      /*Scope*/ 9, /*->4724*/
/*  4715*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4717*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4724*/      /*Scope*/ 9, /*->4734*/
/*  4725*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4727*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4734*/      /*Scope*/ 9, /*->4744*/
/*  4735*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4737*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4744*/      /*Scope*/ 9, /*->4754*/
/*  4745*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4747*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4754*/      0, /*End of Scope*/
/*  4755*/     0, /*End of Scope*/
/*  4756*/    /*Scope*/ 118, /*->4875*/
/*  4757*/     OPC_CheckChild0TypeI64,
/*  4758*/     OPC_Scope, 10, /*->4770*/ // 2 children in Scope
/*  4760*/      OPC_CheckChild1Integer, 0, 
/*  4762*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4770*/     /*Scope*/ 103, /*->4874*/
/*  4771*/      OPC_RecordChild1, // #1 = $rhs
/*  4772*/      OPC_Scope, 9, /*->4783*/ // 10 children in Scope
/*  4774*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4776*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4783*/      /*Scope*/ 9, /*->4793*/
/*  4784*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4786*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4793*/      /*Scope*/ 9, /*->4803*/
/*  4794*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4796*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4803*/      /*Scope*/ 9, /*->4813*/
/*  4804*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4806*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4813*/      /*Scope*/ 9, /*->4823*/
/*  4814*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4816*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4823*/      /*Scope*/ 9, /*->4833*/
/*  4824*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4826*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4833*/      /*Scope*/ 9, /*->4843*/
/*  4834*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4836*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4843*/      /*Scope*/ 9, /*->4853*/
/*  4844*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4846*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4853*/      /*Scope*/ 9, /*->4863*/
/*  4854*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4856*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4863*/      /*Scope*/ 9, /*->4873*/
/*  4864*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4866*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4873*/      0, /*End of Scope*/
/*  4874*/     0, /*End of Scope*/
/*  4875*/    /*Scope*/ 125, /*->5001*/
/*  4876*/     OPC_CheckChild0Type, MVT::f32,
/*  4878*/     OPC_RecordChild1, // #1 = $rhs
/*  4879*/     OPC_Scope, 9, /*->4890*/ // 12 children in Scope
/*  4881*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4883*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4890*/     /*Scope*/ 9, /*->4900*/
/*  4891*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4893*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4900*/     /*Scope*/ 9, /*->4910*/
/*  4901*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4903*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4910*/     /*Scope*/ 9, /*->4920*/
/*  4911*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4913*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4920*/     /*Scope*/ 9, /*->4930*/
/*  4921*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4923*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4930*/     /*Scope*/ 9, /*->4940*/
/*  4931*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4933*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4940*/     /*Scope*/ 9, /*->4950*/
/*  4941*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4943*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4950*/     /*Scope*/ 9, /*->4960*/
/*  4951*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4953*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4960*/     /*Scope*/ 9, /*->4970*/
/*  4961*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  4963*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4970*/     /*Scope*/ 9, /*->4980*/
/*  4971*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  4973*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4980*/     /*Scope*/ 9, /*->4990*/
/*  4981*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  4983*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4990*/     /*Scope*/ 9, /*->5000*/
/*  4991*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  4993*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5000*/     0, /*End of Scope*/
/*  5001*/    /*Scope*/ 125, /*->5127*/
/*  5002*/     OPC_CheckChild0Type, MVT::f64,
/*  5004*/     OPC_RecordChild1, // #1 = $rhs
/*  5005*/     OPC_Scope, 9, /*->5016*/ // 12 children in Scope
/*  5007*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5009*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5016*/     /*Scope*/ 9, /*->5026*/
/*  5017*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5019*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5026*/     /*Scope*/ 9, /*->5036*/
/*  5027*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5029*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5036*/     /*Scope*/ 9, /*->5046*/
/*  5037*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5039*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5046*/     /*Scope*/ 9, /*->5056*/
/*  5047*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5049*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5056*/     /*Scope*/ 9, /*->5066*/
/*  5057*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5059*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5066*/     /*Scope*/ 9, /*->5076*/
/*  5067*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5069*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5076*/     /*Scope*/ 9, /*->5086*/
/*  5077*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5079*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5086*/     /*Scope*/ 9, /*->5096*/
/*  5087*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5089*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5096*/     /*Scope*/ 9, /*->5106*/
/*  5097*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5099*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5106*/     /*Scope*/ 9, /*->5116*/
/*  5107*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5109*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5116*/     /*Scope*/ 9, /*->5126*/
/*  5117*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5119*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5126*/     0, /*End of Scope*/
/*  5127*/    0, /*End of Scope*/
/*  5128*/   /*SwitchType*/ 115, MVT::v16i8,// ->5245
/*  5130*/    OPC_CheckChild0Type, MVT::v16i8,
/*  5132*/    OPC_RecordChild1, // #1 = $rhs
/*  5133*/    OPC_Scope, 10, /*->5145*/ // 10 children in Scope
/*  5135*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5137*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5138*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5145*/    /*Scope*/ 10, /*->5156*/
/*  5146*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5148*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5149*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5156*/    /*Scope*/ 10, /*->5167*/
/*  5157*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5159*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5160*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5167*/    /*Scope*/ 10, /*->5178*/
/*  5168*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5170*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5171*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5178*/    /*Scope*/ 10, /*->5189*/
/*  5179*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5181*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5182*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5189*/    /*Scope*/ 10, /*->5200*/
/*  5190*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5192*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5193*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5200*/    /*Scope*/ 10, /*->5211*/
/*  5201*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5203*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5204*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5211*/    /*Scope*/ 10, /*->5222*/
/*  5212*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5214*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5215*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5222*/    /*Scope*/ 10, /*->5233*/
/*  5223*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5225*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5226*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5233*/    /*Scope*/ 10, /*->5244*/
/*  5234*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5236*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5237*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5244*/    0, /*End of Scope*/
/*  5245*/   /*SwitchType*/ 62|128,1/*190*/, MVT::v8i16,// ->5438
/*  5248*/    OPC_Scope, 115, /*->5365*/ // 2 children in Scope
/*  5250*/     OPC_CheckChild0Type, MVT::v8i16,
/*  5252*/     OPC_RecordChild1, // #1 = $rhs
/*  5253*/     OPC_Scope, 10, /*->5265*/ // 10 children in Scope
/*  5255*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5257*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5258*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5265*/     /*Scope*/ 10, /*->5276*/
/*  5266*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5268*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5269*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5276*/     /*Scope*/ 10, /*->5287*/
/*  5277*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5279*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5280*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5287*/     /*Scope*/ 10, /*->5298*/
/*  5288*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5290*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5291*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5298*/     /*Scope*/ 10, /*->5309*/
/*  5299*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5301*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5302*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5309*/     /*Scope*/ 10, /*->5320*/
/*  5310*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5312*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5313*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5320*/     /*Scope*/ 10, /*->5331*/
/*  5321*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5323*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5324*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5331*/     /*Scope*/ 10, /*->5342*/
/*  5332*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5334*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5335*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5342*/     /*Scope*/ 10, /*->5353*/
/*  5343*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5345*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5346*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5353*/     /*Scope*/ 10, /*->5364*/
/*  5354*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5356*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5357*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5364*/     0, /*End of Scope*/
/*  5365*/    /*Scope*/ 71, /*->5437*/
/*  5366*/     OPC_CheckChild0Type, MVT::v8f16,
/*  5368*/     OPC_RecordChild1, // #1 = $rhs
/*  5369*/     OPC_Scope, 10, /*->5381*/ // 6 children in Scope
/*  5371*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5373*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5374*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5381*/     /*Scope*/ 10, /*->5392*/
/*  5382*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5384*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5385*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5392*/     /*Scope*/ 10, /*->5403*/
/*  5393*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5395*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5396*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5403*/     /*Scope*/ 10, /*->5414*/
/*  5404*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5406*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5407*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5414*/     /*Scope*/ 10, /*->5425*/
/*  5415*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5417*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5418*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5425*/     /*Scope*/ 10, /*->5436*/
/*  5426*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5428*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/*  5429*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5436*/     0, /*End of Scope*/
/*  5437*/    0, /*End of Scope*/
/*  5438*/   /*SwitchType*/ 123|128,1/*251*/, MVT::v4i32,// ->5692
/*  5441*/    OPC_Scope, 115, /*->5558*/ // 2 children in Scope
/*  5443*/     OPC_CheckChild0Type, MVT::v4i32,
/*  5445*/     OPC_RecordChild1, // #1 = $rhs
/*  5446*/     OPC_Scope, 10, /*->5458*/ // 10 children in Scope
/*  5448*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5450*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5451*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5458*/     /*Scope*/ 10, /*->5469*/
/*  5459*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5461*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5462*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5469*/     /*Scope*/ 10, /*->5480*/
/*  5470*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5472*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5473*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5480*/     /*Scope*/ 10, /*->5491*/
/*  5481*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5483*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5484*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5491*/     /*Scope*/ 10, /*->5502*/
/*  5492*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5494*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5495*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5502*/     /*Scope*/ 10, /*->5513*/
/*  5503*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5505*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5506*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5513*/     /*Scope*/ 10, /*->5524*/
/*  5514*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5516*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5517*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5524*/     /*Scope*/ 10, /*->5535*/
/*  5525*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5527*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5528*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5535*/     /*Scope*/ 10, /*->5546*/
/*  5536*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5538*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5539*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5546*/     /*Scope*/ 10, /*->5557*/
/*  5547*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5549*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5550*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5557*/     0, /*End of Scope*/
/*  5558*/    /*Scope*/ 3|128,1/*131*/, /*->5691*/
/*  5560*/     OPC_CheckChild0Type, MVT::v4f32,
/*  5562*/     OPC_RecordChild1, // #1 = $rhs
/*  5563*/     OPC_Scope, 10, /*->5575*/ // 12 children in Scope
/*  5565*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5567*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5568*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5575*/     /*Scope*/ 10, /*->5586*/
/*  5576*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5578*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5579*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5586*/     /*Scope*/ 10, /*->5597*/
/*  5587*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5589*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5590*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5597*/     /*Scope*/ 10, /*->5608*/
/*  5598*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5600*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5601*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5608*/     /*Scope*/ 10, /*->5619*/
/*  5609*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5611*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5612*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5619*/     /*Scope*/ 10, /*->5630*/
/*  5620*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5622*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5623*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5630*/     /*Scope*/ 9, /*->5640*/
/*  5631*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5633*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5640*/     /*Scope*/ 9, /*->5650*/
/*  5641*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5643*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5650*/     /*Scope*/ 9, /*->5660*/
/*  5651*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5653*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5660*/     /*Scope*/ 9, /*->5670*/
/*  5661*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5663*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5670*/     /*Scope*/ 9, /*->5680*/
/*  5671*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5673*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5680*/     /*Scope*/ 9, /*->5690*/
/*  5681*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5683*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5690*/     0, /*End of Scope*/
/*  5691*/    0, /*End of Scope*/
/*  5692*/   /*SwitchType*/ 79|128,1/*207*/, MVT::v2i64,// ->5902
/*  5695*/    OPC_Scope, 71, /*->5768*/ // 2 children in Scope
/*  5697*/     OPC_CheckChild0Type, MVT::v2i64,
/*  5699*/     OPC_RecordChild1, // #1 = $rhs
/*  5700*/     OPC_Scope, 10, /*->5712*/ // 6 children in Scope
/*  5702*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5704*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5705*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5712*/     /*Scope*/ 10, /*->5723*/
/*  5713*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5715*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5716*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5723*/     /*Scope*/ 10, /*->5734*/
/*  5724*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5726*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5727*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5734*/     /*Scope*/ 10, /*->5745*/
/*  5735*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5737*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5738*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5745*/     /*Scope*/ 10, /*->5756*/
/*  5746*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5748*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5749*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5756*/     /*Scope*/ 10, /*->5767*/
/*  5757*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5759*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5760*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5767*/     0, /*End of Scope*/
/*  5768*/    /*Scope*/ 3|128,1/*131*/, /*->5901*/
/*  5770*/     OPC_CheckChild0Type, MVT::v2f64,
/*  5772*/     OPC_RecordChild1, // #1 = $rhs
/*  5773*/     OPC_Scope, 10, /*->5785*/ // 12 children in Scope
/*  5775*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5777*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5778*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5785*/     /*Scope*/ 10, /*->5796*/
/*  5786*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5788*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5789*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5796*/     /*Scope*/ 10, /*->5807*/
/*  5797*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5799*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5800*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5807*/     /*Scope*/ 10, /*->5818*/
/*  5808*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5810*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5811*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5818*/     /*Scope*/ 10, /*->5829*/
/*  5819*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5821*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5822*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5829*/     /*Scope*/ 10, /*->5840*/
/*  5830*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5832*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5833*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5840*/     /*Scope*/ 9, /*->5850*/
/*  5841*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5843*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5850*/     /*Scope*/ 9, /*->5860*/
/*  5851*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5853*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5860*/     /*Scope*/ 9, /*->5870*/
/*  5861*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5863*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5870*/     /*Scope*/ 9, /*->5880*/
/*  5871*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5873*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5880*/     /*Scope*/ 9, /*->5890*/
/*  5881*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5883*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5890*/     /*Scope*/ 9, /*->5900*/
/*  5891*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5893*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5900*/     0, /*End of Scope*/
/*  5901*/    0, /*End of Scope*/
/*  5902*/   0, // EndSwitchType
/*  5903*/  0, /*End of Scope*/
/*  5904*/ /*SwitchOpcode*/ 17|128,11/*1425*/, TARGET_VAL(ISD::LOAD),// ->7333
/*  5908*/  OPC_RecordMemRef,
/*  5909*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5910*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5911*/  OPC_Scope, 68|128,5/*708*/, /*->6622*/ // 2 children in Scope
/*  5914*/   OPC_CheckChild1TypeI32,
/*  5915*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  5917*/   OPC_Scope, 37, /*->5956*/ // 16 children in Scope
/*  5919*/    OPC_CheckPredicate7,  // Predicate_load
/*  5920*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->5938
/*  5923*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5924*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5926*/     OPC_EmitMergeInputChains1_0,
/*  5927*/     OPC_EmitInteger32, 0, 
/*  5929*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5938*/    /*SwitchType*/ 15, MVT::i64,// ->5955
/*  5940*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5941*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5943*/     OPC_EmitMergeInputChains1_0,
/*  5944*/     OPC_EmitInteger32, 0, 
/*  5946*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5955*/    0, // EndSwitchType
/*  5956*/   /*Scope*/ 97, /*->6054*/
/*  5957*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  5959*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->5998
/*  5962*/     OPC_Scope, 16, /*->5980*/ // 2 children in Scope
/*  5964*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5965*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5966*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5968*/      OPC_EmitMergeInputChains1_0,
/*  5969*/      OPC_EmitInteger32, 0, 
/*  5971*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5980*/     /*Scope*/ 16, /*->5997*/
/*  5981*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  5982*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5985*/      OPC_EmitMergeInputChains1_0,
/*  5986*/      OPC_EmitInteger32, 0, 
/*  5988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5997*/     0, /*End of Scope*/
/*  5998*/    /*SwitchType*/ 53, MVT::i64,// ->6053
/*  6000*/     OPC_Scope, 16, /*->6018*/ // 3 children in Scope
/*  6002*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6003*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6004*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6006*/      OPC_EmitMergeInputChains1_0,
/*  6007*/      OPC_EmitInteger32, 0, 
/*  6009*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6018*/     /*Scope*/ 16, /*->6035*/
/*  6019*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6020*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6021*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6023*/      OPC_EmitMergeInputChains1_0,
/*  6024*/      OPC_EmitInteger32, 0, 
/*  6026*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6035*/     /*Scope*/ 16, /*->6052*/
/*  6036*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6037*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6038*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6040*/      OPC_EmitMergeInputChains1_0,
/*  6041*/      OPC_EmitInteger32, 0, 
/*  6043*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6052*/     0, /*End of Scope*/
/*  6053*/    0, // EndSwitchType
/*  6054*/   /*Scope*/ 97, /*->6152*/
/*  6055*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6057*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6096
/*  6060*/     OPC_Scope, 16, /*->6078*/ // 2 children in Scope
/*  6062*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6063*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6064*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6066*/      OPC_EmitMergeInputChains1_0,
/*  6067*/      OPC_EmitInteger32, 0, 
/*  6069*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6078*/     /*Scope*/ 16, /*->6095*/
/*  6079*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6080*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6083*/      OPC_EmitMergeInputChains1_0,
/*  6084*/      OPC_EmitInteger32, 0, 
/*  6086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6095*/     0, /*End of Scope*/
/*  6096*/    /*SwitchType*/ 53, MVT::i64,// ->6151
/*  6098*/     OPC_Scope, 16, /*->6116*/ // 3 children in Scope
/*  6100*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6101*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6102*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6104*/      OPC_EmitMergeInputChains1_0,
/*  6105*/      OPC_EmitInteger32, 0, 
/*  6107*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6116*/     /*Scope*/ 16, /*->6133*/
/*  6117*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6118*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6119*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6121*/      OPC_EmitMergeInputChains1_0,
/*  6122*/      OPC_EmitInteger32, 0, 
/*  6124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6133*/     /*Scope*/ 16, /*->6150*/
/*  6134*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6135*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6136*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6138*/      OPC_EmitMergeInputChains1_0,
/*  6139*/      OPC_EmitInteger32, 0, 
/*  6141*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6150*/     0, /*End of Scope*/
/*  6151*/    0, // EndSwitchType
/*  6152*/   /*Scope*/ 97, /*->6250*/
/*  6153*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6155*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6194
/*  6158*/     OPC_Scope, 16, /*->6176*/ // 2 children in Scope
/*  6160*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6161*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6162*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6164*/      OPC_EmitMergeInputChains1_0,
/*  6165*/      OPC_EmitInteger32, 0, 
/*  6167*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6176*/     /*Scope*/ 16, /*->6193*/
/*  6177*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6178*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6179*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6181*/      OPC_EmitMergeInputChains1_0,
/*  6182*/      OPC_EmitInteger32, 0, 
/*  6184*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6193*/     0, /*End of Scope*/
/*  6194*/    /*SwitchType*/ 53, MVT::i64,// ->6249
/*  6196*/     OPC_Scope, 16, /*->6214*/ // 3 children in Scope
/*  6198*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6199*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6200*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6202*/      OPC_EmitMergeInputChains1_0,
/*  6203*/      OPC_EmitInteger32, 0, 
/*  6205*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6214*/     /*Scope*/ 16, /*->6231*/
/*  6215*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6216*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6217*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6219*/      OPC_EmitMergeInputChains1_0,
/*  6220*/      OPC_EmitInteger32, 0, 
/*  6222*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6231*/     /*Scope*/ 16, /*->6248*/
/*  6232*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6233*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6234*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6236*/      OPC_EmitMergeInputChains1_0,
/*  6237*/      OPC_EmitInteger32, 0, 
/*  6239*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6248*/     0, /*End of Scope*/
/*  6249*/    0, // EndSwitchType
/*  6250*/   /*Scope*/ 105, /*->6356*/
/*  6251*/    OPC_CheckPredicate7,  // Predicate_load
/*  6252*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->6270
/*  6255*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6256*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6258*/     OPC_EmitMergeInputChains1_0,
/*  6259*/     OPC_EmitInteger32, 0, 
/*  6261*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6270*/    /*SwitchType*/ 15, MVT::f64,// ->6287
/*  6272*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6273*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6275*/     OPC_EmitMergeInputChains1_0,
/*  6276*/     OPC_EmitInteger32, 0, 
/*  6278*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6287*/    /*SwitchType*/ 15, MVT::v16i8,// ->6304
/*  6289*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6290*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6292*/     OPC_EmitMergeInputChains1_0,
/*  6293*/     OPC_EmitInteger32, 0, 
/*  6295*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6304*/    /*SwitchType*/ 15, MVT::v8i16,// ->6321
/*  6306*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6307*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6309*/     OPC_EmitMergeInputChains1_0,
/*  6310*/     OPC_EmitInteger32, 0, 
/*  6312*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6321*/    /*SwitchType*/ 15, MVT::v4i32,// ->6338
/*  6323*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6324*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6326*/     OPC_EmitMergeInputChains1_0,
/*  6327*/     OPC_EmitInteger32, 0, 
/*  6329*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6338*/    /*SwitchType*/ 15, MVT::v2i64,// ->6355
/*  6340*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6341*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6343*/     OPC_EmitMergeInputChains1_0,
/*  6344*/     OPC_EmitInteger32, 0, 
/*  6346*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6355*/    0, // EndSwitchType
/*  6356*/   /*Scope*/ 21, /*->6378*/
/*  6357*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6359*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6361*/    OPC_CheckType, MVT::v8i16,
/*  6363*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6364*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6366*/    OPC_EmitMergeInputChains1_0,
/*  6367*/    OPC_EmitInteger32, 0, 
/*  6369*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6378*/   /*Scope*/ 21, /*->6400*/
/*  6379*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6381*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6383*/    OPC_CheckType, MVT::v8i16,
/*  6385*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6386*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6388*/    OPC_EmitMergeInputChains1_0,
/*  6389*/    OPC_EmitInteger32, 0, 
/*  6391*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6400*/   /*Scope*/ 21, /*->6422*/
/*  6401*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6403*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6405*/    OPC_CheckType, MVT::v8i16,
/*  6407*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6408*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6410*/    OPC_EmitMergeInputChains1_0,
/*  6411*/    OPC_EmitInteger32, 0, 
/*  6413*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6422*/   /*Scope*/ 21, /*->6444*/
/*  6423*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6425*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6427*/    OPC_CheckType, MVT::v4i32,
/*  6429*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6430*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6432*/    OPC_EmitMergeInputChains1_0,
/*  6433*/    OPC_EmitInteger32, 0, 
/*  6435*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6444*/   /*Scope*/ 21, /*->6466*/
/*  6445*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6447*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6449*/    OPC_CheckType, MVT::v4i32,
/*  6451*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6452*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6454*/    OPC_EmitMergeInputChains1_0,
/*  6455*/    OPC_EmitInteger32, 0, 
/*  6457*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6466*/   /*Scope*/ 21, /*->6488*/
/*  6467*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6469*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6471*/    OPC_CheckType, MVT::v4i32,
/*  6473*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6474*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6476*/    OPC_EmitMergeInputChains1_0,
/*  6477*/    OPC_EmitInteger32, 0, 
/*  6479*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6488*/   /*Scope*/ 21, /*->6510*/
/*  6489*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6491*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6493*/    OPC_CheckType, MVT::v2i64,
/*  6495*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6496*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6498*/    OPC_EmitMergeInputChains1_0,
/*  6499*/    OPC_EmitInteger32, 0, 
/*  6501*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6510*/   /*Scope*/ 21, /*->6532*/
/*  6511*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6513*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6515*/    OPC_CheckType, MVT::v2i64,
/*  6517*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6518*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6520*/    OPC_EmitMergeInputChains1_0,
/*  6521*/    OPC_EmitInteger32, 0, 
/*  6523*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6532*/   /*Scope*/ 21, /*->6554*/
/*  6533*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6535*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6537*/    OPC_CheckType, MVT::v2i64,
/*  6539*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6540*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6542*/    OPC_EmitMergeInputChains1_0,
/*  6543*/    OPC_EmitInteger32, 0, 
/*  6545*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6554*/   /*Scope*/ 37, /*->6592*/
/*  6555*/    OPC_CheckPredicate7,  // Predicate_load
/*  6556*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->6574
/*  6559*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6560*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6562*/     OPC_EmitMergeInputChains1_0,
/*  6563*/     OPC_EmitInteger32, 0, 
/*  6565*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6574*/    /*SwitchType*/ 15, MVT::v2f64,// ->6591
/*  6576*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6577*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6579*/     OPC_EmitMergeInputChains1_0,
/*  6580*/     OPC_EmitInteger32, 0, 
/*  6582*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6591*/    0, // EndSwitchType
/*  6592*/   /*Scope*/ 28, /*->6621*/
/*  6593*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6595*/    OPC_CheckType, MVT::v2f64,
/*  6597*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6598*/    OPC_EmitMergeInputChains1_0,
/*  6599*/    OPC_EmitInteger32, 0, 
/*  6601*/    OPC_EmitInteger32, 0, 
/*  6603*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6612*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  6618*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6621*/   0, /*End of Scope*/
/*  6622*/  /*Scope*/ 68|128,5/*708*/, /*->7332*/
/*  6624*/   OPC_CheckChild1TypeI64,
/*  6625*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  6627*/   OPC_Scope, 37, /*->6666*/ // 16 children in Scope
/*  6629*/    OPC_CheckPredicate7,  // Predicate_load
/*  6630*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->6648
/*  6633*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6634*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6636*/     OPC_EmitMergeInputChains1_0,
/*  6637*/     OPC_EmitInteger32, 0, 
/*  6639*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6648*/    /*SwitchType*/ 15, MVT::i64,// ->6665
/*  6650*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6651*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6653*/     OPC_EmitMergeInputChains1_0,
/*  6654*/     OPC_EmitInteger32, 0, 
/*  6656*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6665*/    0, // EndSwitchType
/*  6666*/   /*Scope*/ 97, /*->6764*/
/*  6667*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  6669*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6708
/*  6672*/     OPC_Scope, 16, /*->6690*/ // 2 children in Scope
/*  6674*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6675*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6676*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6678*/      OPC_EmitMergeInputChains1_0,
/*  6679*/      OPC_EmitInteger32, 0, 
/*  6681*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6690*/     /*Scope*/ 16, /*->6707*/
/*  6691*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6692*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6693*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6695*/      OPC_EmitMergeInputChains1_0,
/*  6696*/      OPC_EmitInteger32, 0, 
/*  6698*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6707*/     0, /*End of Scope*/
/*  6708*/    /*SwitchType*/ 53, MVT::i64,// ->6763
/*  6710*/     OPC_Scope, 16, /*->6728*/ // 3 children in Scope
/*  6712*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6713*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6714*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6716*/      OPC_EmitMergeInputChains1_0,
/*  6717*/      OPC_EmitInteger32, 0, 
/*  6719*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6728*/     /*Scope*/ 16, /*->6745*/
/*  6729*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6730*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6731*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6733*/      OPC_EmitMergeInputChains1_0,
/*  6734*/      OPC_EmitInteger32, 0, 
/*  6736*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6745*/     /*Scope*/ 16, /*->6762*/
/*  6746*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6747*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6748*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6750*/      OPC_EmitMergeInputChains1_0,
/*  6751*/      OPC_EmitInteger32, 0, 
/*  6753*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6762*/     0, /*End of Scope*/
/*  6763*/    0, // EndSwitchType
/*  6764*/   /*Scope*/ 97, /*->6862*/
/*  6765*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  6767*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6806
/*  6770*/     OPC_Scope, 16, /*->6788*/ // 2 children in Scope
/*  6772*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6773*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6774*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6776*/      OPC_EmitMergeInputChains1_0,
/*  6777*/      OPC_EmitInteger32, 0, 
/*  6779*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6788*/     /*Scope*/ 16, /*->6805*/
/*  6789*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6790*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6791*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6793*/      OPC_EmitMergeInputChains1_0,
/*  6794*/      OPC_EmitInteger32, 0, 
/*  6796*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6805*/     0, /*End of Scope*/
/*  6806*/    /*SwitchType*/ 53, MVT::i64,// ->6861
/*  6808*/     OPC_Scope, 16, /*->6826*/ // 3 children in Scope
/*  6810*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6811*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6812*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6814*/      OPC_EmitMergeInputChains1_0,
/*  6815*/      OPC_EmitInteger32, 0, 
/*  6817*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6826*/     /*Scope*/ 16, /*->6843*/
/*  6827*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6828*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6829*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6831*/      OPC_EmitMergeInputChains1_0,
/*  6832*/      OPC_EmitInteger32, 0, 
/*  6834*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6843*/     /*Scope*/ 16, /*->6860*/
/*  6844*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6845*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6846*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6848*/      OPC_EmitMergeInputChains1_0,
/*  6849*/      OPC_EmitInteger32, 0, 
/*  6851*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6860*/     0, /*End of Scope*/
/*  6861*/    0, // EndSwitchType
/*  6862*/   /*Scope*/ 97, /*->6960*/
/*  6863*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6865*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6904
/*  6868*/     OPC_Scope, 16, /*->6886*/ // 2 children in Scope
/*  6870*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6871*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6872*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6874*/      OPC_EmitMergeInputChains1_0,
/*  6875*/      OPC_EmitInteger32, 0, 
/*  6877*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6886*/     /*Scope*/ 16, /*->6903*/
/*  6887*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6888*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6889*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6891*/      OPC_EmitMergeInputChains1_0,
/*  6892*/      OPC_EmitInteger32, 0, 
/*  6894*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6903*/     0, /*End of Scope*/
/*  6904*/    /*SwitchType*/ 53, MVT::i64,// ->6959
/*  6906*/     OPC_Scope, 16, /*->6924*/ // 3 children in Scope
/*  6908*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6909*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6910*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6912*/      OPC_EmitMergeInputChains1_0,
/*  6913*/      OPC_EmitInteger32, 0, 
/*  6915*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6924*/     /*Scope*/ 16, /*->6941*/
/*  6925*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6926*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6927*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6929*/      OPC_EmitMergeInputChains1_0,
/*  6930*/      OPC_EmitInteger32, 0, 
/*  6932*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6941*/     /*Scope*/ 16, /*->6958*/
/*  6942*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6943*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6946*/      OPC_EmitMergeInputChains1_0,
/*  6947*/      OPC_EmitInteger32, 0, 
/*  6949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6958*/     0, /*End of Scope*/
/*  6959*/    0, // EndSwitchType
/*  6960*/   /*Scope*/ 105, /*->7066*/
/*  6961*/    OPC_CheckPredicate7,  // Predicate_load
/*  6962*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->6980
/*  6965*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6966*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6968*/     OPC_EmitMergeInputChains1_0,
/*  6969*/     OPC_EmitInteger32, 0, 
/*  6971*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6980*/    /*SwitchType*/ 15, MVT::f64,// ->6997
/*  6982*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6983*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6985*/     OPC_EmitMergeInputChains1_0,
/*  6986*/     OPC_EmitInteger32, 0, 
/*  6988*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6997*/    /*SwitchType*/ 15, MVT::v16i8,// ->7014
/*  6999*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7000*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7002*/     OPC_EmitMergeInputChains1_0,
/*  7003*/     OPC_EmitInteger32, 0, 
/*  7005*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7014*/    /*SwitchType*/ 15, MVT::v8i16,// ->7031
/*  7016*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7017*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7019*/     OPC_EmitMergeInputChains1_0,
/*  7020*/     OPC_EmitInteger32, 0, 
/*  7022*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7031*/    /*SwitchType*/ 15, MVT::v4i32,// ->7048
/*  7033*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7034*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7036*/     OPC_EmitMergeInputChains1_0,
/*  7037*/     OPC_EmitInteger32, 0, 
/*  7039*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7048*/    /*SwitchType*/ 15, MVT::v2i64,// ->7065
/*  7050*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7051*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7053*/     OPC_EmitMergeInputChains1_0,
/*  7054*/     OPC_EmitInteger32, 0, 
/*  7056*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7065*/    0, // EndSwitchType
/*  7066*/   /*Scope*/ 21, /*->7088*/
/*  7067*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7069*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7071*/    OPC_CheckType, MVT::v8i16,
/*  7073*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7074*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7076*/    OPC_EmitMergeInputChains1_0,
/*  7077*/    OPC_EmitInteger32, 0, 
/*  7079*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7088*/   /*Scope*/ 21, /*->7110*/
/*  7089*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7091*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7093*/    OPC_CheckType, MVT::v8i16,
/*  7095*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7096*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7098*/    OPC_EmitMergeInputChains1_0,
/*  7099*/    OPC_EmitInteger32, 0, 
/*  7101*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7110*/   /*Scope*/ 21, /*->7132*/
/*  7111*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7113*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7115*/    OPC_CheckType, MVT::v8i16,
/*  7117*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7118*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7120*/    OPC_EmitMergeInputChains1_0,
/*  7121*/    OPC_EmitInteger32, 0, 
/*  7123*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7132*/   /*Scope*/ 21, /*->7154*/
/*  7133*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7135*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7137*/    OPC_CheckType, MVT::v4i32,
/*  7139*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7140*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7142*/    OPC_EmitMergeInputChains1_0,
/*  7143*/    OPC_EmitInteger32, 0, 
/*  7145*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7154*/   /*Scope*/ 21, /*->7176*/
/*  7155*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7157*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7159*/    OPC_CheckType, MVT::v4i32,
/*  7161*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7162*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7164*/    OPC_EmitMergeInputChains1_0,
/*  7165*/    OPC_EmitInteger32, 0, 
/*  7167*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7176*/   /*Scope*/ 21, /*->7198*/
/*  7177*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7179*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7181*/    OPC_CheckType, MVT::v4i32,
/*  7183*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7184*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7186*/    OPC_EmitMergeInputChains1_0,
/*  7187*/    OPC_EmitInteger32, 0, 
/*  7189*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7198*/   /*Scope*/ 21, /*->7220*/
/*  7199*/    OPC_CheckPredicate, 13, // Predicate_sextload
/*  7201*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7203*/    OPC_CheckType, MVT::v2i64,
/*  7205*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7206*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7208*/    OPC_EmitMergeInputChains1_0,
/*  7209*/    OPC_EmitInteger32, 0, 
/*  7211*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7220*/   /*Scope*/ 21, /*->7242*/
/*  7221*/    OPC_CheckPredicate, 14, // Predicate_zextload
/*  7223*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7225*/    OPC_CheckType, MVT::v2i64,
/*  7227*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7228*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7230*/    OPC_EmitMergeInputChains1_0,
/*  7231*/    OPC_EmitInteger32, 0, 
/*  7233*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7242*/   /*Scope*/ 21, /*->7264*/
/*  7243*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7245*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7247*/    OPC_CheckType, MVT::v2i64,
/*  7249*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7250*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7252*/    OPC_EmitMergeInputChains1_0,
/*  7253*/    OPC_EmitInteger32, 0, 
/*  7255*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7264*/   /*Scope*/ 37, /*->7302*/
/*  7265*/    OPC_CheckPredicate7,  // Predicate_load
/*  7266*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->7284
/*  7269*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7270*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7272*/     OPC_EmitMergeInputChains1_0,
/*  7273*/     OPC_EmitInteger32, 0, 
/*  7275*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7284*/    /*SwitchType*/ 15, MVT::v2f64,// ->7301
/*  7286*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7287*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7289*/     OPC_EmitMergeInputChains1_0,
/*  7290*/     OPC_EmitInteger32, 0, 
/*  7292*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7301*/    0, // EndSwitchType
/*  7302*/   /*Scope*/ 28, /*->7331*/
/*  7303*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7305*/    OPC_CheckType, MVT::v2f64,
/*  7307*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7308*/    OPC_EmitMergeInputChains1_0,
/*  7309*/    OPC_EmitInteger32, 0, 
/*  7311*/    OPC_EmitInteger64, 0, 
/*  7313*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7322*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  7328*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7331*/   0, /*End of Scope*/
/*  7332*/  0, /*End of Scope*/
/*  7333*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7496
/*  7337*/  OPC_RecordMemRef,
/*  7338*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7339*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7340*/  OPC_Scope, 76, /*->7418*/ // 2 children in Scope
/*  7342*/   OPC_CheckChild1TypeI32,
/*  7343*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7399
/*  7346*/    OPC_Scope, 16, /*->7364*/ // 3 children in Scope
/*  7348*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7349*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7350*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7352*/     OPC_EmitMergeInputChains1_0,
/*  7353*/     OPC_EmitInteger32, 0, 
/*  7355*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7364*/    /*Scope*/ 16, /*->7381*/
/*  7365*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7366*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7367*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7369*/     OPC_EmitMergeInputChains1_0,
/*  7370*/     OPC_EmitInteger32, 0, 
/*  7372*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7381*/    /*Scope*/ 16, /*->7398*/
/*  7382*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7383*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7384*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7386*/     OPC_EmitMergeInputChains1_0,
/*  7387*/     OPC_EmitInteger32, 0, 
/*  7389*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7398*/    0, /*End of Scope*/
/*  7399*/   /*SwitchType*/ 16, MVT::i64,// ->7417
/*  7401*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7402*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7403*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7405*/    OPC_EmitMergeInputChains1_0,
/*  7406*/    OPC_EmitInteger32, 0, 
/*  7408*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7417*/   0, // EndSwitchType
/*  7418*/  /*Scope*/ 76, /*->7495*/
/*  7419*/   OPC_CheckChild1TypeI64,
/*  7420*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7476
/*  7423*/    OPC_Scope, 16, /*->7441*/ // 3 children in Scope
/*  7425*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7426*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7427*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7429*/     OPC_EmitMergeInputChains1_0,
/*  7430*/     OPC_EmitInteger32, 0, 
/*  7432*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7441*/    /*Scope*/ 16, /*->7458*/
/*  7442*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7443*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7444*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7446*/     OPC_EmitMergeInputChains1_0,
/*  7447*/     OPC_EmitInteger32, 0, 
/*  7449*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7458*/    /*Scope*/ 16, /*->7475*/
/*  7459*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7460*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7461*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7463*/     OPC_EmitMergeInputChains1_0,
/*  7464*/     OPC_EmitInteger32, 0, 
/*  7466*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7475*/    0, /*End of Scope*/
/*  7476*/   /*SwitchType*/ 16, MVT::i64,// ->7494
/*  7478*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7479*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7480*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7482*/    OPC_EmitMergeInputChains1_0,
/*  7483*/    OPC_EmitInteger32, 0, 
/*  7485*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7494*/   0, // EndSwitchType
/*  7495*/  0, /*End of Scope*/
/*  7496*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7741
/*  7500*/  OPC_RecordMemRef,
/*  7501*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7502*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7503*/  OPC_Scope, 117, /*->7622*/ // 2 children in Scope
/*  7505*/   OPC_CheckChild1TypeI32,
/*  7506*/   OPC_RecordChild2, // #2 = $val
/*  7507*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7602
/*  7510*/    OPC_Scope, 17, /*->7529*/ // 5 children in Scope
/*  7512*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*  7513*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7514*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7516*/     OPC_EmitMergeInputChains1_0,
/*  7517*/     OPC_EmitInteger32, 0, 
/*  7519*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7529*/    /*Scope*/ 17, /*->7547*/
/*  7530*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7531*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7532*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7534*/     OPC_EmitMergeInputChains1_0,
/*  7535*/     OPC_EmitInteger32, 0, 
/*  7537*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7547*/    /*Scope*/ 17, /*->7565*/
/*  7548*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7549*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7550*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7552*/     OPC_EmitMergeInputChains1_0,
/*  7553*/     OPC_EmitInteger32, 0, 
/*  7555*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7565*/    /*Scope*/ 17, /*->7583*/
/*  7566*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7567*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7568*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7570*/     OPC_EmitMergeInputChains1_0,
/*  7571*/     OPC_EmitInteger32, 0, 
/*  7573*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7583*/    /*Scope*/ 17, /*->7601*/
/*  7584*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7585*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7586*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7588*/     OPC_EmitMergeInputChains1_0,
/*  7589*/     OPC_EmitInteger32, 0, 
/*  7591*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7601*/    0, /*End of Scope*/
/*  7602*/   /*SwitchType*/ 17, MVT::i64,// ->7621
/*  7604*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_64
/*  7605*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7606*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7608*/    OPC_EmitMergeInputChains1_0,
/*  7609*/    OPC_EmitInteger32, 0, 
/*  7611*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7621*/   0, // EndSwitchType
/*  7622*/  /*Scope*/ 117, /*->7740*/
/*  7623*/   OPC_CheckChild1TypeI64,
/*  7624*/   OPC_RecordChild2, // #2 = $val
/*  7625*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7720
/*  7628*/    OPC_Scope, 17, /*->7647*/ // 5 children in Scope
/*  7630*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*  7631*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7632*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7634*/     OPC_EmitMergeInputChains1_0,
/*  7635*/     OPC_EmitInteger32, 0, 
/*  7637*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7647*/    /*Scope*/ 17, /*->7665*/
/*  7648*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7649*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7650*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7652*/     OPC_EmitMergeInputChains1_0,
/*  7653*/     OPC_EmitInteger32, 0, 
/*  7655*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7665*/    /*Scope*/ 17, /*->7683*/
/*  7666*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7667*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7668*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7670*/     OPC_EmitMergeInputChains1_0,
/*  7671*/     OPC_EmitInteger32, 0, 
/*  7673*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7683*/    /*Scope*/ 17, /*->7701*/
/*  7684*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7685*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7686*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7688*/     OPC_EmitMergeInputChains1_0,
/*  7689*/     OPC_EmitInteger32, 0, 
/*  7691*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7701*/    /*Scope*/ 17, /*->7719*/
/*  7702*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7703*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7704*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7706*/     OPC_EmitMergeInputChains1_0,
/*  7707*/     OPC_EmitInteger32, 0, 
/*  7709*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7719*/    0, /*End of Scope*/
/*  7720*/   /*SwitchType*/ 17, MVT::i64,// ->7739
/*  7722*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_64
/*  7723*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7724*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7726*/    OPC_EmitMergeInputChains1_0,
/*  7727*/    OPC_EmitInteger32, 0, 
/*  7729*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7739*/   0, // EndSwitchType
/*  7740*/  0, /*End of Scope*/
/*  7741*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->7986
/*  7745*/  OPC_RecordMemRef,
/*  7746*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7747*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7748*/  OPC_Scope, 117, /*->7867*/ // 2 children in Scope
/*  7750*/   OPC_CheckChild1TypeI32,
/*  7751*/   OPC_RecordChild2, // #2 = $val
/*  7752*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7847
/*  7755*/    OPC_Scope, 17, /*->7774*/ // 5 children in Scope
/*  7757*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*  7758*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7759*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7761*/     OPC_EmitMergeInputChains1_0,
/*  7762*/     OPC_EmitInteger32, 0, 
/*  7764*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7774*/    /*Scope*/ 17, /*->7792*/
/*  7775*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7776*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7777*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7779*/     OPC_EmitMergeInputChains1_0,
/*  7780*/     OPC_EmitInteger32, 0, 
/*  7782*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7792*/    /*Scope*/ 17, /*->7810*/
/*  7793*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7794*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7795*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7797*/     OPC_EmitMergeInputChains1_0,
/*  7798*/     OPC_EmitInteger32, 0, 
/*  7800*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7810*/    /*Scope*/ 17, /*->7828*/
/*  7811*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7812*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7813*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7815*/     OPC_EmitMergeInputChains1_0,
/*  7816*/     OPC_EmitInteger32, 0, 
/*  7818*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7828*/    /*Scope*/ 17, /*->7846*/
/*  7829*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7830*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7831*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7833*/     OPC_EmitMergeInputChains1_0,
/*  7834*/     OPC_EmitInteger32, 0, 
/*  7836*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7846*/    0, /*End of Scope*/
/*  7847*/   /*SwitchType*/ 17, MVT::i64,// ->7866
/*  7849*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_64
/*  7850*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7851*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7853*/    OPC_EmitMergeInputChains1_0,
/*  7854*/    OPC_EmitInteger32, 0, 
/*  7856*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7866*/   0, // EndSwitchType
/*  7867*/  /*Scope*/ 117, /*->7985*/
/*  7868*/   OPC_CheckChild1TypeI64,
/*  7869*/   OPC_RecordChild2, // #2 = $val
/*  7870*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7965
/*  7873*/    OPC_Scope, 17, /*->7892*/ // 5 children in Scope
/*  7875*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*  7876*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7877*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7879*/     OPC_EmitMergeInputChains1_0,
/*  7880*/     OPC_EmitInteger32, 0, 
/*  7882*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7892*/    /*Scope*/ 17, /*->7910*/
/*  7893*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7894*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7895*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7897*/     OPC_EmitMergeInputChains1_0,
/*  7898*/     OPC_EmitInteger32, 0, 
/*  7900*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7910*/    /*Scope*/ 17, /*->7928*/
/*  7911*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7912*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7913*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7915*/     OPC_EmitMergeInputChains1_0,
/*  7916*/     OPC_EmitInteger32, 0, 
/*  7918*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7928*/    /*Scope*/ 17, /*->7946*/
/*  7929*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7930*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7931*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7933*/     OPC_EmitMergeInputChains1_0,
/*  7934*/     OPC_EmitInteger32, 0, 
/*  7936*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7946*/    /*Scope*/ 17, /*->7964*/
/*  7947*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7948*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7949*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7951*/     OPC_EmitMergeInputChains1_0,
/*  7952*/     OPC_EmitInteger32, 0, 
/*  7954*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7964*/    0, /*End of Scope*/
/*  7965*/   /*SwitchType*/ 17, MVT::i64,// ->7984
/*  7967*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_64
/*  7968*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7969*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7971*/    OPC_EmitMergeInputChains1_0,
/*  7972*/    OPC_EmitInteger32, 0, 
/*  7974*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7984*/   0, // EndSwitchType
/*  7985*/  0, /*End of Scope*/
/*  7986*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8231
/*  7990*/  OPC_RecordMemRef,
/*  7991*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  7992*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7993*/  OPC_Scope, 117, /*->8112*/ // 2 children in Scope
/*  7995*/   OPC_CheckChild1TypeI32,
/*  7996*/   OPC_RecordChild2, // #2 = $val
/*  7997*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8092
/*  8000*/    OPC_Scope, 17, /*->8019*/ // 5 children in Scope
/*  8002*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*  8003*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8004*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8006*/     OPC_EmitMergeInputChains1_0,
/*  8007*/     OPC_EmitInteger32, 0, 
/*  8009*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8019*/    /*Scope*/ 17, /*->8037*/
/*  8020*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  8021*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8022*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8024*/     OPC_EmitMergeInputChains1_0,
/*  8025*/     OPC_EmitInteger32, 0, 
/*  8027*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8037*/    /*Scope*/ 17, /*->8055*/
/*  8038*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  8039*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8040*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8042*/     OPC_EmitMergeInputChains1_0,
/*  8043*/     OPC_EmitInteger32, 0, 
/*  8045*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8055*/    /*Scope*/ 17, /*->8073*/
/*  8056*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  8057*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8058*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8060*/     OPC_EmitMergeInputChains1_0,
/*  8061*/     OPC_EmitInteger32, 0, 
/*  8063*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8073*/    /*Scope*/ 17, /*->8091*/
/*  8074*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  8075*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8076*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8078*/     OPC_EmitMergeInputChains1_0,
/*  8079*/     OPC_EmitInteger32, 0, 
/*  8081*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8091*/    0, /*End of Scope*/
/*  8092*/   /*SwitchType*/ 17, MVT::i64,// ->8111
/*  8094*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_64
/*  8095*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8096*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8098*/    OPC_EmitMergeInputChains1_0,
/*  8099*/    OPC_EmitInteger32, 0, 
/*  8101*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8111*/   0, // EndSwitchType
/*  8112*/  /*Scope*/ 117, /*->8230*/
/*  8113*/   OPC_CheckChild1TypeI64,
/*  8114*/   OPC_RecordChild2, // #2 = $val
/*  8115*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8210
/*  8118*/    OPC_Scope, 17, /*->8137*/ // 5 children in Scope
/*  8120*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*  8121*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8122*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8124*/     OPC_EmitMergeInputChains1_0,
/*  8125*/     OPC_EmitInteger32, 0, 
/*  8127*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8137*/    /*Scope*/ 17, /*->8155*/
/*  8138*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  8139*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8140*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8142*/     OPC_EmitMergeInputChains1_0,
/*  8143*/     OPC_EmitInteger32, 0, 
/*  8145*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8155*/    /*Scope*/ 17, /*->8173*/
/*  8156*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  8157*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8158*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8160*/     OPC_EmitMergeInputChains1_0,
/*  8161*/     OPC_EmitInteger32, 0, 
/*  8163*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8173*/    /*Scope*/ 17, /*->8191*/
/*  8174*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  8175*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8176*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8178*/     OPC_EmitMergeInputChains1_0,
/*  8179*/     OPC_EmitInteger32, 0, 
/*  8181*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8191*/    /*Scope*/ 17, /*->8209*/
/*  8192*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  8193*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8194*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8196*/     OPC_EmitMergeInputChains1_0,
/*  8197*/     OPC_EmitInteger32, 0, 
/*  8199*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8209*/    0, /*End of Scope*/
/*  8210*/   /*SwitchType*/ 17, MVT::i64,// ->8229
/*  8212*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_64
/*  8213*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8214*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8216*/    OPC_EmitMergeInputChains1_0,
/*  8217*/    OPC_EmitInteger32, 0, 
/*  8219*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8229*/   0, // EndSwitchType
/*  8230*/  0, /*End of Scope*/
/*  8231*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8476
/*  8235*/  OPC_RecordMemRef,
/*  8236*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8237*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8238*/  OPC_Scope, 117, /*->8357*/ // 2 children in Scope
/*  8240*/   OPC_CheckChild1TypeI32,
/*  8241*/   OPC_RecordChild2, // #2 = $val
/*  8242*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8337
/*  8245*/    OPC_Scope, 17, /*->8264*/ // 5 children in Scope
/*  8247*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*  8248*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8249*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8251*/     OPC_EmitMergeInputChains1_0,
/*  8252*/     OPC_EmitInteger32, 0, 
/*  8254*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8264*/    /*Scope*/ 17, /*->8282*/
/*  8265*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  8266*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8267*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8269*/     OPC_EmitMergeInputChains1_0,
/*  8270*/     OPC_EmitInteger32, 0, 
/*  8272*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8282*/    /*Scope*/ 17, /*->8300*/
/*  8283*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8284*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8285*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8287*/     OPC_EmitMergeInputChains1_0,
/*  8288*/     OPC_EmitInteger32, 0, 
/*  8290*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8300*/    /*Scope*/ 17, /*->8318*/
/*  8301*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  8302*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8303*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8305*/     OPC_EmitMergeInputChains1_0,
/*  8306*/     OPC_EmitInteger32, 0, 
/*  8308*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8318*/    /*Scope*/ 17, /*->8336*/
/*  8319*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8320*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8321*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8323*/     OPC_EmitMergeInputChains1_0,
/*  8324*/     OPC_EmitInteger32, 0, 
/*  8326*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8336*/    0, /*End of Scope*/
/*  8337*/   /*SwitchType*/ 17, MVT::i64,// ->8356
/*  8339*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_64
/*  8340*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8341*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8343*/    OPC_EmitMergeInputChains1_0,
/*  8344*/    OPC_EmitInteger32, 0, 
/*  8346*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8356*/   0, // EndSwitchType
/*  8357*/  /*Scope*/ 117, /*->8475*/
/*  8358*/   OPC_CheckChild1TypeI64,
/*  8359*/   OPC_RecordChild2, // #2 = $val
/*  8360*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8455
/*  8363*/    OPC_Scope, 17, /*->8382*/ // 5 children in Scope
/*  8365*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*  8366*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8367*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8369*/     OPC_EmitMergeInputChains1_0,
/*  8370*/     OPC_EmitInteger32, 0, 
/*  8372*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8382*/    /*Scope*/ 17, /*->8400*/
/*  8383*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  8384*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8385*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8387*/     OPC_EmitMergeInputChains1_0,
/*  8388*/     OPC_EmitInteger32, 0, 
/*  8390*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8400*/    /*Scope*/ 17, /*->8418*/
/*  8401*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8402*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8403*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8405*/     OPC_EmitMergeInputChains1_0,
/*  8406*/     OPC_EmitInteger32, 0, 
/*  8408*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8418*/    /*Scope*/ 17, /*->8436*/
/*  8419*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  8420*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8421*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8423*/     OPC_EmitMergeInputChains1_0,
/*  8424*/     OPC_EmitInteger32, 0, 
/*  8426*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8436*/    /*Scope*/ 17, /*->8454*/
/*  8437*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8438*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8439*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8441*/     OPC_EmitMergeInputChains1_0,
/*  8442*/     OPC_EmitInteger32, 0, 
/*  8444*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8454*/    0, /*End of Scope*/
/*  8455*/   /*SwitchType*/ 17, MVT::i64,// ->8474
/*  8457*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_64
/*  8458*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8459*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8461*/    OPC_EmitMergeInputChains1_0,
/*  8462*/    OPC_EmitInteger32, 0, 
/*  8464*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8474*/   0, // EndSwitchType
/*  8475*/  0, /*End of Scope*/
/*  8476*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8721
/*  8480*/  OPC_RecordMemRef,
/*  8481*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8482*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8483*/  OPC_Scope, 117, /*->8602*/ // 2 children in Scope
/*  8485*/   OPC_CheckChild1TypeI32,
/*  8486*/   OPC_RecordChild2, // #2 = $val
/*  8487*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8582
/*  8490*/    OPC_Scope, 17, /*->8509*/ // 5 children in Scope
/*  8492*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*  8493*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8494*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8496*/     OPC_EmitMergeInputChains1_0,
/*  8497*/     OPC_EmitInteger32, 0, 
/*  8499*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8509*/    /*Scope*/ 17, /*->8527*/
/*  8510*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8511*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8512*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8514*/     OPC_EmitMergeInputChains1_0,
/*  8515*/     OPC_EmitInteger32, 0, 
/*  8517*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8527*/    /*Scope*/ 17, /*->8545*/
/*  8528*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8529*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8530*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8532*/     OPC_EmitMergeInputChains1_0,
/*  8533*/     OPC_EmitInteger32, 0, 
/*  8535*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8545*/    /*Scope*/ 17, /*->8563*/
/*  8546*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8547*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8548*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8550*/     OPC_EmitMergeInputChains1_0,
/*  8551*/     OPC_EmitInteger32, 0, 
/*  8553*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8563*/    /*Scope*/ 17, /*->8581*/
/*  8564*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8565*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8566*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8568*/     OPC_EmitMergeInputChains1_0,
/*  8569*/     OPC_EmitInteger32, 0, 
/*  8571*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8581*/    0, /*End of Scope*/
/*  8582*/   /*SwitchType*/ 17, MVT::i64,// ->8601
/*  8584*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_64
/*  8585*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8586*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8588*/    OPC_EmitMergeInputChains1_0,
/*  8589*/    OPC_EmitInteger32, 0, 
/*  8591*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8601*/   0, // EndSwitchType
/*  8602*/  /*Scope*/ 117, /*->8720*/
/*  8603*/   OPC_CheckChild1TypeI64,
/*  8604*/   OPC_RecordChild2, // #2 = $val
/*  8605*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8700
/*  8608*/    OPC_Scope, 17, /*->8627*/ // 5 children in Scope
/*  8610*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*  8611*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8612*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8614*/     OPC_EmitMergeInputChains1_0,
/*  8615*/     OPC_EmitInteger32, 0, 
/*  8617*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8627*/    /*Scope*/ 17, /*->8645*/
/*  8628*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8629*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8630*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8632*/     OPC_EmitMergeInputChains1_0,
/*  8633*/     OPC_EmitInteger32, 0, 
/*  8635*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8645*/    /*Scope*/ 17, /*->8663*/
/*  8646*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8647*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8648*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8650*/     OPC_EmitMergeInputChains1_0,
/*  8651*/     OPC_EmitInteger32, 0, 
/*  8653*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8663*/    /*Scope*/ 17, /*->8681*/
/*  8664*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8665*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8666*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8668*/     OPC_EmitMergeInputChains1_0,
/*  8669*/     OPC_EmitInteger32, 0, 
/*  8671*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8681*/    /*Scope*/ 17, /*->8699*/
/*  8682*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8683*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8684*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8686*/     OPC_EmitMergeInputChains1_0,
/*  8687*/     OPC_EmitInteger32, 0, 
/*  8689*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8699*/    0, /*End of Scope*/
/*  8700*/   /*SwitchType*/ 17, MVT::i64,// ->8719
/*  8702*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_64
/*  8703*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8704*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8706*/    OPC_EmitMergeInputChains1_0,
/*  8707*/    OPC_EmitInteger32, 0, 
/*  8709*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8719*/   0, // EndSwitchType
/*  8720*/  0, /*End of Scope*/
/*  8721*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->8966
/*  8725*/  OPC_RecordMemRef,
/*  8726*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8727*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8728*/  OPC_Scope, 117, /*->8847*/ // 2 children in Scope
/*  8730*/   OPC_CheckChild1TypeI32,
/*  8731*/   OPC_RecordChild2, // #2 = $val
/*  8732*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8827
/*  8735*/    OPC_Scope, 17, /*->8754*/ // 5 children in Scope
/*  8737*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*  8738*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8739*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8741*/     OPC_EmitMergeInputChains1_0,
/*  8742*/     OPC_EmitInteger32, 0, 
/*  8744*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8754*/    /*Scope*/ 17, /*->8772*/
/*  8755*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8756*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8757*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8759*/     OPC_EmitMergeInputChains1_0,
/*  8760*/     OPC_EmitInteger32, 0, 
/*  8762*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8772*/    /*Scope*/ 17, /*->8790*/
/*  8773*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8774*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8775*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8777*/     OPC_EmitMergeInputChains1_0,
/*  8778*/     OPC_EmitInteger32, 0, 
/*  8780*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8790*/    /*Scope*/ 17, /*->8808*/
/*  8791*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8792*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8793*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8795*/     OPC_EmitMergeInputChains1_0,
/*  8796*/     OPC_EmitInteger32, 0, 
/*  8798*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8808*/    /*Scope*/ 17, /*->8826*/
/*  8809*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8810*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8811*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8813*/     OPC_EmitMergeInputChains1_0,
/*  8814*/     OPC_EmitInteger32, 0, 
/*  8816*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8826*/    0, /*End of Scope*/
/*  8827*/   /*SwitchType*/ 17, MVT::i64,// ->8846
/*  8829*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_64
/*  8830*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8831*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8833*/    OPC_EmitMergeInputChains1_0,
/*  8834*/    OPC_EmitInteger32, 0, 
/*  8836*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8846*/   0, // EndSwitchType
/*  8847*/  /*Scope*/ 117, /*->8965*/
/*  8848*/   OPC_CheckChild1TypeI64,
/*  8849*/   OPC_RecordChild2, // #2 = $val
/*  8850*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8945
/*  8853*/    OPC_Scope, 17, /*->8872*/ // 5 children in Scope
/*  8855*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*  8856*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8857*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8859*/     OPC_EmitMergeInputChains1_0,
/*  8860*/     OPC_EmitInteger32, 0, 
/*  8862*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8872*/    /*Scope*/ 17, /*->8890*/
/*  8873*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8874*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8875*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8877*/     OPC_EmitMergeInputChains1_0,
/*  8878*/     OPC_EmitInteger32, 0, 
/*  8880*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8890*/    /*Scope*/ 17, /*->8908*/
/*  8891*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8892*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8893*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8895*/     OPC_EmitMergeInputChains1_0,
/*  8896*/     OPC_EmitInteger32, 0, 
/*  8898*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8908*/    /*Scope*/ 17, /*->8926*/
/*  8909*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8910*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8911*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8913*/     OPC_EmitMergeInputChains1_0,
/*  8914*/     OPC_EmitInteger32, 0, 
/*  8916*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8926*/    /*Scope*/ 17, /*->8944*/
/*  8927*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8928*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8929*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8931*/     OPC_EmitMergeInputChains1_0,
/*  8932*/     OPC_EmitInteger32, 0, 
/*  8934*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8944*/    0, /*End of Scope*/
/*  8945*/   /*SwitchType*/ 17, MVT::i64,// ->8964
/*  8947*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_64
/*  8948*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8949*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8951*/    OPC_EmitMergeInputChains1_0,
/*  8952*/    OPC_EmitInteger32, 0, 
/*  8954*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8964*/   0, // EndSwitchType
/*  8965*/  0, /*End of Scope*/
/*  8966*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9225
/*  8970*/  OPC_RecordMemRef,
/*  8971*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  8972*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8973*/  OPC_Scope, 124, /*->9099*/ // 2 children in Scope
/*  8975*/   OPC_CheckChild1TypeI32,
/*  8976*/   OPC_RecordChild2, // #2 = $exp
/*  8977*/   OPC_RecordChild3, // #3 = $new
/*  8978*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->9078
/*  8981*/    OPC_Scope, 18, /*->9001*/ // 5 children in Scope
/*  8983*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*  8984*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8985*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8987*/     OPC_EmitMergeInputChains1_0,
/*  8988*/     OPC_EmitInteger32, 0, 
/*  8990*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9001*/    /*Scope*/ 18, /*->9020*/
/*  9002*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  9003*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9004*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9006*/     OPC_EmitMergeInputChains1_0,
/*  9007*/     OPC_EmitInteger32, 0, 
/*  9009*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9020*/    /*Scope*/ 18, /*->9039*/
/*  9021*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  9022*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9023*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9025*/     OPC_EmitMergeInputChains1_0,
/*  9026*/     OPC_EmitInteger32, 0, 
/*  9028*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9039*/    /*Scope*/ 18, /*->9058*/
/*  9040*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  9041*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9042*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9044*/     OPC_EmitMergeInputChains1_0,
/*  9045*/     OPC_EmitInteger32, 0, 
/*  9047*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9058*/    /*Scope*/ 18, /*->9077*/
/*  9059*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  9060*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9061*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9063*/     OPC_EmitMergeInputChains1_0,
/*  9064*/     OPC_EmitInteger32, 0, 
/*  9066*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9077*/    0, /*End of Scope*/
/*  9078*/   /*SwitchType*/ 18, MVT::i64,// ->9098
/*  9080*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_64
/*  9081*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9082*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9084*/    OPC_EmitMergeInputChains1_0,
/*  9085*/    OPC_EmitInteger32, 0, 
/*  9087*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9098*/   0, // EndSwitchType
/*  9099*/  /*Scope*/ 124, /*->9224*/
/*  9100*/   OPC_CheckChild1TypeI64,
/*  9101*/   OPC_RecordChild2, // #2 = $exp
/*  9102*/   OPC_RecordChild3, // #3 = $new
/*  9103*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->9203
/*  9106*/    OPC_Scope, 18, /*->9126*/ // 5 children in Scope
/*  9108*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*  9109*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9110*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9112*/     OPC_EmitMergeInputChains1_0,
/*  9113*/     OPC_EmitInteger32, 0, 
/*  9115*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9126*/    /*Scope*/ 18, /*->9145*/
/*  9127*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  9128*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9129*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9131*/     OPC_EmitMergeInputChains1_0,
/*  9132*/     OPC_EmitInteger32, 0, 
/*  9134*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9145*/    /*Scope*/ 18, /*->9164*/
/*  9146*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  9147*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9148*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9150*/     OPC_EmitMergeInputChains1_0,
/*  9151*/     OPC_EmitInteger32, 0, 
/*  9153*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9164*/    /*Scope*/ 18, /*->9183*/
/*  9165*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  9166*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9167*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9169*/     OPC_EmitMergeInputChains1_0,
/*  9170*/     OPC_EmitInteger32, 0, 
/*  9172*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9183*/    /*Scope*/ 18, /*->9202*/
/*  9184*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  9185*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9186*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9188*/     OPC_EmitMergeInputChains1_0,
/*  9189*/     OPC_EmitInteger32, 0, 
/*  9191*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9202*/    0, /*End of Scope*/
/*  9203*/   /*SwitchType*/ 18, MVT::i64,// ->9223
/*  9205*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_64
/*  9206*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9207*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9209*/    OPC_EmitMergeInputChains1_0,
/*  9210*/    OPC_EmitInteger32, 0, 
/*  9212*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9223*/   0, // EndSwitchType
/*  9224*/  0, /*End of Scope*/
/*  9225*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9317
/*  9228*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9229*/  OPC_Scope, 69, /*->9300*/ // 2 children in Scope
/*  9231*/   OPC_MoveChild1,
/*  9232*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9257
/*  9236*/    OPC_RecordChild0, // #1 = $cond
/*  9237*/    OPC_MoveChild0,
/*  9238*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  9240*/    OPC_MoveParent,
/*  9241*/    OPC_CheckChild1Integer, 2, 
/*  9243*/    OPC_CheckTypeI32,
/*  9244*/    OPC_MoveSibling2,
/*  9245*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9248*/    OPC_RecordNode, // #2 = $dst
/*  9249*/    OPC_MoveParent,
/*  9250*/    OPC_EmitMergeInputChains1_0,
/*  9251*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9257*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9299
/*  9260*/    OPC_RecordChild0, // #1 = $cond
/*  9261*/    OPC_CheckChild0TypeI32,
/*  9262*/    OPC_CheckChild1Integer, 0, 
/*  9264*/    OPC_CheckTypeI32,
/*  9265*/    OPC_Scope, 15, /*->9282*/ // 2 children in Scope
/*  9267*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9269*/     OPC_MoveSibling2,
/*  9270*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9273*/     OPC_RecordNode, // #2 = $dst
/*  9274*/     OPC_MoveParent,
/*  9275*/     OPC_EmitMergeInputChains1_0,
/*  9276*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9282*/    /*Scope*/ 15, /*->9298*/
/*  9283*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9285*/     OPC_MoveSibling2,
/*  9286*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9289*/     OPC_RecordNode, // #2 = $dst
/*  9290*/     OPC_MoveParent,
/*  9291*/     OPC_EmitMergeInputChains1_0,
/*  9292*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9298*/    0, /*End of Scope*/
/*  9299*/   0, // EndSwitchOpcode
/*  9300*/  /*Scope*/ 15, /*->9316*/
/*  9301*/   OPC_RecordChild1, // #1 = $cond
/*  9302*/   OPC_CheckChild1TypeI32,
/*  9303*/   OPC_RecordChild2, // #2 = $dst
/*  9304*/   OPC_MoveChild2,
/*  9305*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9308*/   OPC_MoveParent,
/*  9309*/   OPC_EmitMergeInputChains1_0,
/*  9310*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9316*/  0, /*End of Scope*/
/*  9317*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9379
/*  9320*/  OPC_RecordChild0, // #0 = $lhs
/*  9321*/  OPC_Scope, 31, /*->9354*/ // 2 children in Scope
/*  9323*/   OPC_MoveChild1,
/*  9324*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9339
/*  9327*/    OPC_CheckAndImm, 31, 
/*  9329*/    OPC_RecordChild0, // #1 = $rhs
/*  9330*/    OPC_MoveParent,
/*  9331*/    OPC_CheckTypeI32,
/*  9332*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9339*/   /*SwitchType*/ 12, MVT::i64,// ->9353
/*  9341*/    OPC_CheckAndImm, 63, 
/*  9343*/    OPC_RecordChild0, // #1 = $rhs
/*  9344*/    OPC_MoveParent,
/*  9345*/    OPC_CheckTypeI64,
/*  9346*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9353*/   0, // EndSwitchType
/*  9354*/  /*Scope*/ 23, /*->9378*/
/*  9355*/   OPC_RecordChild1, // #1 = $rhs
/*  9356*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9367
/*  9359*/    OPC_CheckChild1TypeI32,
/*  9360*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9367*/   /*SwitchType*/ 8, MVT::i64,// ->9377
/*  9369*/    OPC_CheckChild1TypeI64,
/*  9370*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9377*/   0, // EndSwitchType
/*  9378*/  0, /*End of Scope*/
/*  9379*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9441
/*  9382*/  OPC_RecordChild0, // #0 = $lhs
/*  9383*/  OPC_Scope, 31, /*->9416*/ // 2 children in Scope
/*  9385*/   OPC_MoveChild1,
/*  9386*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9401
/*  9389*/    OPC_CheckAndImm, 31, 
/*  9391*/    OPC_RecordChild0, // #1 = $rhs
/*  9392*/    OPC_MoveParent,
/*  9393*/    OPC_CheckTypeI32,
/*  9394*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9401*/   /*SwitchType*/ 12, MVT::i64,// ->9415
/*  9403*/    OPC_CheckAndImm, 63, 
/*  9405*/    OPC_RecordChild0, // #1 = $rhs
/*  9406*/    OPC_MoveParent,
/*  9407*/    OPC_CheckTypeI64,
/*  9408*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9415*/   0, // EndSwitchType
/*  9416*/  /*Scope*/ 23, /*->9440*/
/*  9417*/   OPC_RecordChild1, // #1 = $rhs
/*  9418*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9429
/*  9421*/    OPC_CheckChild1TypeI32,
/*  9422*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9429*/   /*SwitchType*/ 8, MVT::i64,// ->9439
/*  9431*/    OPC_CheckChild1TypeI64,
/*  9432*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9439*/   0, // EndSwitchType
/*  9440*/  0, /*End of Scope*/
/*  9441*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9503
/*  9444*/  OPC_RecordChild0, // #0 = $lhs
/*  9445*/  OPC_Scope, 31, /*->9478*/ // 2 children in Scope
/*  9447*/   OPC_MoveChild1,
/*  9448*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9463
/*  9451*/    OPC_CheckAndImm, 31, 
/*  9453*/    OPC_RecordChild0, // #1 = $rhs
/*  9454*/    OPC_MoveParent,
/*  9455*/    OPC_CheckTypeI32,
/*  9456*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9463*/   /*SwitchType*/ 12, MVT::i64,// ->9477
/*  9465*/    OPC_CheckAndImm, 63, 
/*  9467*/    OPC_RecordChild0, // #1 = $rhs
/*  9468*/    OPC_MoveParent,
/*  9469*/    OPC_CheckTypeI64,
/*  9470*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9477*/   0, // EndSwitchType
/*  9478*/  /*Scope*/ 23, /*->9502*/
/*  9479*/   OPC_RecordChild1, // #1 = $rhs
/*  9480*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9491
/*  9483*/    OPC_CheckChild1TypeI32,
/*  9484*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9491*/   /*SwitchType*/ 8, MVT::i64,// ->9501
/*  9493*/    OPC_CheckChild1TypeI64,
/*  9494*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9501*/   0, // EndSwitchType
/*  9502*/  0, /*End of Scope*/
/*  9503*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9565
/*  9506*/  OPC_RecordChild0, // #0 = $lhs
/*  9507*/  OPC_Scope, 31, /*->9540*/ // 2 children in Scope
/*  9509*/   OPC_MoveChild1,
/*  9510*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9525
/*  9513*/    OPC_CheckAndImm, 31, 
/*  9515*/    OPC_RecordChild0, // #1 = $rhs
/*  9516*/    OPC_MoveParent,
/*  9517*/    OPC_CheckTypeI32,
/*  9518*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9525*/   /*SwitchType*/ 12, MVT::i64,// ->9539
/*  9527*/    OPC_CheckAndImm, 63, 
/*  9529*/    OPC_RecordChild0, // #1 = $rhs
/*  9530*/    OPC_MoveParent,
/*  9531*/    OPC_CheckTypeI64,
/*  9532*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9539*/   0, // EndSwitchType
/*  9540*/  /*Scope*/ 23, /*->9564*/
/*  9541*/   OPC_RecordChild1, // #1 = $rhs
/*  9542*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9553
/*  9545*/    OPC_CheckChild1TypeI32,
/*  9546*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9553*/   /*SwitchType*/ 8, MVT::i64,// ->9563
/*  9555*/    OPC_CheckChild1TypeI64,
/*  9556*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9563*/   0, // EndSwitchType
/*  9564*/  0, /*End of Scope*/
/*  9565*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9627
/*  9568*/  OPC_RecordChild0, // #0 = $lhs
/*  9569*/  OPC_Scope, 31, /*->9602*/ // 2 children in Scope
/*  9571*/   OPC_MoveChild1,
/*  9572*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9587
/*  9575*/    OPC_CheckAndImm, 31, 
/*  9577*/    OPC_RecordChild0, // #1 = $rhs
/*  9578*/    OPC_MoveParent,
/*  9579*/    OPC_CheckTypeI32,
/*  9580*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9587*/   /*SwitchType*/ 12, MVT::i64,// ->9601
/*  9589*/    OPC_CheckAndImm, 63, 
/*  9591*/    OPC_RecordChild0, // #1 = $rhs
/*  9592*/    OPC_MoveParent,
/*  9593*/    OPC_CheckTypeI64,
/*  9594*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9601*/   0, // EndSwitchType
/*  9602*/  /*Scope*/ 23, /*->9626*/
/*  9603*/   OPC_RecordChild1, // #1 = $rhs
/*  9604*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9615
/*  9607*/    OPC_CheckChild1TypeI32,
/*  9608*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9615*/   /*SwitchType*/ 8, MVT::i64,// ->9625
/*  9617*/    OPC_CheckChild1TypeI64,
/*  9618*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9625*/   0, // EndSwitchType
/*  9626*/  0, /*End of Scope*/
/*  9627*/ /*SwitchOpcode*/ 23|128,4/*535*/, TARGET_VAL(ISD::SELECT),// ->10166
/*  9631*/  OPC_Scope, 127, /*->9760*/ // 8 children in Scope
/*  9633*/   OPC_MoveChild0,
/*  9634*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9637*/   OPC_RecordChild0, // #0 = $cond
/*  9638*/   OPC_CheckChild0TypeI32,
/*  9639*/   OPC_CheckChild1Integer, 0, 
/*  9641*/   OPC_CheckTypeI32,
/*  9642*/   OPC_Scope, 57, /*->9701*/ // 2 children in Scope
/*  9644*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9646*/    OPC_MoveParent,
/*  9647*/    OPC_RecordChild1, // #1 = $lhs
/*  9648*/    OPC_RecordChild2, // #2 = $rhs
/*  9649*/    OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9660
/*  9652*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9660*/    /*SwitchType*/ 8, MVT::i64,// ->9670
/*  9662*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9670*/    /*SwitchType*/ 8, MVT::funcref,// ->9680
/*  9672*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9680*/    /*SwitchType*/ 8, MVT::externref,// ->9690
/*  9682*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9690*/    /*SwitchType*/ 8, MVT::exnref,// ->9700
/*  9692*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   MVT::exnref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9700*/    0, // EndSwitchType
/*  9701*/   /*Scope*/ 57, /*->9759*/
/*  9702*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9704*/    OPC_MoveParent,
/*  9705*/    OPC_RecordChild1, // #1 = $lhs
/*  9706*/    OPC_RecordChild2, // #2 = $rhs
/*  9707*/    OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9718
/*  9710*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9718*/    /*SwitchType*/ 8, MVT::i64,// ->9728
/*  9720*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9728*/    /*SwitchType*/ 8, MVT::funcref,// ->9738
/*  9730*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9738*/    /*SwitchType*/ 8, MVT::externref,// ->9748
/*  9740*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9748*/    /*SwitchType*/ 8, MVT::exnref,// ->9758
/*  9750*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   MVT::exnref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9758*/    0, // EndSwitchType
/*  9759*/   0, /*End of Scope*/
/*  9760*/  /*Scope*/ 59, /*->9820*/
/*  9761*/   OPC_RecordChild0, // #0 = $cond
/*  9762*/   OPC_CheckChild0TypeI32,
/*  9763*/   OPC_RecordChild1, // #1 = $lhs
/*  9764*/   OPC_RecordChild2, // #2 = $rhs
/*  9765*/   OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->9776
/*  9768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9776*/   /*SwitchType*/ 8, MVT::i64,// ->9786
/*  9778*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9786*/   /*SwitchType*/ 9, MVT::funcref,// ->9797
/*  9788*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9789*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9797*/   /*SwitchType*/ 9, MVT::externref,// ->9808
/*  9799*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9800*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9808*/   /*SwitchType*/ 9, MVT::exnref,// ->9819
/*  9810*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9811*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  MVT::exnref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9819*/   0, // EndSwitchType
/*  9820*/  /*Scope*/ 67, /*->9888*/
/*  9821*/   OPC_MoveChild0,
/*  9822*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9825*/   OPC_RecordChild0, // #0 = $cond
/*  9826*/   OPC_CheckChild0TypeI32,
/*  9827*/   OPC_CheckChild1Integer, 0, 
/*  9829*/   OPC_CheckTypeI32,
/*  9830*/   OPC_Scope, 27, /*->9859*/ // 2 children in Scope
/*  9832*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9834*/    OPC_MoveParent,
/*  9835*/    OPC_RecordChild1, // #1 = $lhs
/*  9836*/    OPC_RecordChild2, // #2 = $rhs
/*  9837*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9848
/*  9840*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9848*/    /*SwitchType*/ 8, MVT::f64,// ->9858
/*  9850*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9858*/    0, // EndSwitchType
/*  9859*/   /*Scope*/ 27, /*->9887*/
/*  9860*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9862*/    OPC_MoveParent,
/*  9863*/    OPC_RecordChild1, // #1 = $lhs
/*  9864*/    OPC_RecordChild2, // #2 = $rhs
/*  9865*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9876
/*  9868*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9876*/    /*SwitchType*/ 8, MVT::f64,// ->9886
/*  9878*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9886*/    0, // EndSwitchType
/*  9887*/   0, /*End of Scope*/
/*  9888*/  /*Scope*/ 26, /*->9915*/
/*  9889*/   OPC_RecordChild0, // #0 = $cond
/*  9890*/   OPC_CheckChild0TypeI32,
/*  9891*/   OPC_RecordChild1, // #1 = $lhs
/*  9892*/   OPC_RecordChild2, // #2 = $rhs
/*  9893*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9904
/*  9896*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9904*/   /*SwitchType*/ 8, MVT::f64,// ->9914
/*  9906*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9914*/   0, // EndSwitchType
/*  9915*/  /*Scope*/ 107, /*->10023*/
/*  9916*/   OPC_MoveChild0,
/*  9917*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9920*/   OPC_RecordChild0, // #0 = $cond
/*  9921*/   OPC_CheckChild0TypeI32,
/*  9922*/   OPC_CheckChild1Integer, 0, 
/*  9924*/   OPC_CheckTypeI32,
/*  9925*/   OPC_Scope, 47, /*->9974*/ // 2 children in Scope
/*  9927*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9929*/    OPC_MoveParent,
/*  9930*/    OPC_RecordChild1, // #1 = $lhs
/*  9931*/    OPC_RecordChild2, // #2 = $rhs
/*  9932*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9943
/*  9935*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9943*/    /*SwitchType*/ 8, MVT::v8i16,// ->9953
/*  9945*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9953*/    /*SwitchType*/ 8, MVT::v4i32,// ->9963
/*  9955*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9963*/    /*SwitchType*/ 8, MVT::v2i64,// ->9973
/*  9965*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9973*/    0, // EndSwitchType
/*  9974*/   /*Scope*/ 47, /*->10022*/
/*  9975*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9977*/    OPC_MoveParent,
/*  9978*/    OPC_RecordChild1, // #1 = $lhs
/*  9979*/    OPC_RecordChild2, // #2 = $rhs
/*  9980*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9991
/*  9983*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9991*/    /*SwitchType*/ 8, MVT::v8i16,// ->10001
/*  9993*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10001*/    /*SwitchType*/ 8, MVT::v4i32,// ->10011
/* 10003*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10011*/    /*SwitchType*/ 8, MVT::v2i64,// ->10021
/* 10013*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10021*/    0, // EndSwitchType
/* 10022*/   0, /*End of Scope*/
/* 10023*/  /*Scope*/ 46, /*->10070*/
/* 10024*/   OPC_RecordChild0, // #0 = $cond
/* 10025*/   OPC_CheckChild0TypeI32,
/* 10026*/   OPC_RecordChild1, // #1 = $lhs
/* 10027*/   OPC_RecordChild2, // #2 = $rhs
/* 10028*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->10039
/* 10031*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10039*/   /*SwitchType*/ 8, MVT::v8i16,// ->10049
/* 10041*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10049*/   /*SwitchType*/ 8, MVT::v4i32,// ->10059
/* 10051*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10059*/   /*SwitchType*/ 8, MVT::v2i64,// ->10069
/* 10061*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10069*/   0, // EndSwitchType
/* 10070*/  /*Scope*/ 67, /*->10138*/
/* 10071*/   OPC_MoveChild0,
/* 10072*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10075*/   OPC_RecordChild0, // #0 = $cond
/* 10076*/   OPC_CheckChild0TypeI32,
/* 10077*/   OPC_CheckChild1Integer, 0, 
/* 10079*/   OPC_CheckTypeI32,
/* 10080*/   OPC_Scope, 27, /*->10109*/ // 2 children in Scope
/* 10082*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10084*/    OPC_MoveParent,
/* 10085*/    OPC_RecordChild1, // #1 = $lhs
/* 10086*/    OPC_RecordChild2, // #2 = $rhs
/* 10087*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10098
/* 10090*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10098*/    /*SwitchType*/ 8, MVT::v2f64,// ->10108
/* 10100*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10108*/    0, // EndSwitchType
/* 10109*/   /*Scope*/ 27, /*->10137*/
/* 10110*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10112*/    OPC_MoveParent,
/* 10113*/    OPC_RecordChild1, // #1 = $lhs
/* 10114*/    OPC_RecordChild2, // #2 = $rhs
/* 10115*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10126
/* 10118*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10126*/    /*SwitchType*/ 8, MVT::v2f64,// ->10136
/* 10128*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10136*/    0, // EndSwitchType
/* 10137*/   0, /*End of Scope*/
/* 10138*/  /*Scope*/ 26, /*->10165*/
/* 10139*/   OPC_RecordChild0, // #0 = $cond
/* 10140*/   OPC_CheckChild0TypeI32,
/* 10141*/   OPC_RecordChild1, // #1 = $lhs
/* 10142*/   OPC_RecordChild2, // #2 = $rhs
/* 10143*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10154
/* 10146*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10154*/   /*SwitchType*/ 8, MVT::v2f64,// ->10164
/* 10156*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10164*/   0, // EndSwitchType
/* 10165*/  0, /*End of Scope*/
/* 10166*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10299
/* 10170*/  OPC_Scope, 57, /*->10229*/ // 2 children in Scope
/* 10172*/   OPC_MoveChild0,
/* 10173*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10176*/   OPC_RecordChild0, // #0 = $vec
/* 10177*/   OPC_Scope, 24, /*->10203*/ // 2 children in Scope
/* 10179*/    OPC_CheckChild0Type, MVT::v16i8,
/* 10181*/    OPC_RecordChild1, // #1 = $idx
/* 10182*/    OPC_MoveChild1,
/* 10183*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10186*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 10188*/    OPC_CheckTypeI32,
/* 10189*/    OPC_MoveParent,
/* 10190*/    OPC_MoveSibling1,
/* 10191*/    OPC_CheckValueType, MVT::i8,
/* 10193*/    OPC_MoveParent,
/* 10194*/    OPC_CheckTypeI32,
/* 10195*/    OPC_EmitConvertToTarget1,
/* 10196*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10203*/   /*Scope*/ 24, /*->10228*/
/* 10204*/    OPC_CheckChild0Type, MVT::v8i16,
/* 10206*/    OPC_RecordChild1, // #1 = $idx
/* 10207*/    OPC_MoveChild1,
/* 10208*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10211*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 10213*/    OPC_CheckTypeI32,
/* 10214*/    OPC_MoveParent,
/* 10215*/    OPC_MoveSibling1,
/* 10216*/    OPC_CheckValueType, MVT::i16,
/* 10218*/    OPC_MoveParent,
/* 10219*/    OPC_CheckTypeI32,
/* 10220*/    OPC_EmitConvertToTarget1,
/* 10221*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10228*/   0, /*End of Scope*/
/* 10229*/  /*Scope*/ 68, /*->10298*/
/* 10230*/   OPC_RecordChild0, // #0 = $src
/* 10231*/   OPC_MoveChild1,
/* 10232*/   OPC_Scope, 25, /*->10259*/ // 3 children in Scope
/* 10234*/    OPC_CheckValueType, MVT::i8,
/* 10236*/    OPC_MoveParent,
/* 10237*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10248
/* 10240*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10242*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10248*/    /*SwitchType*/ 8, MVT::i64,// ->10258
/* 10250*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10258*/    0, // EndSwitchType
/* 10259*/   /*Scope*/ 25, /*->10285*/
/* 10260*/    OPC_CheckValueType, MVT::i16,
/* 10262*/    OPC_MoveParent,
/* 10263*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10274
/* 10266*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10268*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10274*/    /*SwitchType*/ 8, MVT::i64,// ->10284
/* 10276*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10278*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10284*/    0, // EndSwitchType
/* 10285*/   /*Scope*/ 11, /*->10297*/
/* 10286*/    OPC_CheckValueType, MVT::i32,
/* 10288*/    OPC_MoveParent,
/* 10289*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10291*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10297*/   0, /*End of Scope*/
/* 10298*/  0, /*End of Scope*/
/* 10299*/ /*SwitchOpcode*/ 38|128,1/*166*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10469
/* 10303*/  OPC_RecordMemRef,
/* 10304*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10305*/  OPC_MoveChild1,
/* 10306*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10309*/  OPC_RecordChild0, // #1 = $addr
/* 10310*/  OPC_MoveChild0,
/* 10311*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10314*/  OPC_MoveParent,
/* 10315*/  OPC_MoveParent,
/* 10316*/  OPC_SwitchType /*14 cases */, 8, MVT::i32,// ->10327
/* 10319*/   OPC_EmitMergeInputChains1_0,
/* 10320*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10327*/  /*SwitchType*/ 8, MVT::i64,// ->10337
/* 10329*/   OPC_EmitMergeInputChains1_0,
/* 10330*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10337*/  /*SwitchType*/ 9, MVT::funcref,// ->10348
/* 10339*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10340*/   OPC_EmitMergeInputChains1_0,
/* 10341*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10348*/  /*SwitchType*/ 9, MVT::externref,// ->10359
/* 10350*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10351*/   OPC_EmitMergeInputChains1_0,
/* 10352*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10359*/  /*SwitchType*/ 10, MVT::exnref,// ->10371
/* 10361*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10363*/   OPC_EmitMergeInputChains1_0,
/* 10364*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::exnref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10371*/  /*SwitchType*/ 8, MVT::f32,// ->10381
/* 10373*/   OPC_EmitMergeInputChains1_0,
/* 10374*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10381*/  /*SwitchType*/ 8, MVT::f64,// ->10391
/* 10383*/   OPC_EmitMergeInputChains1_0,
/* 10384*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10391*/  /*SwitchType*/ 9, MVT::v2i64,// ->10402
/* 10393*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10394*/   OPC_EmitMergeInputChains1_0,
/* 10395*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10402*/  /*SwitchType*/ 9, MVT::v4i32,// ->10413
/* 10404*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10405*/   OPC_EmitMergeInputChains1_0,
/* 10406*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10413*/  /*SwitchType*/ 9, MVT::v16i8,// ->10424
/* 10415*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10416*/   OPC_EmitMergeInputChains1_0,
/* 10417*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10424*/  /*SwitchType*/ 9, MVT::v8i16,// ->10435
/* 10426*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10427*/   OPC_EmitMergeInputChains1_0,
/* 10428*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10435*/  /*SwitchType*/ 9, MVT::v8f16,// ->10446
/* 10437*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10438*/   OPC_EmitMergeInputChains1_0,
/* 10439*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8f16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10446*/  /*SwitchType*/ 9, MVT::v4f32,// ->10457
/* 10448*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10449*/   OPC_EmitMergeInputChains1_0,
/* 10450*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10457*/  /*SwitchType*/ 9, MVT::v2f64,// ->10468
/* 10459*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10460*/   OPC_EmitMergeInputChains1_0,
/* 10461*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10468*/  0, // EndSwitchType
/* 10469*/ /*SwitchOpcode*/ 66|128,2/*322*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10795
/* 10473*/  OPC_RecordMemRef,
/* 10474*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10475*/  OPC_RecordChild1, // #1 = $src
/* 10476*/  OPC_Scope, 20, /*->10498*/ // 14 children in Scope
/* 10478*/   OPC_CheckChild1TypeI32,
/* 10479*/   OPC_MoveChild2,
/* 10480*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10483*/   OPC_RecordChild0, // #2 = $addr
/* 10484*/   OPC_MoveChild0,
/* 10485*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10488*/   OPC_MoveParent,
/* 10489*/   OPC_MoveParent,
/* 10490*/   OPC_EmitMergeInputChains1_0,
/* 10491*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10498*/  /*Scope*/ 20, /*->10519*/
/* 10499*/   OPC_CheckChild1TypeI64,
/* 10500*/   OPC_MoveChild2,
/* 10501*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10504*/   OPC_RecordChild0, // #2 = $addr
/* 10505*/   OPC_MoveChild0,
/* 10506*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10509*/   OPC_MoveParent,
/* 10510*/   OPC_MoveParent,
/* 10511*/   OPC_EmitMergeInputChains1_0,
/* 10512*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10519*/  /*Scope*/ 21, /*->10541*/
/* 10520*/   OPC_CheckChild1Type, MVT::f32,
/* 10522*/   OPC_MoveChild2,
/* 10523*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10526*/   OPC_RecordChild0, // #2 = $addr
/* 10527*/   OPC_MoveChild0,
/* 10528*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10531*/   OPC_MoveParent,
/* 10532*/   OPC_MoveParent,
/* 10533*/   OPC_EmitMergeInputChains1_0,
/* 10534*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10541*/  /*Scope*/ 21, /*->10563*/
/* 10542*/   OPC_CheckChild1Type, MVT::f64,
/* 10544*/   OPC_MoveChild2,
/* 10545*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10548*/   OPC_RecordChild0, // #2 = $addr
/* 10549*/   OPC_MoveChild0,
/* 10550*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10553*/   OPC_MoveParent,
/* 10554*/   OPC_MoveParent,
/* 10555*/   OPC_EmitMergeInputChains1_0,
/* 10556*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10563*/  /*Scope*/ 22, /*->10586*/
/* 10564*/   OPC_CheckChild1Type, MVT::v8f16,
/* 10566*/   OPC_MoveChild2,
/* 10567*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10570*/   OPC_RecordChild0, // #2 = $addr
/* 10571*/   OPC_MoveChild0,
/* 10572*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10575*/   OPC_MoveParent,
/* 10576*/   OPC_MoveParent,
/* 10577*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10578*/   OPC_EmitMergeInputChains1_0,
/* 10579*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10586*/  /*Scope*/ 22, /*->10609*/
/* 10587*/   OPC_CheckChild1Type, MVT::v4f32,
/* 10589*/   OPC_MoveChild2,
/* 10590*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10593*/   OPC_RecordChild0, // #2 = $addr
/* 10594*/   OPC_MoveChild0,
/* 10595*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10598*/   OPC_MoveParent,
/* 10599*/   OPC_MoveParent,
/* 10600*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10601*/   OPC_EmitMergeInputChains1_0,
/* 10602*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10609*/  /*Scope*/ 22, /*->10632*/
/* 10610*/   OPC_CheckChild1Type, MVT::v2f64,
/* 10612*/   OPC_MoveChild2,
/* 10613*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10616*/   OPC_RecordChild0, // #2 = $addr
/* 10617*/   OPC_MoveChild0,
/* 10618*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10621*/   OPC_MoveParent,
/* 10622*/   OPC_MoveParent,
/* 10623*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10624*/   OPC_EmitMergeInputChains1_0,
/* 10625*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10632*/  /*Scope*/ 22, /*->10655*/
/* 10633*/   OPC_CheckChild1Type, MVT::v2i64,
/* 10635*/   OPC_MoveChild2,
/* 10636*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10639*/   OPC_RecordChild0, // #2 = $addr
/* 10640*/   OPC_MoveChild0,
/* 10641*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10644*/   OPC_MoveParent,
/* 10645*/   OPC_MoveParent,
/* 10646*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10647*/   OPC_EmitMergeInputChains1_0,
/* 10648*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10655*/  /*Scope*/ 22, /*->10678*/
/* 10656*/   OPC_CheckChild1Type, MVT::v4i32,
/* 10658*/   OPC_MoveChild2,
/* 10659*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10662*/   OPC_RecordChild0, // #2 = $addr
/* 10663*/   OPC_MoveChild0,
/* 10664*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10667*/   OPC_MoveParent,
/* 10668*/   OPC_MoveParent,
/* 10669*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10670*/   OPC_EmitMergeInputChains1_0,
/* 10671*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10678*/  /*Scope*/ 22, /*->10701*/
/* 10679*/   OPC_CheckChild1Type, MVT::v16i8,
/* 10681*/   OPC_MoveChild2,
/* 10682*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10685*/   OPC_RecordChild0, // #2 = $addr
/* 10686*/   OPC_MoveChild0,
/* 10687*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10690*/   OPC_MoveParent,
/* 10691*/   OPC_MoveParent,
/* 10692*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10693*/   OPC_EmitMergeInputChains1_0,
/* 10694*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10701*/  /*Scope*/ 22, /*->10724*/
/* 10702*/   OPC_CheckChild1Type, MVT::v8i16,
/* 10704*/   OPC_MoveChild2,
/* 10705*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10708*/   OPC_RecordChild0, // #2 = $addr
/* 10709*/   OPC_MoveChild0,
/* 10710*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10713*/   OPC_MoveParent,
/* 10714*/   OPC_MoveParent,
/* 10715*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10716*/   OPC_EmitMergeInputChains1_0,
/* 10717*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10724*/  /*Scope*/ 22, /*->10747*/
/* 10725*/   OPC_CheckChild1Type, MVT::funcref,
/* 10727*/   OPC_MoveChild2,
/* 10728*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10731*/   OPC_RecordChild0, // #2 = $addr
/* 10732*/   OPC_MoveChild0,
/* 10733*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10736*/   OPC_MoveParent,
/* 10737*/   OPC_MoveParent,
/* 10738*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10739*/   OPC_EmitMergeInputChains1_0,
/* 10740*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10747*/  /*Scope*/ 22, /*->10770*/
/* 10748*/   OPC_CheckChild1Type, MVT::externref,
/* 10750*/   OPC_MoveChild2,
/* 10751*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10754*/   OPC_RecordChild0, // #2 = $addr
/* 10755*/   OPC_MoveChild0,
/* 10756*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10759*/   OPC_MoveParent,
/* 10760*/   OPC_MoveParent,
/* 10761*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10762*/   OPC_EmitMergeInputChains1_0,
/* 10763*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10770*/  /*Scope*/ 23, /*->10794*/
/* 10771*/   OPC_CheckChild1Type, MVT::exnref,
/* 10773*/   OPC_MoveChild2,
/* 10774*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10777*/   OPC_RecordChild0, // #2 = $addr
/* 10778*/   OPC_MoveChild0,
/* 10779*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10782*/   OPC_MoveParent,
/* 10783*/   OPC_MoveParent,
/* 10784*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10786*/   OPC_EmitMergeInputChains1_0,
/* 10787*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 10794*/  0, /*End of Scope*/
/* 10795*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10819
/* 10798*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10799*/  OPC_RecordChild1, // #1 = $amt
/* 10800*/  OPC_MoveChild1,
/* 10801*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10804*/  OPC_MoveSibling2,
/* 10805*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10808*/  OPC_RecordNode, // #2 = $amt2
/* 10809*/  OPC_MoveParent,
/* 10810*/  OPC_EmitMergeInputChains1_0,
/* 10811*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10819*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10844
/* 10822*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10823*/  OPC_CaptureGlueInput,
/* 10824*/  OPC_RecordChild1, // #1 = $amt
/* 10825*/  OPC_MoveChild1,
/* 10826*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10829*/  OPC_MoveSibling2,
/* 10830*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10833*/  OPC_RecordNode, // #2 = $amt2
/* 10834*/  OPC_MoveParent,
/* 10835*/  OPC_EmitMergeInputChains1_0,
/* 10836*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10844*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->10904
/* 10847*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 10848*/  OPC_RecordChild1, // #1 = $src_idx
/* 10849*/  OPC_MoveChild1,
/* 10850*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10853*/  OPC_CheckTypeI32,
/* 10854*/  OPC_MoveSibling2,
/* 10855*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10858*/  OPC_RecordNode, // #2 = $dst_idx
/* 10859*/  OPC_CheckTypeI32,
/* 10860*/  OPC_MoveParent,
/* 10861*/  OPC_RecordChild3, // #3 = $dst
/* 10862*/  OPC_Scope, 19, /*->10883*/ // 2 children in Scope
/* 10864*/   OPC_CheckChild3TypeI32,
/* 10865*/   OPC_RecordChild4, // #4 = $src
/* 10866*/   OPC_CheckChild4TypeI32,
/* 10867*/   OPC_RecordChild5, // #5 = $len
/* 10868*/   OPC_CheckChild5TypeI32,
/* 10869*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10871*/   OPC_EmitMergeInputChains1_0,
/* 10872*/   OPC_EmitConvertToTarget1,
/* 10873*/   OPC_EmitConvertToTarget2,
/* 10874*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8091MEMORY_COPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_8091MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 10883*/  /*Scope*/ 19, /*->10903*/
/* 10884*/   OPC_CheckChild3TypeI64,
/* 10885*/   OPC_RecordChild4, // #4 = $src
/* 10886*/   OPC_CheckChild4TypeI64,
/* 10887*/   OPC_RecordChild5, // #5 = $len
/* 10888*/   OPC_CheckChild5TypeI64,
/* 10889*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10891*/   OPC_EmitMergeInputChains1_0,
/* 10892*/   OPC_EmitConvertToTarget1,
/* 10893*/   OPC_EmitConvertToTarget2,
/* 10894*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8092MEMORY_COPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_8092MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 10903*/  0, /*End of Scope*/
/* 10904*/ /*SwitchOpcode*/ 54, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->10961
/* 10907*/  OPC_RecordMemRef,
/* 10908*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 10909*/  OPC_MoveChild1,
/* 10910*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10913*/  OPC_RecordChild0, // #1 = $table
/* 10914*/  OPC_MoveChild0,
/* 10915*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10918*/  OPC_MoveParent,
/* 10919*/  OPC_MoveParent,
/* 10920*/  OPC_RecordChild2, // #2 = $idx
/* 10921*/  OPC_CheckChild2TypeI32,
/* 10922*/  OPC_SwitchType /*3 cases */, 10, MVT::funcref,// ->10935
/* 10925*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10926*/   OPC_EmitMergeInputChains1_0,
/* 10927*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10935*/  /*SwitchType*/ 10, MVT::externref,// ->10947
/* 10937*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10938*/   OPC_EmitMergeInputChains1_0,
/* 10939*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10947*/  /*SwitchType*/ 11, MVT::exnref,// ->10960
/* 10949*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10951*/   OPC_EmitMergeInputChains1_0,
/* 10952*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::exnref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10960*/  0, // EndSwitchType
/* 10961*/ /*SwitchOpcode*/ 83, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11047
/* 10964*/  OPC_RecordMemRef,
/* 10965*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 10966*/  OPC_Scope, 56, /*->11024*/ // 2 children in Scope
/* 10968*/   OPC_MoveChild1,
/* 10969*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10972*/   OPC_RecordChild0, // #1 = $table
/* 10973*/   OPC_MoveChild0,
/* 10974*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10977*/   OPC_MoveParent,
/* 10978*/   OPC_MoveParent,
/* 10979*/   OPC_RecordChild2, // #2 = $idx
/* 10980*/   OPC_CheckChild2TypeI32,
/* 10981*/   OPC_RecordChild3, // #3 = $src
/* 10982*/   OPC_Scope, 12, /*->10996*/ // 3 children in Scope
/* 10984*/    OPC_CheckChild3Type, MVT::funcref,
/* 10986*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10987*/    OPC_EmitMergeInputChains1_0,
/* 10988*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 10996*/   /*Scope*/ 12, /*->11009*/
/* 10997*/    OPC_CheckChild3Type, MVT::externref,
/* 10999*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11000*/    OPC_EmitMergeInputChains1_0,
/* 11001*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11009*/   /*Scope*/ 13, /*->11023*/
/* 11010*/    OPC_CheckChild3Type, MVT::exnref,
/* 11012*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11014*/    OPC_EmitMergeInputChains1_0,
/* 11015*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11023*/   0, /*End of Scope*/
/* 11024*/  /*Scope*/ 21, /*->11046*/
/* 11025*/   OPC_RecordChild1, // #1 = $table
/* 11026*/   OPC_MoveChild1,
/* 11027*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11030*/   OPC_MoveParent,
/* 11031*/   OPC_RecordChild2, // #2 = $idx
/* 11032*/   OPC_CheckChild2TypeI32,
/* 11033*/   OPC_RecordChild3, // #3 = $r
/* 11034*/   OPC_CheckChild3Type, MVT::funcref,
/* 11036*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11037*/   OPC_EmitMergeInputChains1_0,
/* 11038*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11046*/  0, /*End of Scope*/
/* 11047*/ /*SwitchOpcode*/ 93|128,9/*1245*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12296
/* 11051*/  OPC_Scope, 49, /*->11102*/ // 40 children in Scope
/* 11053*/   OPC_CheckChild0Integer, 92|128,62|128,1/*24412*/, 
/* 11057*/   OPC_RecordChild1, // #0 = $src
/* 11058*/   OPC_Scope, 20, /*->11080*/ // 2 children in Scope
/* 11060*/    OPC_CheckChild1Type, MVT::f32,
/* 11062*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11071
/* 11065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12206:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11071*/    /*SwitchType*/ 6, MVT::i64,// ->11079
/* 11073*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12206:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11079*/    0, // EndSwitchType
/* 11080*/   /*Scope*/ 20, /*->11101*/
/* 11081*/    OPC_CheckChild1Type, MVT::f64,
/* 11083*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11092
/* 11086*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12206:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11092*/    /*SwitchType*/ 6, MVT::i64,// ->11100
/* 11094*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12206:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11100*/    0, // EndSwitchType
/* 11101*/   0, /*End of Scope*/
/* 11102*/  /*Scope*/ 49, /*->11152*/
/* 11103*/   OPC_CheckChild0Integer, 94|128,62|128,1/*24414*/, 
/* 11107*/   OPC_RecordChild1, // #0 = $src
/* 11108*/   OPC_Scope, 20, /*->11130*/ // 2 children in Scope
/* 11110*/    OPC_CheckChild1Type, MVT::f32,
/* 11112*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11121
/* 11115*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12207:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11121*/    /*SwitchType*/ 6, MVT::i64,// ->11129
/* 11123*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12207:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11129*/    0, // EndSwitchType
/* 11130*/   /*Scope*/ 20, /*->11151*/
/* 11131*/    OPC_CheckChild1Type, MVT::f64,
/* 11133*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11142
/* 11136*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12207:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11142*/    /*SwitchType*/ 6, MVT::i64,// ->11150
/* 11144*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12207:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11150*/    0, // EndSwitchType
/* 11151*/   0, /*End of Scope*/
/* 11152*/  /*Scope*/ 43, /*->11196*/
/* 11153*/   OPC_CheckChild0Integer, 78|128,61|128,1/*24270*/, 
/* 11157*/   OPC_RecordChild1, // #0 = $vec
/* 11158*/   OPC_Scope, 8, /*->11168*/ // 4 children in Scope
/* 11160*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11162*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11168*/   /*Scope*/ 8, /*->11177*/
/* 11169*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11171*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11177*/   /*Scope*/ 8, /*->11186*/
/* 11178*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11180*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11186*/   /*Scope*/ 8, /*->11195*/
/* 11187*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11189*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12135:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11195*/   0, /*End of Scope*/
/* 11196*/  /*Scope*/ 47, /*->11244*/
/* 11197*/   OPC_CheckChild0Integer, 76|128,61|128,1/*24268*/, 
/* 11201*/   OPC_RecordChild1, // #0 = $vec
/* 11202*/   OPC_Scope, 9, /*->11213*/ // 4 children in Scope
/* 11204*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11206*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11207*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11213*/   /*Scope*/ 9, /*->11223*/
/* 11214*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11216*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11217*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11223*/   /*Scope*/ 9, /*->11233*/
/* 11224*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11226*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11227*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11233*/   /*Scope*/ 9, /*->11243*/
/* 11234*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11236*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11237*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12134:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11243*/   0, /*End of Scope*/
/* 11244*/  /*Scope*/ 47, /*->11292*/
/* 11245*/   OPC_CheckChild0Integer, 82|128,61|128,1/*24274*/, 
/* 11249*/   OPC_RecordChild1, // #0 = $vec
/* 11250*/   OPC_Scope, 9, /*->11261*/ // 4 children in Scope
/* 11252*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11254*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11255*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12137:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11261*/   /*Scope*/ 9, /*->11271*/
/* 11262*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11264*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11265*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12137:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11271*/   /*Scope*/ 9, /*->11281*/
/* 11272*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11274*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11275*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12137:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11281*/   /*Scope*/ 9, /*->11291*/
/* 11282*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11284*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11285*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12137:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11291*/   0, /*End of Scope*/
/* 11292*/  /*Scope*/ 10, /*->11303*/
/* 11293*/   OPC_CheckChild0Integer, 8|128,62|128,1/*24328*/, 
/* 11297*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11298*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 MVT::funcref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12164:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11303*/  /*Scope*/ 12, /*->11316*/
/* 11304*/   OPC_CheckChild0Integer, 2|128,62|128,1/*24322*/, 
/* 11308*/   OPC_RecordChild1, // #0 = $ref
/* 11309*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11310*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12161:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11316*/  /*Scope*/ 10, /*->11327*/
/* 11317*/   OPC_CheckChild0Integer, 6|128,62|128,1/*24326*/, 
/* 11321*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11322*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 MVT::externref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12163:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11327*/  /*Scope*/ 12, /*->11340*/
/* 11328*/   OPC_CheckChild0Integer, 0|128,62|128,1/*24320*/, 
/* 11332*/   OPC_RecordChild1, // #0 = $ref
/* 11333*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11334*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12160:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11340*/  /*Scope*/ 10, /*->11351*/
/* 11341*/   OPC_CheckChild0Integer, 4|128,62|128,1/*24324*/, 
/* 11345*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11346*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 MVT::exnref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 12162:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11351*/  /*Scope*/ 12, /*->11364*/
/* 11352*/   OPC_CheckChild0Integer, 126|128,61|128,1/*24318*/, 
/* 11356*/   OPC_RecordChild1, // #0 = $ref
/* 11357*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 11358*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12159:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11364*/  /*Scope*/ 23, /*->11388*/
/* 11365*/   OPC_CheckChild0Integer, 94|128,61|128,1/*24286*/, 
/* 11369*/   OPC_RecordChild1, // #0 = $vec
/* 11370*/   OPC_RecordChild2, // #1 = $idx
/* 11371*/   OPC_MoveChild2,
/* 11372*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11375*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 11377*/   OPC_MoveParent,
/* 11378*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasHalfPrecision())
/* 11380*/   OPC_EmitConvertToTarget1,
/* 11381*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 12143:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11388*/  /*Scope*/ 13, /*->11402*/
/* 11389*/   OPC_CheckChild0Integer, 50|128,62|128,1/*24370*/, 
/* 11393*/   OPC_RecordChild1, // #0 = $src
/* 11394*/   OPC_RecordChild2, // #1 = $mask
/* 11395*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12185:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11402*/  /*Scope*/ 115, /*->11518*/
/* 11403*/   OPC_CheckChild0Integer, 84|128,61|128,1/*24276*/, 
/* 11407*/   OPC_RecordChild1, // #0 = $v1
/* 11408*/   OPC_SwitchType /*6 cases */, 16, MVT::v16i8,// ->11427
/* 11411*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11413*/    OPC_RecordChild2, // #1 = $v2
/* 11414*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11416*/    OPC_RecordChild3, // #2 = $c
/* 11417*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11419*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12138:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11427*/   /*SwitchType*/ 16, MVT::v8i16,// ->11445
/* 11429*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11431*/    OPC_RecordChild2, // #1 = $v2
/* 11432*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11434*/    OPC_RecordChild3, // #2 = $c
/* 11435*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11437*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12138:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11445*/   /*SwitchType*/ 16, MVT::v4i32,// ->11463
/* 11447*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11449*/    OPC_RecordChild2, // #1 = $v2
/* 11450*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11452*/    OPC_RecordChild3, // #2 = $c
/* 11453*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11455*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12138:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11463*/   /*SwitchType*/ 16, MVT::v2i64,// ->11481
/* 11465*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11467*/    OPC_RecordChild2, // #1 = $v2
/* 11468*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11470*/    OPC_RecordChild3, // #2 = $c
/* 11471*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11473*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12138:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11481*/   /*SwitchType*/ 16, MVT::v4f32,// ->11499
/* 11483*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11485*/    OPC_RecordChild2, // #1 = $v2
/* 11486*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11488*/    OPC_RecordChild3, // #2 = $c
/* 11489*/    OPC_CheckChild3Type, MVT::v4f32,
/* 11491*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12138:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11499*/   /*SwitchType*/ 16, MVT::v2f64,// ->11517
/* 11501*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11503*/    OPC_RecordChild2, // #1 = $v2
/* 11504*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11506*/    OPC_RecordChild3, // #2 = $c
/* 11507*/    OPC_CheckChild3Type, MVT::v2f64,
/* 11509*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12138:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11517*/   0, // EndSwitchType
/* 11518*/  /*Scope*/ 37, /*->11556*/
/* 11519*/   OPC_CheckChild0Integer, 46|128,62|128,1/*24366*/, 
/* 11523*/   OPC_RecordChild1, // #0 = $lhs
/* 11524*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11540
/* 11527*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11529*/    OPC_RecordChild2, // #1 = $rhs
/* 11530*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11532*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11533*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12183:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11540*/   /*SwitchType*/ 13, MVT::v8i16,// ->11555
/* 11542*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11544*/    OPC_RecordChild2, // #1 = $rhs
/* 11545*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11547*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11548*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12183:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11555*/   0, // EndSwitchType
/* 11556*/  /*Scope*/ 37, /*->11594*/
/* 11557*/   OPC_CheckChild0Integer, 48|128,62|128,1/*24368*/, 
/* 11561*/   OPC_RecordChild1, // #0 = $lhs
/* 11562*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11578
/* 11565*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11567*/    OPC_RecordChild2, // #1 = $rhs
/* 11568*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11570*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11571*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12184:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11578*/   /*SwitchType*/ 13, MVT::v8i16,// ->11593
/* 11580*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11582*/    OPC_RecordChild2, // #1 = $rhs
/* 11583*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11585*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11586*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12184:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11593*/   0, // EndSwitchType
/* 11594*/  /*Scope*/ 37, /*->11632*/
/* 11595*/   OPC_CheckChild0Integer, 80|128,61|128,1/*24272*/, 
/* 11599*/   OPC_RecordChild1, // #0 = $lhs
/* 11600*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11616
/* 11603*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11605*/    OPC_RecordChild2, // #1 = $rhs
/* 11606*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11608*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11609*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12136:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11616*/   /*SwitchType*/ 13, MVT::v8i16,// ->11631
/* 11618*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11620*/    OPC_RecordChild2, // #1 = $rhs
/* 11621*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11623*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11624*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12136:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11631*/   0, // EndSwitchType
/* 11632*/  /*Scope*/ 14, /*->11647*/
/* 11633*/   OPC_CheckChild0Integer, 88|128,61|128,1/*24280*/, 
/* 11637*/   OPC_RecordChild1, // #0 = $lhs
/* 11638*/   OPC_RecordChild2, // #1 = $rhs
/* 11639*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11640*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12140:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11647*/  /*Scope*/ 37, /*->11685*/
/* 11648*/   OPC_CheckChild0Integer, 116|128,61|128,1/*24308*/, 
/* 11652*/   OPC_RecordChild1, // #0 = $low
/* 11653*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11669
/* 11656*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11658*/    OPC_RecordChild2, // #1 = $high
/* 11659*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11661*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11662*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12154:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11669*/   /*SwitchType*/ 13, MVT::v8i16,// ->11684
/* 11671*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11673*/    OPC_RecordChild2, // #1 = $high
/* 11674*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11676*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11677*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12154:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11684*/   0, // EndSwitchType
/* 11685*/  /*Scope*/ 37, /*->11723*/
/* 11686*/   OPC_CheckChild0Integer, 118|128,61|128,1/*24310*/, 
/* 11690*/   OPC_RecordChild1, // #0 = $low
/* 11691*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11707
/* 11694*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11696*/    OPC_RecordChild2, // #1 = $high
/* 11697*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11699*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11700*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12155:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11707*/   /*SwitchType*/ 13, MVT::v8i16,// ->11722
/* 11709*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11711*/    OPC_RecordChild2, // #1 = $high
/* 11712*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11714*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11715*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12155:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11722*/   0, // EndSwitchType
/* 11723*/  /*Scope*/ 29, /*->11753*/
/* 11724*/   OPC_CheckChild0Integer, 90|128,61|128,1/*24282*/, 
/* 11728*/   OPC_RecordChild1, // #0 = $vec
/* 11729*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11741
/* 11732*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11734*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11735*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12141:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11741*/   /*SwitchType*/ 9, MVT::v4i32,// ->11752
/* 11743*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11745*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11746*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12141:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11752*/   0, // EndSwitchType
/* 11753*/  /*Scope*/ 29, /*->11783*/
/* 11754*/   OPC_CheckChild0Integer, 92|128,61|128,1/*24284*/, 
/* 11758*/   OPC_RecordChild1, // #0 = $vec
/* 11759*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11771
/* 11762*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11764*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11765*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12142:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11771*/   /*SwitchType*/ 9, MVT::v4i32,// ->11782
/* 11773*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11775*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11776*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12142:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11782*/   0, // EndSwitchType
/* 11783*/  /*Scope*/ 14, /*->11798*/
/* 11784*/   OPC_CheckChild0Integer, 124|128,61|128,1/*24316*/, 
/* 11788*/   OPC_RecordChild1, // #0 = $lhs
/* 11789*/   OPC_RecordChild2, // #1 = $rhs
/* 11790*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11791*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12158:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11798*/  /*Scope*/ 14, /*->11813*/
/* 11799*/   OPC_CheckChild0Integer, 28|128,62|128,1/*24348*/, 
/* 11803*/   OPC_RecordChild1, // #0 = $src
/* 11804*/   OPC_RecordChild2, // #1 = $mask
/* 11805*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11806*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12174:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11813*/  /*Scope*/ 12, /*->11826*/
/* 11814*/   OPC_CheckChild0Integer, 30|128,62|128,1/*24350*/, 
/* 11818*/   OPC_RecordChild1, // #0 = $vec
/* 11819*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11820*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12175:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11826*/  /*Scope*/ 12, /*->11839*/
/* 11827*/   OPC_CheckChild0Integer, 34|128,62|128,1/*24354*/, 
/* 11831*/   OPC_RecordChild1, // #0 = $vec
/* 11832*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11833*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12177:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11839*/  /*Scope*/ 12, /*->11852*/
/* 11840*/   OPC_CheckChild0Integer, 32|128,62|128,1/*24352*/, 
/* 11844*/   OPC_RecordChild1, // #0 = $vec
/* 11845*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11846*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12176:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11852*/  /*Scope*/ 12, /*->11865*/
/* 11853*/   OPC_CheckChild0Integer, 36|128,62|128,1/*24356*/, 
/* 11857*/   OPC_RecordChild1, // #0 = $vec
/* 11858*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11859*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12178:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11865*/  /*Scope*/ 83, /*->11949*/
/* 11866*/   OPC_CheckChild0Integer, 16|128,62|128,1/*24336*/, 
/* 11870*/   OPC_RecordChild1, // #0 = $a
/* 11871*/   OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->11891
/* 11874*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11876*/    OPC_RecordChild2, // #1 = $b
/* 11877*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11879*/    OPC_RecordChild3, // #2 = $c
/* 11880*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11882*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11883*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12168:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 11891*/   /*SwitchType*/ 17, MVT::v8i16,// ->11910
/* 11893*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11895*/    OPC_RecordChild2, // #1 = $b
/* 11896*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11898*/    OPC_RecordChild3, // #2 = $c
/* 11899*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11901*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11902*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12168:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 11910*/   /*SwitchType*/ 17, MVT::v4i32,// ->11929
/* 11912*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11914*/    OPC_RecordChild2, // #1 = $b
/* 11915*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11917*/    OPC_RecordChild3, // #2 = $c
/* 11918*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11920*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11921*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12168:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 11929*/   /*SwitchType*/ 17, MVT::v2i64,// ->11948
/* 11931*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11933*/    OPC_RecordChild2, // #1 = $b
/* 11934*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11936*/    OPC_RecordChild3, // #2 = $c
/* 11937*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11939*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11940*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12168:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 11948*/   0, // EndSwitchType
/* 11949*/  /*Scope*/ 14, /*->11964*/
/* 11950*/   OPC_CheckChild0Integer, 26|128,62|128,1/*24346*/, 
/* 11954*/   OPC_RecordChild1, // #0 = $lhs
/* 11955*/   OPC_RecordChild2, // #1 = $rhs
/* 11956*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11957*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12173:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11964*/  /*Scope*/ 14, /*->11979*/
/* 11965*/   OPC_CheckChild0Integer, 14|128,62|128,1/*24334*/, 
/* 11969*/   OPC_RecordChild1, // #0 = $lhs
/* 11970*/   OPC_RecordChild2, // #1 = $rhs
/* 11971*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11972*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12167:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11979*/  /*Scope*/ 16, /*->11996*/
/* 11980*/   OPC_CheckChild0Integer, 12|128,62|128,1/*24332*/, 
/* 11984*/   OPC_RecordChild1, // #0 = $lhs
/* 11985*/   OPC_RecordChild2, // #1 = $rhs
/* 11986*/   OPC_RecordChild3, // #2 = $acc
/* 11987*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11988*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12166:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 11996*/  /*Scope*/ 13, /*->12010*/
/* 11997*/   OPC_CheckChild0Integer, 42|128,62|128,1/*24362*/, 
/* 12001*/   OPC_RecordChild1, // #0 = $x
/* 12002*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasHalfPrecision())
/* 12004*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12181:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 12010*/  /*Scope*/ 49, /*->12060*/
/* 12011*/   OPC_CheckChild0Integer, 122|128,61|128,1/*24314*/, 
/* 12015*/   OPC_RecordChild1, // #0 = $lhs
/* 12016*/   OPC_SwitchType /*3 cases */, 12, MVT::v4f32,// ->12031
/* 12019*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12021*/    OPC_RecordChild2, // #1 = $rhs
/* 12022*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12024*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12157:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12031*/   /*SwitchType*/ 12, MVT::v2f64,// ->12045
/* 12033*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12035*/    OPC_RecordChild2, // #1 = $rhs
/* 12036*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12038*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12157:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12045*/   /*SwitchType*/ 12, MVT::v8f16,// ->12059
/* 12047*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12049*/    OPC_RecordChild2, // #1 = $rhs
/* 12050*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12052*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  MVT::v8f16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12157:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12059*/   0, // EndSwitchType
/* 12060*/  /*Scope*/ 49, /*->12110*/
/* 12061*/   OPC_CheckChild0Integer, 120|128,61|128,1/*24312*/, 
/* 12065*/   OPC_RecordChild1, // #0 = $lhs
/* 12066*/   OPC_SwitchType /*3 cases */, 12, MVT::v4f32,// ->12081
/* 12069*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12071*/    OPC_RecordChild2, // #1 = $rhs
/* 12072*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12074*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12156:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12081*/   /*SwitchType*/ 12, MVT::v2f64,// ->12095
/* 12083*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12085*/    OPC_RecordChild2, // #1 = $rhs
/* 12086*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12088*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12156:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12095*/   /*SwitchType*/ 12, MVT::v8f16,// ->12109
/* 12097*/    OPC_CheckChild1Type, MVT::v8f16,
/* 12099*/    OPC_RecordChild2, // #1 = $rhs
/* 12100*/    OPC_CheckChild2Type, MVT::v8f16,
/* 12102*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  MVT::v8f16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12156:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12109*/   0, // EndSwitchType
/* 12110*/  /*Scope*/ 45, /*->12156*/
/* 12111*/   OPC_CheckChild0Integer, 18|128,62|128,1/*24338*/, 
/* 12115*/   OPC_RecordChild1, // #0 = $a
/* 12116*/   OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->12136
/* 12119*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12121*/    OPC_RecordChild2, // #1 = $b
/* 12122*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12124*/    OPC_RecordChild3, // #2 = $c
/* 12125*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12127*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12128*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12169:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12136*/   /*SwitchType*/ 17, MVT::v2f64,// ->12155
/* 12138*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12140*/    OPC_RecordChild2, // #1 = $b
/* 12141*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12143*/    OPC_RecordChild3, // #2 = $c
/* 12144*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12146*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12147*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12169:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12155*/   0, // EndSwitchType
/* 12156*/  /*Scope*/ 45, /*->12202*/
/* 12157*/   OPC_CheckChild0Integer, 24|128,62|128,1/*24344*/, 
/* 12161*/   OPC_RecordChild1, // #0 = $a
/* 12162*/   OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->12182
/* 12165*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12167*/    OPC_RecordChild2, // #1 = $b
/* 12168*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12170*/    OPC_RecordChild3, // #2 = $c
/* 12171*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12173*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12174*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12172:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12182*/   /*SwitchType*/ 17, MVT::v2f64,// ->12201
/* 12184*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12186*/    OPC_RecordChild2, // #1 = $b
/* 12187*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12189*/    OPC_RecordChild3, // #2 = $c
/* 12190*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12192*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12193*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12172:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12201*/   0, // EndSwitchType
/* 12202*/  /*Scope*/ 37, /*->12240*/
/* 12203*/   OPC_CheckChild0Integer, 22|128,62|128,1/*24342*/, 
/* 12207*/   OPC_RecordChild1, // #0 = $lhs
/* 12208*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->12224
/* 12211*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12213*/    OPC_RecordChild2, // #1 = $rhs
/* 12214*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12216*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12217*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12171:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12224*/   /*SwitchType*/ 13, MVT::v2f64,// ->12239
/* 12226*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12228*/    OPC_RecordChild2, // #1 = $rhs
/* 12229*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12231*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12232*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12171:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12239*/   0, // EndSwitchType
/* 12240*/  /*Scope*/ 37, /*->12278*/
/* 12241*/   OPC_CheckChild0Integer, 20|128,62|128,1/*24340*/, 
/* 12245*/   OPC_RecordChild1, // #0 = $lhs
/* 12246*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->12262
/* 12249*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12251*/    OPC_RecordChild2, // #1 = $rhs
/* 12252*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12254*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12255*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12170:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12262*/   /*SwitchType*/ 13, MVT::v2f64,// ->12277
/* 12264*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12266*/    OPC_RecordChild2, // #1 = $rhs
/* 12267*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12269*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12270*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12170:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12277*/   0, // EndSwitchType
/* 12278*/  /*Scope*/ 16, /*->12295*/
/* 12279*/   OPC_CheckChild0Integer, 10|128,62|128,1/*24330*/, 
/* 12283*/   OPC_RecordChild1, // #0 = $lhs
/* 12284*/   OPC_RecordChild2, // #1 = $rhs
/* 12285*/   OPC_RecordChild3, // #2 = $acc
/* 12286*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12287*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12165:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12295*/  0, /*End of Scope*/
/* 12296*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12431
/* 12300*/  OPC_RecordChild0, // #0 = $vec
/* 12301*/  OPC_Scope, 20, /*->12323*/ // 6 children in Scope
/* 12303*/   OPC_CheckChild0Type, MVT::v16i8,
/* 12305*/   OPC_RecordChild1, // #1 = $idx
/* 12306*/   OPC_MoveChild1,
/* 12307*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12310*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 12312*/   OPC_CheckTypeI32,
/* 12313*/   OPC_MoveParent,
/* 12314*/   OPC_CheckTypeI32,
/* 12315*/   OPC_EmitConvertToTarget1,
/* 12316*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12323*/  /*Scope*/ 20, /*->12344*/
/* 12324*/   OPC_CheckChild0Type, MVT::v8i16,
/* 12326*/   OPC_RecordChild1, // #1 = $idx
/* 12327*/   OPC_MoveChild1,
/* 12328*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12331*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 12333*/   OPC_CheckTypeI32,
/* 12334*/   OPC_MoveParent,
/* 12335*/   OPC_CheckTypeI32,
/* 12336*/   OPC_EmitConvertToTarget1,
/* 12337*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12344*/  /*Scope*/ 20, /*->12365*/
/* 12345*/   OPC_CheckChild0Type, MVT::v4i32,
/* 12347*/   OPC_RecordChild1, // #1 = $idx
/* 12348*/   OPC_MoveChild1,
/* 12349*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12352*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 12354*/   OPC_CheckTypeI32,
/* 12355*/   OPC_MoveParent,
/* 12356*/   OPC_CheckTypeI32,
/* 12357*/   OPC_EmitConvertToTarget1,
/* 12358*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12365*/  /*Scope*/ 20, /*->12386*/
/* 12366*/   OPC_CheckChild0Type, MVT::v2i64,
/* 12368*/   OPC_RecordChild1, // #1 = $idx
/* 12369*/   OPC_MoveChild1,
/* 12370*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12373*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 12375*/   OPC_CheckTypeI32,
/* 12376*/   OPC_MoveParent,
/* 12377*/   OPC_CheckTypeI64,
/* 12378*/   OPC_EmitConvertToTarget1,
/* 12379*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12386*/  /*Scope*/ 21, /*->12408*/
/* 12387*/   OPC_CheckChild0Type, MVT::v4f32,
/* 12389*/   OPC_RecordChild1, // #1 = $idx
/* 12390*/   OPC_MoveChild1,
/* 12391*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12394*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 12396*/   OPC_CheckTypeI32,
/* 12397*/   OPC_MoveParent,
/* 12398*/   OPC_CheckType, MVT::f32,
/* 12400*/   OPC_EmitConvertToTarget1,
/* 12401*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12408*/  /*Scope*/ 21, /*->12430*/
/* 12409*/   OPC_CheckChild0Type, MVT::v2f64,
/* 12411*/   OPC_RecordChild1, // #1 = $idx
/* 12412*/   OPC_MoveChild1,
/* 12413*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12416*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 12418*/   OPC_CheckTypeI32,
/* 12419*/   OPC_MoveParent,
/* 12420*/   OPC_CheckType, MVT::f64,
/* 12422*/   OPC_EmitConvertToTarget1,
/* 12423*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12430*/  0, /*End of Scope*/
/* 12431*/ /*SwitchOpcode*/ 120, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12554
/* 12434*/  OPC_RecordChild0, // #0 = $argno
/* 12435*/  OPC_MoveChild0,
/* 12436*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12439*/  OPC_MoveParent,
/* 12440*/  OPC_SwitchType /*14 cases */, 6, MVT::i32,// ->12449
/* 12443*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12449*/  /*SwitchType*/ 6, MVT::i64,// ->12457
/* 12451*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12457*/  /*SwitchType*/ 6, MVT::funcref,// ->12465
/* 12459*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12465*/  /*SwitchType*/ 6, MVT::externref,// ->12473
/* 12467*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12473*/  /*SwitchType*/ 6, MVT::exnref,// ->12481
/* 12475*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 MVT::exnref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12481*/  /*SwitchType*/ 6, MVT::f32,// ->12489
/* 12483*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12489*/  /*SwitchType*/ 6, MVT::f64,// ->12497
/* 12491*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12497*/  /*SwitchType*/ 6, MVT::v16i8,// ->12505
/* 12499*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12505*/  /*SwitchType*/ 6, MVT::v8i16,// ->12513
/* 12507*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12513*/  /*SwitchType*/ 6, MVT::v4i32,// ->12521
/* 12515*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12521*/  /*SwitchType*/ 6, MVT::v2i64,// ->12529
/* 12523*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12529*/  /*SwitchType*/ 6, MVT::v4f32,// ->12537
/* 12531*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12537*/  /*SwitchType*/ 6, MVT::v2f64,// ->12545
/* 12539*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12545*/  /*SwitchType*/ 6, MVT::v8f16,// ->12553
/* 12547*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12553*/  0, // EndSwitchType
/* 12554*/ /*SwitchOpcode*/ 18|128,1/*146*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12704
/* 12558*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12559*/  OPC_RecordChild1, // #1 = $local
/* 12560*/  OPC_MoveChild1,
/* 12561*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12564*/  OPC_MoveParent,
/* 12565*/  OPC_SwitchType /*14 cases */, 7, MVT::i32,// ->12575
/* 12568*/   OPC_EmitMergeInputChains1_0,
/* 12569*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12575*/  /*SwitchType*/ 7, MVT::i64,// ->12584
/* 12577*/   OPC_EmitMergeInputChains1_0,
/* 12578*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12584*/  /*SwitchType*/ 8, MVT::funcref,// ->12594
/* 12586*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12587*/   OPC_EmitMergeInputChains1_0,
/* 12588*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12594*/  /*SwitchType*/ 8, MVT::externref,// ->12604
/* 12596*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12597*/   OPC_EmitMergeInputChains1_0,
/* 12598*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12604*/  /*SwitchType*/ 9, MVT::exnref,// ->12615
/* 12606*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12608*/   OPC_EmitMergeInputChains1_0,
/* 12609*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 MVT::exnref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12615*/  /*SwitchType*/ 7, MVT::f32,// ->12624
/* 12617*/   OPC_EmitMergeInputChains1_0,
/* 12618*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12624*/  /*SwitchType*/ 7, MVT::f64,// ->12633
/* 12626*/   OPC_EmitMergeInputChains1_0,
/* 12627*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12633*/  /*SwitchType*/ 8, MVT::v2i64,// ->12643
/* 12635*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12636*/   OPC_EmitMergeInputChains1_0,
/* 12637*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12643*/  /*SwitchType*/ 8, MVT::v4i32,// ->12653
/* 12645*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12646*/   OPC_EmitMergeInputChains1_0,
/* 12647*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12653*/  /*SwitchType*/ 8, MVT::v16i8,// ->12663
/* 12655*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12656*/   OPC_EmitMergeInputChains1_0,
/* 12657*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12663*/  /*SwitchType*/ 8, MVT::v8i16,// ->12673
/* 12665*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12666*/   OPC_EmitMergeInputChains1_0,
/* 12667*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12673*/  /*SwitchType*/ 8, MVT::v8f16,// ->12683
/* 12675*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12676*/   OPC_EmitMergeInputChains1_0,
/* 12677*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8f16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 12683*/  /*SwitchType*/ 8, MVT::v4f32,// ->12693
/* 12685*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12686*/   OPC_EmitMergeInputChains1_0,
/* 12687*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12693*/  /*SwitchType*/ 8, MVT::v2f64,// ->12703
/* 12695*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12696*/   OPC_EmitMergeInputChains1_0,
/* 12697*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12703*/  0, // EndSwitchType
/* 12704*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->12867
/* 12708*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12709*/  OPC_RecordChild1, // #1 = $local
/* 12710*/  OPC_MoveChild1,
/* 12711*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12714*/  OPC_MoveParent,
/* 12715*/  OPC_RecordChild2, // #2 = $src
/* 12716*/  OPC_Scope, 8, /*->12726*/ // 14 children in Scope
/* 12718*/   OPC_CheckChild2TypeI32,
/* 12719*/   OPC_EmitMergeInputChains1_0,
/* 12720*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12726*/  /*Scope*/ 8, /*->12735*/
/* 12727*/   OPC_CheckChild2TypeI64,
/* 12728*/   OPC_EmitMergeInputChains1_0,
/* 12729*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12735*/  /*Scope*/ 9, /*->12745*/
/* 12736*/   OPC_CheckChild2Type, MVT::f32,
/* 12738*/   OPC_EmitMergeInputChains1_0,
/* 12739*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 12745*/  /*Scope*/ 9, /*->12755*/
/* 12746*/   OPC_CheckChild2Type, MVT::f64,
/* 12748*/   OPC_EmitMergeInputChains1_0,
/* 12749*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 12755*/  /*Scope*/ 10, /*->12766*/
/* 12756*/   OPC_CheckChild2Type, MVT::v8f16,
/* 12758*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12759*/   OPC_EmitMergeInputChains1_0,
/* 12760*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 12766*/  /*Scope*/ 10, /*->12777*/
/* 12767*/   OPC_CheckChild2Type, MVT::v4f32,
/* 12769*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12770*/   OPC_EmitMergeInputChains1_0,
/* 12771*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 12777*/  /*Scope*/ 10, /*->12788*/
/* 12778*/   OPC_CheckChild2Type, MVT::v2f64,
/* 12780*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12781*/   OPC_EmitMergeInputChains1_0,
/* 12782*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 12788*/  /*Scope*/ 10, /*->12799*/
/* 12789*/   OPC_CheckChild2Type, MVT::v2i64,
/* 12791*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12792*/   OPC_EmitMergeInputChains1_0,
/* 12793*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 12799*/  /*Scope*/ 10, /*->12810*/
/* 12800*/   OPC_CheckChild2Type, MVT::v4i32,
/* 12802*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12803*/   OPC_EmitMergeInputChains1_0,
/* 12804*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 12810*/  /*Scope*/ 10, /*->12821*/
/* 12811*/   OPC_CheckChild2Type, MVT::v16i8,
/* 12813*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12814*/   OPC_EmitMergeInputChains1_0,
/* 12815*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 12821*/  /*Scope*/ 10, /*->12832*/
/* 12822*/   OPC_CheckChild2Type, MVT::v8i16,
/* 12824*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12825*/   OPC_EmitMergeInputChains1_0,
/* 12826*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 12832*/  /*Scope*/ 10, /*->12843*/
/* 12833*/   OPC_CheckChild2Type, MVT::funcref,
/* 12835*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12836*/   OPC_EmitMergeInputChains1_0,
/* 12837*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 12843*/  /*Scope*/ 10, /*->12854*/
/* 12844*/   OPC_CheckChild2Type, MVT::externref,
/* 12846*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12847*/   OPC_EmitMergeInputChains1_0,
/* 12848*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 12854*/  /*Scope*/ 11, /*->12866*/
/* 12855*/   OPC_CheckChild2Type, MVT::exnref,
/* 12857*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12859*/   OPC_EmitMergeInputChains1_0,
/* 12860*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 12866*/  0, /*End of Scope*/
/* 12867*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->12999
/* 12871*/  OPC_RecordChild0, // #0 = $addr
/* 12872*/  OPC_MoveChild0,
/* 12873*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->12924
/* 12877*/   OPC_MoveParent,
/* 12878*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->12901
/* 12881*/    OPC_Scope, 8, /*->12891*/ // 2 children in Scope
/* 12883*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12885*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12891*/    /*Scope*/ 8, /*->12900*/
/* 12892*/     OPC_CheckPatternPredicate, 13, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12894*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12900*/    0, /*End of Scope*/
/* 12901*/   /*SwitchType*/ 20, MVT::i64,// ->12923
/* 12903*/    OPC_Scope, 8, /*->12913*/ // 2 children in Scope
/* 12905*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12907*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12913*/    /*Scope*/ 8, /*->12922*/
/* 12914*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12916*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12922*/    0, /*End of Scope*/
/* 12923*/   0, // EndSwitchType
/* 12924*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->12948
/* 12927*/   OPC_MoveParent,
/* 12928*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12938
/* 12931*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 12932*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 12938*/   /*SwitchType*/ 7, MVT::i64,// ->12947
/* 12940*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 12941*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 12947*/   0, // EndSwitchType
/* 12948*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->12998
/* 12951*/   OPC_MoveParent,
/* 12952*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->12975
/* 12955*/    OPC_Scope, 8, /*->12965*/ // 2 children in Scope
/* 12957*/     OPC_CheckPatternPredicate, 13, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12959*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 12965*/    /*Scope*/ 8, /*->12974*/
/* 12966*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12968*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 12974*/    0, /*End of Scope*/
/* 12975*/   /*SwitchType*/ 20, MVT::i64,// ->12997
/* 12977*/    OPC_Scope, 8, /*->12987*/ // 2 children in Scope
/* 12979*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12981*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 12987*/    /*Scope*/ 8, /*->12996*/
/* 12988*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12990*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 12996*/    0, /*End of Scope*/
/* 12997*/   0, // EndSwitchType
/* 12998*/  0, // EndSwitchOpcode
/* 12999*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13082
/* 13002*/  OPC_RecordChild0, // #0 = $addr
/* 13003*/  OPC_MoveChild0,
/* 13004*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13031
/* 13008*/   OPC_MoveParent,
/* 13009*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13020
/* 13012*/    OPC_CheckPatternPredicate, 13, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13014*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13020*/   /*SwitchType*/ 8, MVT::i64,// ->13030
/* 13022*/    OPC_CheckPatternPredicate, 14, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13024*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13030*/   0, // EndSwitchType
/* 13031*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13055
/* 13034*/   OPC_MoveParent,
/* 13035*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13045
/* 13038*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 13039*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13045*/   /*SwitchType*/ 7, MVT::i64,// ->13054
/* 13047*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 13048*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13054*/   0, // EndSwitchType
/* 13055*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13081
/* 13058*/   OPC_MoveParent,
/* 13059*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13070
/* 13062*/    OPC_CheckPatternPredicate, 13, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13064*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13070*/   /*SwitchType*/ 8, MVT::i64,// ->13080
/* 13072*/    OPC_CheckPatternPredicate, 14, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13074*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13080*/   0, // EndSwitchType
/* 13081*/  0, // EndSwitchOpcode
/* 13082*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->13132
/* 13085*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13086*/  OPC_RecordChild1, // #1 = $idx
/* 13087*/  OPC_MoveChild1,
/* 13088*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13091*/  OPC_CheckTypeI32,
/* 13092*/  OPC_MoveParent,
/* 13093*/  OPC_RecordChild2, // #2 = $dst
/* 13094*/  OPC_Scope, 17, /*->13113*/ // 2 children in Scope
/* 13096*/   OPC_CheckChild2TypeI32,
/* 13097*/   OPC_RecordChild3, // #3 = $value
/* 13098*/   OPC_CheckChild3TypeI32,
/* 13099*/   OPC_RecordChild4, // #4 = $size
/* 13100*/   OPC_CheckChild4TypeI32,
/* 13101*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13103*/   OPC_EmitMergeInputChains1_0,
/* 13104*/   OPC_EmitConvertToTarget1,
/* 13105*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8091MEMORY_FILL_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_8091MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13113*/  /*Scope*/ 17, /*->13131*/
/* 13114*/   OPC_CheckChild2TypeI64,
/* 13115*/   OPC_RecordChild3, // #3 = $value
/* 13116*/   OPC_CheckChild3TypeI32,
/* 13117*/   OPC_RecordChild4, // #4 = $size
/* 13118*/   OPC_CheckChild4TypeI64,
/* 13119*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13121*/   OPC_EmitMergeInputChains1_0,
/* 13122*/   OPC_EmitConvertToTarget1,
/* 13123*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8092MEMORY_FILL_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_8092MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13131*/  0, /*End of Scope*/
/* 13132*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13156
/* 13135*/  OPC_RecordNode, // #0 = $imm
/* 13136*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13146
/* 13139*/   OPC_EmitConvertToTarget0,
/* 13140*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13146*/  /*SwitchType*/ 7, MVT::i64,// ->13155
/* 13148*/   OPC_EmitConvertToTarget0,
/* 13149*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13155*/  0, // EndSwitchType
/* 13156*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13172
/* 13159*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13160*/  OPC_RecordChild1, // #1 = $dst
/* 13161*/  OPC_MoveChild1,
/* 13162*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13165*/  OPC_MoveParent,
/* 13166*/  OPC_EmitMergeInputChains1_0,
/* 13167*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13172*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13197
/* 13175*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13176*/  OPC_RecordChild1, // #1 = $index
/* 13177*/  OPC_Scope, 8, /*->13187*/ // 2 children in Scope
/* 13179*/   OPC_CheckChild1TypeI32,
/* 13180*/   OPC_EmitMergeInputChains1_0,
/* 13181*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13187*/  /*Scope*/ 8, /*->13196*/
/* 13188*/   OPC_CheckChild1TypeI64,
/* 13189*/   OPC_EmitMergeInputChains1_0,
/* 13190*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13196*/  0, /*End of Scope*/
/* 13197*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13207
/* 13200*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13201*/  OPC_EmitMergeInputChains1_0,
/* 13202*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13207*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13216
/* 13210*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13211*/  OPC_EmitMergeInputChains1_0,
/* 13212*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13216*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13225
/* 13219*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13220*/  OPC_EmitMergeInputChains1_0,
/* 13221*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13225*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::CLEANUPRET),// ->13236
/* 13228*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13229*/  OPC_CheckPatternPredicate, 15, // (Subtarget->hasExceptionHandling())
/* 13231*/  OPC_EmitMergeInputChains1_0,
/* 13232*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 13236*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13260
/* 13239*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13240*/  OPC_RecordChild1, // #1 = $dst
/* 13241*/  OPC_MoveChild1,
/* 13242*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13245*/  OPC_MoveSibling2,
/* 13246*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13249*/  OPC_RecordNode, // #2 = $from
/* 13250*/  OPC_MoveParent,
/* 13251*/  OPC_CheckPatternPredicate, 15, // (Subtarget->hasExceptionHandling())
/* 13253*/  OPC_EmitMergeInputChains1_0,
/* 13254*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13260*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13325
/* 13263*/  OPC_RecordChild0, // #0 = $lhs
/* 13264*/  OPC_RecordChild1, // #1 = $rhs
/* 13265*/  OPC_SwitchType /*6 cases */, 7, MVT::i32,// ->13275
/* 13268*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13275*/  /*SwitchType*/ 7, MVT::i64,// ->13284
/* 13277*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13284*/  /*SwitchType*/ 8, MVT::v16i8,// ->13294
/* 13286*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13287*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13294*/  /*SwitchType*/ 8, MVT::v8i16,// ->13304
/* 13296*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13297*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13304*/  /*SwitchType*/ 8, MVT::v4i32,// ->13314
/* 13306*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13307*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13314*/  /*SwitchType*/ 8, MVT::v2i64,// ->13324
/* 13316*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13317*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13324*/  0, // EndSwitchType
/* 13325*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13441
/* 13328*/  OPC_Scope, 22, /*->13352*/ // 3 children in Scope
/* 13330*/   OPC_RecordChild0, // #0 = $lhs
/* 13331*/   OPC_RecordChild1, // #1 = $rhs
/* 13332*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13342
/* 13335*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13342*/   /*SwitchType*/ 7, MVT::i64,// ->13351
/* 13344*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13351*/   0, // EndSwitchType
/* 13352*/  /*Scope*/ 42, /*->13395*/
/* 13353*/   OPC_MoveChild0,
/* 13354*/   OPC_CheckImmAllZerosV,
/* 13355*/   OPC_MoveParent,
/* 13356*/   OPC_RecordChild1, // #0 = $v
/* 13357*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->13367
/* 13360*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13361*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13367*/   /*SwitchType*/ 7, MVT::v8i16,// ->13376
/* 13369*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13370*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13376*/   /*SwitchType*/ 7, MVT::v4i32,// ->13385
/* 13378*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13379*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13385*/   /*SwitchType*/ 7, MVT::v2i64,// ->13394
/* 13387*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13388*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13394*/   0, // EndSwitchType
/* 13395*/  /*Scope*/ 44, /*->13440*/
/* 13396*/   OPC_RecordChild0, // #0 = $lhs
/* 13397*/   OPC_RecordChild1, // #1 = $rhs
/* 13398*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13409
/* 13401*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13402*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13409*/   /*SwitchType*/ 8, MVT::v8i16,// ->13419
/* 13411*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13412*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13419*/   /*SwitchType*/ 8, MVT::v4i32,// ->13429
/* 13421*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13422*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13429*/   /*SwitchType*/ 8, MVT::v2i64,// ->13439
/* 13431*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13432*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13439*/   0, // EndSwitchType
/* 13440*/  0, /*End of Scope*/
/* 13441*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->13786
/* 13445*/  OPC_Scope, 22, /*->13469*/ // 3 children in Scope
/* 13447*/   OPC_RecordChild0, // #0 = $lhs
/* 13448*/   OPC_RecordChild1, // #1 = $rhs
/* 13449*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13459
/* 13452*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13459*/   /*SwitchType*/ 7, MVT::i64,// ->13468
/* 13461*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13468*/   0, // EndSwitchType
/* 13469*/  /*Scope*/ 23|128,2/*279*/, /*->13750*/
/* 13471*/   OPC_MoveChild0,
/* 13472*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13542
/* 13476*/    OPC_RecordChild0, // #0 = $lhs
/* 13477*/    OPC_Scope, 20, /*->13499*/ // 3 children in Scope
/* 13479*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13481*/     OPC_MoveSibling1,
/* 13482*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13485*/     OPC_RecordChild0, // #1 = $rhs
/* 13486*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13488*/     OPC_MoveParent,
/* 13489*/     OPC_CheckType, MVT::v8i16,
/* 13491*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13492*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13499*/    /*Scope*/ 20, /*->13520*/
/* 13500*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13502*/     OPC_MoveSibling1,
/* 13503*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13506*/     OPC_RecordChild0, // #1 = $rhs
/* 13507*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13509*/     OPC_MoveParent,
/* 13510*/     OPC_CheckType, MVT::v4i32,
/* 13512*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13513*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13520*/    /*Scope*/ 20, /*->13541*/
/* 13521*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13523*/     OPC_MoveSibling1,
/* 13524*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13527*/     OPC_RecordChild0, // #1 = $rhs
/* 13528*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13530*/     OPC_MoveParent,
/* 13531*/     OPC_CheckType, MVT::v2i64,
/* 13533*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13534*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13541*/    0, /*End of Scope*/
/* 13542*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13611
/* 13545*/    OPC_RecordChild0, // #0 = $lhs
/* 13546*/    OPC_Scope, 20, /*->13568*/ // 3 children in Scope
/* 13548*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13550*/     OPC_MoveSibling1,
/* 13551*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13554*/     OPC_RecordChild0, // #1 = $rhs
/* 13555*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13557*/     OPC_MoveParent,
/* 13558*/     OPC_CheckType, MVT::v8i16,
/* 13560*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13561*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13568*/    /*Scope*/ 20, /*->13589*/
/* 13569*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13571*/     OPC_MoveSibling1,
/* 13572*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13575*/     OPC_RecordChild0, // #1 = $rhs
/* 13576*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13578*/     OPC_MoveParent,
/* 13579*/     OPC_CheckType, MVT::v4i32,
/* 13581*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13582*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13589*/    /*Scope*/ 20, /*->13610*/
/* 13590*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13592*/     OPC_MoveSibling1,
/* 13593*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13596*/     OPC_RecordChild0, // #1 = $rhs
/* 13597*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13599*/     OPC_MoveParent,
/* 13600*/     OPC_CheckType, MVT::v2i64,
/* 13602*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13603*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13610*/    0, /*End of Scope*/
/* 13611*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13680
/* 13614*/    OPC_RecordChild0, // #0 = $lhs
/* 13615*/    OPC_Scope, 20, /*->13637*/ // 3 children in Scope
/* 13617*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13619*/     OPC_MoveSibling1,
/* 13620*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13623*/     OPC_RecordChild0, // #1 = $rhs
/* 13624*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13626*/     OPC_MoveParent,
/* 13627*/     OPC_CheckType, MVT::v8i16,
/* 13629*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13630*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13637*/    /*Scope*/ 20, /*->13658*/
/* 13638*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13640*/     OPC_MoveSibling1,
/* 13641*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13644*/     OPC_RecordChild0, // #1 = $rhs
/* 13645*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13647*/     OPC_MoveParent,
/* 13648*/     OPC_CheckType, MVT::v4i32,
/* 13650*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13651*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13658*/    /*Scope*/ 20, /*->13679*/
/* 13659*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13661*/     OPC_MoveSibling1,
/* 13662*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13665*/     OPC_RecordChild0, // #1 = $rhs
/* 13666*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13668*/     OPC_MoveParent,
/* 13669*/     OPC_CheckType, MVT::v2i64,
/* 13671*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13672*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13679*/    0, /*End of Scope*/
/* 13680*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->13749
/* 13683*/    OPC_RecordChild0, // #0 = $lhs
/* 13684*/    OPC_Scope, 20, /*->13706*/ // 3 children in Scope
/* 13686*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13688*/     OPC_MoveSibling1,
/* 13689*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13692*/     OPC_RecordChild0, // #1 = $rhs
/* 13693*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13695*/     OPC_MoveParent,
/* 13696*/     OPC_CheckType, MVT::v8i16,
/* 13698*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13699*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13706*/    /*Scope*/ 20, /*->13727*/
/* 13707*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13709*/     OPC_MoveSibling1,
/* 13710*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13713*/     OPC_RecordChild0, // #1 = $rhs
/* 13714*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13716*/     OPC_MoveParent,
/* 13717*/     OPC_CheckType, MVT::v4i32,
/* 13719*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13720*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13727*/    /*Scope*/ 20, /*->13748*/
/* 13728*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13730*/     OPC_MoveSibling1,
/* 13731*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13734*/     OPC_RecordChild0, // #1 = $rhs
/* 13735*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13737*/     OPC_MoveParent,
/* 13738*/     OPC_CheckType, MVT::v2i64,
/* 13740*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13741*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13748*/    0, /*End of Scope*/
/* 13749*/   0, // EndSwitchOpcode
/* 13750*/  /*Scope*/ 34, /*->13785*/
/* 13751*/   OPC_RecordChild0, // #0 = $lhs
/* 13752*/   OPC_RecordChild1, // #1 = $rhs
/* 13753*/   OPC_SwitchType /*3 cases */, 8, MVT::v8i16,// ->13764
/* 13756*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13757*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13764*/   /*SwitchType*/ 8, MVT::v4i32,// ->13774
/* 13766*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13767*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13774*/   /*SwitchType*/ 8, MVT::v2i64,// ->13784
/* 13776*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13777*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13784*/   0, // EndSwitchType
/* 13785*/  0, /*End of Scope*/
/* 13786*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->13811
/* 13789*/  OPC_RecordChild0, // #0 = $lhs
/* 13790*/  OPC_RecordChild1, // #1 = $rhs
/* 13791*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13801
/* 13794*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13801*/  /*SwitchType*/ 7, MVT::i64,// ->13810
/* 13803*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13810*/  0, // EndSwitchType
/* 13811*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->13836
/* 13814*/  OPC_RecordChild0, // #0 = $lhs
/* 13815*/  OPC_RecordChild1, // #1 = $rhs
/* 13816*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13826
/* 13819*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13826*/  /*SwitchType*/ 7, MVT::i64,// ->13835
/* 13828*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13835*/  0, // EndSwitchType
/* 13836*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->13861
/* 13839*/  OPC_RecordChild0, // #0 = $lhs
/* 13840*/  OPC_RecordChild1, // #1 = $rhs
/* 13841*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13851
/* 13844*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13851*/  /*SwitchType*/ 7, MVT::i64,// ->13860
/* 13853*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13860*/  0, // EndSwitchType
/* 13861*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->13886
/* 13864*/  OPC_RecordChild0, // #0 = $lhs
/* 13865*/  OPC_RecordChild1, // #1 = $rhs
/* 13866*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13876
/* 13869*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13876*/  /*SwitchType*/ 7, MVT::i64,// ->13885
/* 13878*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13885*/  0, // EndSwitchType
/* 13886*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14714
/* 13890*/  OPC_Scope, 22, /*->13914*/ // 3 children in Scope
/* 13892*/   OPC_RecordChild0, // #0 = $lhs
/* 13893*/   OPC_RecordChild1, // #1 = $rhs
/* 13894*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13904
/* 13897*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13904*/   /*SwitchType*/ 7, MVT::i64,// ->13913
/* 13906*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13913*/   0, // EndSwitchType
/* 13914*/  /*Scope*/ 116|128,5/*756*/, /*->14672*/
/* 13916*/   OPC_MoveChild0,
/* 13917*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13920*/   OPC_Scope, 4|128,1/*132*/, /*->14055*/ // 9 children in Scope
/* 13923*/    OPC_RecordChild0, // #0 = $c
/* 13924*/    OPC_RecordChild1, // #1 = $v1
/* 13925*/    OPC_MoveSibling1,
/* 13926*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13929*/    OPC_Scope, 54, /*->13985*/ // 4 children in Scope
/* 13931*/     OPC_MoveChild0,
/* 13932*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13935*/     OPC_CheckChild0Same, 0,
/* 13937*/     OPC_MoveChild1,
/* 13938*/     OPC_CheckImmAllOnesV,
/* 13939*/     OPC_MoveParent,
/* 13940*/     OPC_MoveParent,
/* 13941*/     OPC_RecordChild1, // #2 = $v2
/* 13942*/     OPC_MoveParent,
/* 13943*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13954
/* 13946*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13954*/     /*SwitchType*/ 8, MVT::v8i16,// ->13964
/* 13956*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13964*/     /*SwitchType*/ 8, MVT::v4i32,// ->13974
/* 13966*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13974*/     /*SwitchType*/ 8, MVT::v2i64,// ->13984
/* 13976*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 13984*/     0, // EndSwitchType
/* 13985*/    /*Scope*/ 22, /*->14008*/
/* 13986*/     OPC_RecordChild0, // #2 = $v2
/* 13987*/     OPC_MoveChild1,
/* 13988*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13991*/     OPC_CheckChild0Same, 0,
/* 13993*/     OPC_MoveChild1,
/* 13994*/     OPC_CheckImmAllOnesV,
/* 13995*/     OPC_MoveParent,
/* 13996*/     OPC_MoveParent,
/* 13997*/     OPC_MoveParent,
/* 13998*/     OPC_CheckType, MVT::v16i8,
/* 14000*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14008*/    /*Scope*/ 22, /*->14031*/
/* 14009*/     OPC_MoveChild0,
/* 14010*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14013*/     OPC_CheckChild0Same, 1,
/* 14015*/     OPC_MoveChild1,
/* 14016*/     OPC_CheckImmAllOnesV,
/* 14017*/     OPC_MoveParent,
/* 14018*/     OPC_MoveParent,
/* 14019*/     OPC_RecordChild1, // #2 = $v2
/* 14020*/     OPC_MoveParent,
/* 14021*/     OPC_CheckType, MVT::v16i8,
/* 14023*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14031*/    /*Scope*/ 22, /*->14054*/
/* 14032*/     OPC_RecordChild0, // #2 = $v2
/* 14033*/     OPC_MoveChild1,
/* 14034*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14037*/     OPC_CheckChild0Same, 1,
/* 14039*/     OPC_MoveChild1,
/* 14040*/     OPC_CheckImmAllOnesV,
/* 14041*/     OPC_MoveParent,
/* 14042*/     OPC_MoveParent,
/* 14043*/     OPC_MoveParent,
/* 14044*/     OPC_CheckType, MVT::v16i8,
/* 14046*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14054*/    0, /*End of Scope*/
/* 14055*/   /*Scope*/ 46, /*->14102*/
/* 14056*/    OPC_MoveChild0,
/* 14057*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14060*/    OPC_RecordChild0, // #0 = $c
/* 14061*/    OPC_MoveChild1,
/* 14062*/    OPC_CheckImmAllOnesV,
/* 14063*/    OPC_MoveParent,
/* 14064*/    OPC_MoveParent,
/* 14065*/    OPC_RecordChild1, // #1 = $v2
/* 14066*/    OPC_MoveSibling1,
/* 14067*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14070*/    OPC_Scope, 14, /*->14086*/ // 2 children in Scope
/* 14072*/     OPC_CheckChild0Same, 0,
/* 14074*/     OPC_RecordChild1, // #2 = $v1
/* 14075*/     OPC_MoveParent,
/* 14076*/     OPC_CheckType, MVT::v16i8,
/* 14078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14086*/    /*Scope*/ 14, /*->14101*/
/* 14087*/     OPC_RecordChild0, // #2 = $v1
/* 14088*/     OPC_CheckChild1Same, 0,
/* 14090*/     OPC_MoveParent,
/* 14091*/     OPC_CheckType, MVT::v16i8,
/* 14093*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14101*/    0, /*End of Scope*/
/* 14102*/   /*Scope*/ 126, /*->14229*/
/* 14103*/    OPC_RecordChild0, // #0 = $v2
/* 14104*/    OPC_Scope, 45, /*->14151*/ // 2 children in Scope
/* 14106*/     OPC_MoveChild1,
/* 14107*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14110*/     OPC_RecordChild0, // #1 = $c
/* 14111*/     OPC_MoveChild1,
/* 14112*/     OPC_CheckImmAllOnesV,
/* 14113*/     OPC_MoveParent,
/* 14114*/     OPC_MoveParent,
/* 14115*/     OPC_MoveSibling1,
/* 14116*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14119*/     OPC_Scope, 14, /*->14135*/ // 2 children in Scope
/* 14121*/      OPC_CheckChild0Same, 1,
/* 14123*/      OPC_RecordChild1, // #2 = $v1
/* 14124*/      OPC_MoveParent,
/* 14125*/      OPC_CheckType, MVT::v16i8,
/* 14127*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14135*/     /*Scope*/ 14, /*->14150*/
/* 14136*/      OPC_RecordChild0, // #2 = $v1
/* 14137*/      OPC_CheckChild1Same, 1,
/* 14139*/      OPC_MoveParent,
/* 14140*/      OPC_CheckType, MVT::v16i8,
/* 14142*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14150*/     0, /*End of Scope*/
/* 14151*/    /*Scope*/ 76, /*->14228*/
/* 14152*/     OPC_RecordChild1, // #1 = $v1
/* 14153*/     OPC_MoveSibling1,
/* 14154*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14157*/     OPC_Scope, 22, /*->14181*/ // 3 children in Scope
/* 14159*/      OPC_RecordChild0, // #2 = $v2
/* 14160*/      OPC_MoveChild1,
/* 14161*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14164*/      OPC_CheckChild0Same, 0,
/* 14166*/      OPC_MoveChild1,
/* 14167*/      OPC_CheckImmAllOnesV,
/* 14168*/      OPC_MoveParent,
/* 14169*/      OPC_MoveParent,
/* 14170*/      OPC_MoveParent,
/* 14171*/      OPC_CheckType, MVT::v8i16,
/* 14173*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14181*/     /*Scope*/ 22, /*->14204*/
/* 14182*/      OPC_MoveChild0,
/* 14183*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14186*/      OPC_CheckChild0Same, 1,
/* 14188*/      OPC_MoveChild1,
/* 14189*/      OPC_CheckImmAllOnesV,
/* 14190*/      OPC_MoveParent,
/* 14191*/      OPC_MoveParent,
/* 14192*/      OPC_RecordChild1, // #2 = $v2
/* 14193*/      OPC_MoveParent,
/* 14194*/      OPC_CheckType, MVT::v8i16,
/* 14196*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14204*/     /*Scope*/ 22, /*->14227*/
/* 14205*/      OPC_RecordChild0, // #2 = $v2
/* 14206*/      OPC_MoveChild1,
/* 14207*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14210*/      OPC_CheckChild0Same, 1,
/* 14212*/      OPC_MoveChild1,
/* 14213*/      OPC_CheckImmAllOnesV,
/* 14214*/      OPC_MoveParent,
/* 14215*/      OPC_MoveParent,
/* 14216*/      OPC_MoveParent,
/* 14217*/      OPC_CheckType, MVT::v8i16,
/* 14219*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14227*/     0, /*End of Scope*/
/* 14228*/    0, /*End of Scope*/
/* 14229*/   /*Scope*/ 46, /*->14276*/
/* 14230*/    OPC_MoveChild0,
/* 14231*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14234*/    OPC_RecordChild0, // #0 = $c
/* 14235*/    OPC_MoveChild1,
/* 14236*/    OPC_CheckImmAllOnesV,
/* 14237*/    OPC_MoveParent,
/* 14238*/    OPC_MoveParent,
/* 14239*/    OPC_RecordChild1, // #1 = $v2
/* 14240*/    OPC_MoveSibling1,
/* 14241*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14244*/    OPC_Scope, 14, /*->14260*/ // 2 children in Scope
/* 14246*/     OPC_CheckChild0Same, 0,
/* 14248*/     OPC_RecordChild1, // #2 = $v1
/* 14249*/     OPC_MoveParent,
/* 14250*/     OPC_CheckType, MVT::v8i16,
/* 14252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14260*/    /*Scope*/ 14, /*->14275*/
/* 14261*/     OPC_RecordChild0, // #2 = $v1
/* 14262*/     OPC_CheckChild1Same, 0,
/* 14264*/     OPC_MoveParent,
/* 14265*/     OPC_CheckType, MVT::v8i16,
/* 14267*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14275*/    0, /*End of Scope*/
/* 14276*/   /*Scope*/ 126, /*->14403*/
/* 14277*/    OPC_RecordChild0, // #0 = $v2
/* 14278*/    OPC_Scope, 45, /*->14325*/ // 2 children in Scope
/* 14280*/     OPC_MoveChild1,
/* 14281*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14284*/     OPC_RecordChild0, // #1 = $c
/* 14285*/     OPC_MoveChild1,
/* 14286*/     OPC_CheckImmAllOnesV,
/* 14287*/     OPC_MoveParent,
/* 14288*/     OPC_MoveParent,
/* 14289*/     OPC_MoveSibling1,
/* 14290*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14293*/     OPC_Scope, 14, /*->14309*/ // 2 children in Scope
/* 14295*/      OPC_CheckChild0Same, 1,
/* 14297*/      OPC_RecordChild1, // #2 = $v1
/* 14298*/      OPC_MoveParent,
/* 14299*/      OPC_CheckType, MVT::v8i16,
/* 14301*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14309*/     /*Scope*/ 14, /*->14324*/
/* 14310*/      OPC_RecordChild0, // #2 = $v1
/* 14311*/      OPC_CheckChild1Same, 1,
/* 14313*/      OPC_MoveParent,
/* 14314*/      OPC_CheckType, MVT::v8i16,
/* 14316*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14324*/     0, /*End of Scope*/
/* 14325*/    /*Scope*/ 76, /*->14402*/
/* 14326*/     OPC_RecordChild1, // #1 = $v1
/* 14327*/     OPC_MoveSibling1,
/* 14328*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14331*/     OPC_Scope, 22, /*->14355*/ // 3 children in Scope
/* 14333*/      OPC_RecordChild0, // #2 = $v2
/* 14334*/      OPC_MoveChild1,
/* 14335*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14338*/      OPC_CheckChild0Same, 0,
/* 14340*/      OPC_MoveChild1,
/* 14341*/      OPC_CheckImmAllOnesV,
/* 14342*/      OPC_MoveParent,
/* 14343*/      OPC_MoveParent,
/* 14344*/      OPC_MoveParent,
/* 14345*/      OPC_CheckType, MVT::v4i32,
/* 14347*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14355*/     /*Scope*/ 22, /*->14378*/
/* 14356*/      OPC_MoveChild0,
/* 14357*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14360*/      OPC_CheckChild0Same, 1,
/* 14362*/      OPC_MoveChild1,
/* 14363*/      OPC_CheckImmAllOnesV,
/* 14364*/      OPC_MoveParent,
/* 14365*/      OPC_MoveParent,
/* 14366*/      OPC_RecordChild1, // #2 = $v2
/* 14367*/      OPC_MoveParent,
/* 14368*/      OPC_CheckType, MVT::v4i32,
/* 14370*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14378*/     /*Scope*/ 22, /*->14401*/
/* 14379*/      OPC_RecordChild0, // #2 = $v2
/* 14380*/      OPC_MoveChild1,
/* 14381*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14384*/      OPC_CheckChild0Same, 1,
/* 14386*/      OPC_MoveChild1,
/* 14387*/      OPC_CheckImmAllOnesV,
/* 14388*/      OPC_MoveParent,
/* 14389*/      OPC_MoveParent,
/* 14390*/      OPC_MoveParent,
/* 14391*/      OPC_CheckType, MVT::v4i32,
/* 14393*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14401*/     0, /*End of Scope*/
/* 14402*/    0, /*End of Scope*/
/* 14403*/   /*Scope*/ 46, /*->14450*/
/* 14404*/    OPC_MoveChild0,
/* 14405*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14408*/    OPC_RecordChild0, // #0 = $c
/* 14409*/    OPC_MoveChild1,
/* 14410*/    OPC_CheckImmAllOnesV,
/* 14411*/    OPC_MoveParent,
/* 14412*/    OPC_MoveParent,
/* 14413*/    OPC_RecordChild1, // #1 = $v2
/* 14414*/    OPC_MoveSibling1,
/* 14415*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14418*/    OPC_Scope, 14, /*->14434*/ // 2 children in Scope
/* 14420*/     OPC_CheckChild0Same, 0,
/* 14422*/     OPC_RecordChild1, // #2 = $v1
/* 14423*/     OPC_MoveParent,
/* 14424*/     OPC_CheckType, MVT::v4i32,
/* 14426*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14434*/    /*Scope*/ 14, /*->14449*/
/* 14435*/     OPC_RecordChild0, // #2 = $v1
/* 14436*/     OPC_CheckChild1Same, 0,
/* 14438*/     OPC_MoveParent,
/* 14439*/     OPC_CheckType, MVT::v4i32,
/* 14441*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14449*/    0, /*End of Scope*/
/* 14450*/   /*Scope*/ 126, /*->14577*/
/* 14451*/    OPC_RecordChild0, // #0 = $v2
/* 14452*/    OPC_Scope, 45, /*->14499*/ // 2 children in Scope
/* 14454*/     OPC_MoveChild1,
/* 14455*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14458*/     OPC_RecordChild0, // #1 = $c
/* 14459*/     OPC_MoveChild1,
/* 14460*/     OPC_CheckImmAllOnesV,
/* 14461*/     OPC_MoveParent,
/* 14462*/     OPC_MoveParent,
/* 14463*/     OPC_MoveSibling1,
/* 14464*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14467*/     OPC_Scope, 14, /*->14483*/ // 2 children in Scope
/* 14469*/      OPC_CheckChild0Same, 1,
/* 14471*/      OPC_RecordChild1, // #2 = $v1
/* 14472*/      OPC_MoveParent,
/* 14473*/      OPC_CheckType, MVT::v4i32,
/* 14475*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14483*/     /*Scope*/ 14, /*->14498*/
/* 14484*/      OPC_RecordChild0, // #2 = $v1
/* 14485*/      OPC_CheckChild1Same, 1,
/* 14487*/      OPC_MoveParent,
/* 14488*/      OPC_CheckType, MVT::v4i32,
/* 14490*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14498*/     0, /*End of Scope*/
/* 14499*/    /*Scope*/ 76, /*->14576*/
/* 14500*/     OPC_RecordChild1, // #1 = $v1
/* 14501*/     OPC_MoveSibling1,
/* 14502*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14505*/     OPC_Scope, 22, /*->14529*/ // 3 children in Scope
/* 14507*/      OPC_RecordChild0, // #2 = $v2
/* 14508*/      OPC_MoveChild1,
/* 14509*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14512*/      OPC_CheckChild0Same, 0,
/* 14514*/      OPC_MoveChild1,
/* 14515*/      OPC_CheckImmAllOnesV,
/* 14516*/      OPC_MoveParent,
/* 14517*/      OPC_MoveParent,
/* 14518*/      OPC_MoveParent,
/* 14519*/      OPC_CheckType, MVT::v2i64,
/* 14521*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14529*/     /*Scope*/ 22, /*->14552*/
/* 14530*/      OPC_MoveChild0,
/* 14531*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14534*/      OPC_CheckChild0Same, 1,
/* 14536*/      OPC_MoveChild1,
/* 14537*/      OPC_CheckImmAllOnesV,
/* 14538*/      OPC_MoveParent,
/* 14539*/      OPC_MoveParent,
/* 14540*/      OPC_RecordChild1, // #2 = $v2
/* 14541*/      OPC_MoveParent,
/* 14542*/      OPC_CheckType, MVT::v2i64,
/* 14544*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14552*/     /*Scope*/ 22, /*->14575*/
/* 14553*/      OPC_RecordChild0, // #2 = $v2
/* 14554*/      OPC_MoveChild1,
/* 14555*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14558*/      OPC_CheckChild0Same, 1,
/* 14560*/      OPC_MoveChild1,
/* 14561*/      OPC_CheckImmAllOnesV,
/* 14562*/      OPC_MoveParent,
/* 14563*/      OPC_MoveParent,
/* 14564*/      OPC_MoveParent,
/* 14565*/      OPC_CheckType, MVT::v2i64,
/* 14567*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14575*/     0, /*End of Scope*/
/* 14576*/    0, /*End of Scope*/
/* 14577*/   /*Scope*/ 46, /*->14624*/
/* 14578*/    OPC_MoveChild0,
/* 14579*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14582*/    OPC_RecordChild0, // #0 = $c
/* 14583*/    OPC_MoveChild1,
/* 14584*/    OPC_CheckImmAllOnesV,
/* 14585*/    OPC_MoveParent,
/* 14586*/    OPC_MoveParent,
/* 14587*/    OPC_RecordChild1, // #1 = $v2
/* 14588*/    OPC_MoveSibling1,
/* 14589*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14592*/    OPC_Scope, 14, /*->14608*/ // 2 children in Scope
/* 14594*/     OPC_CheckChild0Same, 0,
/* 14596*/     OPC_RecordChild1, // #2 = $v1
/* 14597*/     OPC_MoveParent,
/* 14598*/     OPC_CheckType, MVT::v2i64,
/* 14600*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14608*/    /*Scope*/ 14, /*->14623*/
/* 14609*/     OPC_RecordChild0, // #2 = $v1
/* 14610*/     OPC_CheckChild1Same, 0,
/* 14612*/     OPC_MoveParent,
/* 14613*/     OPC_CheckType, MVT::v2i64,
/* 14615*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14623*/    0, /*End of Scope*/
/* 14624*/   /*Scope*/ 46, /*->14671*/
/* 14625*/    OPC_RecordChild0, // #0 = $v2
/* 14626*/    OPC_MoveChild1,
/* 14627*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14630*/    OPC_RecordChild0, // #1 = $c
/* 14631*/    OPC_MoveChild1,
/* 14632*/    OPC_CheckImmAllOnesV,
/* 14633*/    OPC_MoveParent,
/* 14634*/    OPC_MoveParent,
/* 14635*/    OPC_MoveSibling1,
/* 14636*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14639*/    OPC_Scope, 14, /*->14655*/ // 2 children in Scope
/* 14641*/     OPC_CheckChild0Same, 1,
/* 14643*/     OPC_RecordChild1, // #2 = $v1
/* 14644*/     OPC_MoveParent,
/* 14645*/     OPC_CheckType, MVT::v2i64,
/* 14647*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14655*/    /*Scope*/ 14, /*->14670*/
/* 14656*/     OPC_RecordChild0, // #2 = $v1
/* 14657*/     OPC_CheckChild1Same, 1,
/* 14659*/     OPC_MoveParent,
/* 14660*/     OPC_CheckType, MVT::v2i64,
/* 14662*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14670*/    0, /*End of Scope*/
/* 14671*/   0, /*End of Scope*/
/* 14672*/  /*Scope*/ 40, /*->14713*/
/* 14673*/   OPC_RecordChild0, // #0 = $lhs
/* 14674*/   OPC_RecordChild1, // #1 = $rhs
/* 14675*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->14685
/* 14678*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14685*/   /*SwitchType*/ 7, MVT::v8i16,// ->14694
/* 14687*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14694*/   /*SwitchType*/ 7, MVT::v4i32,// ->14703
/* 14696*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14703*/   /*SwitchType*/ 7, MVT::v2i64,// ->14712
/* 14705*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14712*/   0, // EndSwitchType
/* 14713*/  0, /*End of Scope*/
/* 14714*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16247
/* 14718*/  OPC_Scope, 22, /*->14742*/ // 17 children in Scope
/* 14720*/   OPC_RecordChild0, // #0 = $lhs
/* 14721*/   OPC_RecordChild1, // #1 = $rhs
/* 14722*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14732
/* 14725*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14732*/   /*SwitchType*/ 7, MVT::i64,// ->14741
/* 14734*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14741*/   0, // EndSwitchType
/* 14742*/  /*Scope*/ 121, /*->14864*/
/* 14743*/   OPC_MoveChild0,
/* 14744*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14747*/   OPC_MoveChild0,
/* 14748*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14751*/   OPC_RecordChild0, // #0 = $v1
/* 14752*/   OPC_Scope, 71, /*->14825*/ // 2 children in Scope
/* 14754*/    OPC_RecordChild1, // #1 = $v2
/* 14755*/    OPC_MoveSibling1,
/* 14756*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14759*/    OPC_RecordChild0, // #2 = $c
/* 14760*/    OPC_MoveChild1,
/* 14761*/    OPC_CheckImmAllOnesV,
/* 14762*/    OPC_MoveParent,
/* 14763*/    OPC_MoveParent,
/* 14764*/    OPC_MoveParent,
/* 14765*/    OPC_Scope, 44, /*->14811*/ // 2 children in Scope
/* 14767*/     OPC_CheckChild1Same, 1,
/* 14769*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->14780
/* 14772*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14780*/     /*SwitchType*/ 8, MVT::v8i16,// ->14790
/* 14782*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14790*/     /*SwitchType*/ 8, MVT::v4i32,// ->14800
/* 14792*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14800*/     /*SwitchType*/ 8, MVT::v2i64,// ->14810
/* 14802*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14810*/     0, // EndSwitchType
/* 14811*/    /*Scope*/ 12, /*->14824*/
/* 14812*/     OPC_CheckChild1Same, 0,
/* 14814*/     OPC_CheckType, MVT::v16i8,
/* 14816*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14824*/    0, /*End of Scope*/
/* 14825*/   /*Scope*/ 37, /*->14863*/
/* 14826*/    OPC_MoveChild1,
/* 14827*/    OPC_CheckImmAllOnesV,
/* 14828*/    OPC_MoveParent,
/* 14829*/    OPC_MoveSibling1,
/* 14830*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14833*/    OPC_RecordChild0, // #1 = $v1
/* 14834*/    OPC_RecordChild1, // #2 = $v2
/* 14835*/    OPC_MoveParent,
/* 14836*/    OPC_MoveParent,
/* 14837*/    OPC_CheckType, MVT::v16i8,
/* 14839*/    OPC_Scope, 10, /*->14851*/ // 2 children in Scope
/* 14841*/     OPC_CheckChild1Same, 2,
/* 14843*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14851*/    /*Scope*/ 10, /*->14862*/
/* 14852*/     OPC_CheckChild1Same, 1,
/* 14854*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14862*/    0, /*End of Scope*/
/* 14863*/   0, /*End of Scope*/
/* 14864*/  /*Scope*/ 102, /*->14967*/
/* 14865*/   OPC_RecordChild0, // #0 = $v2
/* 14866*/   OPC_MoveChild1,
/* 14867*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14870*/   OPC_MoveChild0,
/* 14871*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14874*/   OPC_Scope, 23, /*->14899*/ // 3 children in Scope
/* 14876*/    OPC_RecordChild0, // #1 = $v1
/* 14877*/    OPC_CheckChild1Same, 0,
/* 14879*/    OPC_MoveSibling1,
/* 14880*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14883*/    OPC_RecordChild0, // #2 = $c
/* 14884*/    OPC_MoveChild1,
/* 14885*/    OPC_CheckImmAllOnesV,
/* 14886*/    OPC_MoveParent,
/* 14887*/    OPC_MoveParent,
/* 14888*/    OPC_MoveParent,
/* 14889*/    OPC_CheckType, MVT::v16i8,
/* 14891*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14899*/   /*Scope*/ 23, /*->14923*/
/* 14900*/    OPC_CheckChild0Same, 0,
/* 14902*/    OPC_RecordChild1, // #1 = $v1
/* 14903*/    OPC_MoveSibling1,
/* 14904*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14907*/    OPC_RecordChild0, // #2 = $c
/* 14908*/    OPC_MoveChild1,
/* 14909*/    OPC_CheckImmAllOnesV,
/* 14910*/    OPC_MoveParent,
/* 14911*/    OPC_MoveParent,
/* 14912*/    OPC_MoveParent,
/* 14913*/    OPC_CheckType, MVT::v16i8,
/* 14915*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14923*/   /*Scope*/ 42, /*->14966*/
/* 14924*/    OPC_RecordChild0, // #1 = $c
/* 14925*/    OPC_MoveChild1,
/* 14926*/    OPC_CheckImmAllOnesV,
/* 14927*/    OPC_MoveParent,
/* 14928*/    OPC_MoveSibling1,
/* 14929*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14932*/    OPC_Scope, 15, /*->14949*/ // 2 children in Scope
/* 14934*/     OPC_RecordChild0, // #2 = $v1
/* 14935*/     OPC_CheckChild1Same, 0,
/* 14937*/     OPC_MoveParent,
/* 14938*/     OPC_MoveParent,
/* 14939*/     OPC_CheckType, MVT::v16i8,
/* 14941*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14949*/    /*Scope*/ 15, /*->14965*/
/* 14950*/     OPC_CheckChild0Same, 0,
/* 14952*/     OPC_RecordChild1, // #2 = $v1
/* 14953*/     OPC_MoveParent,
/* 14954*/     OPC_MoveParent,
/* 14955*/     OPC_CheckType, MVT::v16i8,
/* 14957*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14965*/    0, /*End of Scope*/
/* 14966*/   0, /*End of Scope*/
/* 14967*/  /*Scope*/ 73, /*->15041*/
/* 14968*/   OPC_MoveChild0,
/* 14969*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14972*/   OPC_MoveChild0,
/* 14973*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14976*/   OPC_RecordChild0, // #0 = $v2
/* 14977*/   OPC_Scope, 23, /*->15002*/ // 2 children in Scope
/* 14979*/    OPC_RecordChild1, // #1 = $v1
/* 14980*/    OPC_MoveSibling1,
/* 14981*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14984*/    OPC_RecordChild0, // #2 = $c
/* 14985*/    OPC_MoveChild1,
/* 14986*/    OPC_CheckImmAllOnesV,
/* 14987*/    OPC_MoveParent,
/* 14988*/    OPC_MoveParent,
/* 14989*/    OPC_MoveParent,
/* 14990*/    OPC_CheckChild1Same, 0,
/* 14992*/    OPC_CheckType, MVT::v8i16,
/* 14994*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15002*/   /*Scope*/ 37, /*->15040*/
/* 15003*/    OPC_MoveChild1,
/* 15004*/    OPC_CheckImmAllOnesV,
/* 15005*/    OPC_MoveParent,
/* 15006*/    OPC_MoveSibling1,
/* 15007*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15010*/    OPC_RecordChild0, // #1 = $v1
/* 15011*/    OPC_RecordChild1, // #2 = $v2
/* 15012*/    OPC_MoveParent,
/* 15013*/    OPC_MoveParent,
/* 15014*/    OPC_CheckType, MVT::v8i16,
/* 15016*/    OPC_Scope, 10, /*->15028*/ // 2 children in Scope
/* 15018*/     OPC_CheckChild1Same, 2,
/* 15020*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15028*/    /*Scope*/ 10, /*->15039*/
/* 15029*/     OPC_CheckChild1Same, 1,
/* 15031*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15039*/    0, /*End of Scope*/
/* 15040*/   0, /*End of Scope*/
/* 15041*/  /*Scope*/ 102, /*->15144*/
/* 15042*/   OPC_RecordChild0, // #0 = $v2
/* 15043*/   OPC_MoveChild1,
/* 15044*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15047*/   OPC_MoveChild0,
/* 15048*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15051*/   OPC_Scope, 23, /*->15076*/ // 3 children in Scope
/* 15053*/    OPC_RecordChild0, // #1 = $v1
/* 15054*/    OPC_CheckChild1Same, 0,
/* 15056*/    OPC_MoveSibling1,
/* 15057*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15060*/    OPC_RecordChild0, // #2 = $c
/* 15061*/    OPC_MoveChild1,
/* 15062*/    OPC_CheckImmAllOnesV,
/* 15063*/    OPC_MoveParent,
/* 15064*/    OPC_MoveParent,
/* 15065*/    OPC_MoveParent,
/* 15066*/    OPC_CheckType, MVT::v8i16,
/* 15068*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15076*/   /*Scope*/ 23, /*->15100*/
/* 15077*/    OPC_CheckChild0Same, 0,
/* 15079*/    OPC_RecordChild1, // #1 = $v1
/* 15080*/    OPC_MoveSibling1,
/* 15081*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15084*/    OPC_RecordChild0, // #2 = $c
/* 15085*/    OPC_MoveChild1,
/* 15086*/    OPC_CheckImmAllOnesV,
/* 15087*/    OPC_MoveParent,
/* 15088*/    OPC_MoveParent,
/* 15089*/    OPC_MoveParent,
/* 15090*/    OPC_CheckType, MVT::v8i16,
/* 15092*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15100*/   /*Scope*/ 42, /*->15143*/
/* 15101*/    OPC_RecordChild0, // #1 = $c
/* 15102*/    OPC_MoveChild1,
/* 15103*/    OPC_CheckImmAllOnesV,
/* 15104*/    OPC_MoveParent,
/* 15105*/    OPC_MoveSibling1,
/* 15106*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15109*/    OPC_Scope, 15, /*->15126*/ // 2 children in Scope
/* 15111*/     OPC_RecordChild0, // #2 = $v1
/* 15112*/     OPC_CheckChild1Same, 0,
/* 15114*/     OPC_MoveParent,
/* 15115*/     OPC_MoveParent,
/* 15116*/     OPC_CheckType, MVT::v8i16,
/* 15118*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15126*/    /*Scope*/ 15, /*->15142*/
/* 15127*/     OPC_CheckChild0Same, 0,
/* 15129*/     OPC_RecordChild1, // #2 = $v1
/* 15130*/     OPC_MoveParent,
/* 15131*/     OPC_MoveParent,
/* 15132*/     OPC_CheckType, MVT::v8i16,
/* 15134*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15142*/    0, /*End of Scope*/
/* 15143*/   0, /*End of Scope*/
/* 15144*/  /*Scope*/ 73, /*->15218*/
/* 15145*/   OPC_MoveChild0,
/* 15146*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15149*/   OPC_MoveChild0,
/* 15150*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15153*/   OPC_RecordChild0, // #0 = $v2
/* 15154*/   OPC_Scope, 23, /*->15179*/ // 2 children in Scope
/* 15156*/    OPC_RecordChild1, // #1 = $v1
/* 15157*/    OPC_MoveSibling1,
/* 15158*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15161*/    OPC_RecordChild0, // #2 = $c
/* 15162*/    OPC_MoveChild1,
/* 15163*/    OPC_CheckImmAllOnesV,
/* 15164*/    OPC_MoveParent,
/* 15165*/    OPC_MoveParent,
/* 15166*/    OPC_MoveParent,
/* 15167*/    OPC_CheckChild1Same, 0,
/* 15169*/    OPC_CheckType, MVT::v4i32,
/* 15171*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15179*/   /*Scope*/ 37, /*->15217*/
/* 15180*/    OPC_MoveChild1,
/* 15181*/    OPC_CheckImmAllOnesV,
/* 15182*/    OPC_MoveParent,
/* 15183*/    OPC_MoveSibling1,
/* 15184*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15187*/    OPC_RecordChild0, // #1 = $v1
/* 15188*/    OPC_RecordChild1, // #2 = $v2
/* 15189*/    OPC_MoveParent,
/* 15190*/    OPC_MoveParent,
/* 15191*/    OPC_CheckType, MVT::v4i32,
/* 15193*/    OPC_Scope, 10, /*->15205*/ // 2 children in Scope
/* 15195*/     OPC_CheckChild1Same, 2,
/* 15197*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15205*/    /*Scope*/ 10, /*->15216*/
/* 15206*/     OPC_CheckChild1Same, 1,
/* 15208*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15216*/    0, /*End of Scope*/
/* 15217*/   0, /*End of Scope*/
/* 15218*/  /*Scope*/ 102, /*->15321*/
/* 15219*/   OPC_RecordChild0, // #0 = $v2
/* 15220*/   OPC_MoveChild1,
/* 15221*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15224*/   OPC_MoveChild0,
/* 15225*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15228*/   OPC_Scope, 23, /*->15253*/ // 3 children in Scope
/* 15230*/    OPC_RecordChild0, // #1 = $v1
/* 15231*/    OPC_CheckChild1Same, 0,
/* 15233*/    OPC_MoveSibling1,
/* 15234*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15237*/    OPC_RecordChild0, // #2 = $c
/* 15238*/    OPC_MoveChild1,
/* 15239*/    OPC_CheckImmAllOnesV,
/* 15240*/    OPC_MoveParent,
/* 15241*/    OPC_MoveParent,
/* 15242*/    OPC_MoveParent,
/* 15243*/    OPC_CheckType, MVT::v4i32,
/* 15245*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15253*/   /*Scope*/ 23, /*->15277*/
/* 15254*/    OPC_CheckChild0Same, 0,
/* 15256*/    OPC_RecordChild1, // #1 = $v1
/* 15257*/    OPC_MoveSibling1,
/* 15258*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15261*/    OPC_RecordChild0, // #2 = $c
/* 15262*/    OPC_MoveChild1,
/* 15263*/    OPC_CheckImmAllOnesV,
/* 15264*/    OPC_MoveParent,
/* 15265*/    OPC_MoveParent,
/* 15266*/    OPC_MoveParent,
/* 15267*/    OPC_CheckType, MVT::v4i32,
/* 15269*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15277*/   /*Scope*/ 42, /*->15320*/
/* 15278*/    OPC_RecordChild0, // #1 = $c
/* 15279*/    OPC_MoveChild1,
/* 15280*/    OPC_CheckImmAllOnesV,
/* 15281*/    OPC_MoveParent,
/* 15282*/    OPC_MoveSibling1,
/* 15283*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15286*/    OPC_Scope, 15, /*->15303*/ // 2 children in Scope
/* 15288*/     OPC_RecordChild0, // #2 = $v1
/* 15289*/     OPC_CheckChild1Same, 0,
/* 15291*/     OPC_MoveParent,
/* 15292*/     OPC_MoveParent,
/* 15293*/     OPC_CheckType, MVT::v4i32,
/* 15295*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15303*/    /*Scope*/ 15, /*->15319*/
/* 15304*/     OPC_CheckChild0Same, 0,
/* 15306*/     OPC_RecordChild1, // #2 = $v1
/* 15307*/     OPC_MoveParent,
/* 15308*/     OPC_MoveParent,
/* 15309*/     OPC_CheckType, MVT::v4i32,
/* 15311*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15319*/    0, /*End of Scope*/
/* 15320*/   0, /*End of Scope*/
/* 15321*/  /*Scope*/ 73, /*->15395*/
/* 15322*/   OPC_MoveChild0,
/* 15323*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15326*/   OPC_MoveChild0,
/* 15327*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15330*/   OPC_RecordChild0, // #0 = $v2
/* 15331*/   OPC_Scope, 23, /*->15356*/ // 2 children in Scope
/* 15333*/    OPC_RecordChild1, // #1 = $v1
/* 15334*/    OPC_MoveSibling1,
/* 15335*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15338*/    OPC_RecordChild0, // #2 = $c
/* 15339*/    OPC_MoveChild1,
/* 15340*/    OPC_CheckImmAllOnesV,
/* 15341*/    OPC_MoveParent,
/* 15342*/    OPC_MoveParent,
/* 15343*/    OPC_MoveParent,
/* 15344*/    OPC_CheckChild1Same, 0,
/* 15346*/    OPC_CheckType, MVT::v2i64,
/* 15348*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15356*/   /*Scope*/ 37, /*->15394*/
/* 15357*/    OPC_MoveChild1,
/* 15358*/    OPC_CheckImmAllOnesV,
/* 15359*/    OPC_MoveParent,
/* 15360*/    OPC_MoveSibling1,
/* 15361*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15364*/    OPC_RecordChild0, // #1 = $v1
/* 15365*/    OPC_RecordChild1, // #2 = $v2
/* 15366*/    OPC_MoveParent,
/* 15367*/    OPC_MoveParent,
/* 15368*/    OPC_CheckType, MVT::v2i64,
/* 15370*/    OPC_Scope, 10, /*->15382*/ // 2 children in Scope
/* 15372*/     OPC_CheckChild1Same, 2,
/* 15374*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15382*/    /*Scope*/ 10, /*->15393*/
/* 15383*/     OPC_CheckChild1Same, 1,
/* 15385*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15393*/    0, /*End of Scope*/
/* 15394*/   0, /*End of Scope*/
/* 15395*/  /*Scope*/ 102, /*->15498*/
/* 15396*/   OPC_RecordChild0, // #0 = $v2
/* 15397*/   OPC_MoveChild1,
/* 15398*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15401*/   OPC_MoveChild0,
/* 15402*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15405*/   OPC_Scope, 23, /*->15430*/ // 3 children in Scope
/* 15407*/    OPC_RecordChild0, // #1 = $v1
/* 15408*/    OPC_CheckChild1Same, 0,
/* 15410*/    OPC_MoveSibling1,
/* 15411*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15414*/    OPC_RecordChild0, // #2 = $c
/* 15415*/    OPC_MoveChild1,
/* 15416*/    OPC_CheckImmAllOnesV,
/* 15417*/    OPC_MoveParent,
/* 15418*/    OPC_MoveParent,
/* 15419*/    OPC_MoveParent,
/* 15420*/    OPC_CheckType, MVT::v2i64,
/* 15422*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15430*/   /*Scope*/ 23, /*->15454*/
/* 15431*/    OPC_CheckChild0Same, 0,
/* 15433*/    OPC_RecordChild1, // #1 = $v1
/* 15434*/    OPC_MoveSibling1,
/* 15435*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15438*/    OPC_RecordChild0, // #2 = $c
/* 15439*/    OPC_MoveChild1,
/* 15440*/    OPC_CheckImmAllOnesV,
/* 15441*/    OPC_MoveParent,
/* 15442*/    OPC_MoveParent,
/* 15443*/    OPC_MoveParent,
/* 15444*/    OPC_CheckType, MVT::v2i64,
/* 15446*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15454*/   /*Scope*/ 42, /*->15497*/
/* 15455*/    OPC_RecordChild0, // #1 = $c
/* 15456*/    OPC_MoveChild1,
/* 15457*/    OPC_CheckImmAllOnesV,
/* 15458*/    OPC_MoveParent,
/* 15459*/    OPC_MoveSibling1,
/* 15460*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15463*/    OPC_Scope, 15, /*->15480*/ // 2 children in Scope
/* 15465*/     OPC_RecordChild0, // #2 = $v1
/* 15466*/     OPC_CheckChild1Same, 0,
/* 15468*/     OPC_MoveParent,
/* 15469*/     OPC_MoveParent,
/* 15470*/     OPC_CheckType, MVT::v2i64,
/* 15472*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15480*/    /*Scope*/ 15, /*->15496*/
/* 15481*/     OPC_CheckChild0Same, 0,
/* 15483*/     OPC_RecordChild1, // #2 = $v1
/* 15484*/     OPC_MoveParent,
/* 15485*/     OPC_MoveParent,
/* 15486*/     OPC_CheckType, MVT::v2i64,
/* 15488*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15496*/    0, /*End of Scope*/
/* 15497*/   0, /*End of Scope*/
/* 15498*/  /*Scope*/ 112, /*->15611*/
/* 15499*/   OPC_MoveChild0,
/* 15500*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15503*/   OPC_Scope, 69, /*->15574*/ // 2 children in Scope
/* 15505*/    OPC_MoveChild0,
/* 15506*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15509*/    OPC_RecordChild0, // #0 = $v1
/* 15510*/    OPC_RecordChild1, // #1 = $v2
/* 15511*/    OPC_MoveParent,
/* 15512*/    OPC_RecordChild1, // #2 = $c
/* 15513*/    OPC_MoveParent,
/* 15514*/    OPC_Scope, 44, /*->15560*/ // 2 children in Scope
/* 15516*/     OPC_CheckChild1Same, 1,
/* 15518*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->15529
/* 15521*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15529*/     /*SwitchType*/ 8, MVT::v8i16,// ->15539
/* 15531*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15539*/     /*SwitchType*/ 8, MVT::v4i32,// ->15549
/* 15541*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15549*/     /*SwitchType*/ 8, MVT::v2i64,// ->15559
/* 15551*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15559*/     0, // EndSwitchType
/* 15560*/    /*Scope*/ 12, /*->15573*/
/* 15561*/     OPC_CheckChild1Same, 0,
/* 15563*/     OPC_CheckType, MVT::v16i8,
/* 15565*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15573*/    0, /*End of Scope*/
/* 15574*/   /*Scope*/ 35, /*->15610*/
/* 15575*/    OPC_RecordChild0, // #0 = $c
/* 15576*/    OPC_MoveChild1,
/* 15577*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15580*/    OPC_RecordChild0, // #1 = $v1
/* 15581*/    OPC_RecordChild1, // #2 = $v2
/* 15582*/    OPC_MoveParent,
/* 15583*/    OPC_MoveParent,
/* 15584*/    OPC_CheckType, MVT::v16i8,
/* 15586*/    OPC_Scope, 10, /*->15598*/ // 2 children in Scope
/* 15588*/     OPC_CheckChild1Same, 2,
/* 15590*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15598*/    /*Scope*/ 10, /*->15609*/
/* 15599*/     OPC_CheckChild1Same, 1,
/* 15601*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15609*/    0, /*End of Scope*/
/* 15610*/   0, /*End of Scope*/
/* 15611*/  /*Scope*/ 88, /*->15700*/
/* 15612*/   OPC_RecordChild0, // #0 = $v2
/* 15613*/   OPC_MoveChild1,
/* 15614*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15617*/   OPC_Scope, 40, /*->15659*/ // 2 children in Scope
/* 15619*/    OPC_MoveChild0,
/* 15620*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15623*/    OPC_Scope, 16, /*->15641*/ // 2 children in Scope
/* 15625*/     OPC_RecordChild0, // #1 = $v1
/* 15626*/     OPC_CheckChild1Same, 0,
/* 15628*/     OPC_MoveParent,
/* 15629*/     OPC_RecordChild1, // #2 = $c
/* 15630*/     OPC_MoveParent,
/* 15631*/     OPC_CheckType, MVT::v16i8,
/* 15633*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15641*/    /*Scope*/ 16, /*->15658*/
/* 15642*/     OPC_CheckChild0Same, 0,
/* 15644*/     OPC_RecordChild1, // #1 = $v1
/* 15645*/     OPC_MoveParent,
/* 15646*/     OPC_RecordChild1, // #2 = $c
/* 15647*/     OPC_MoveParent,
/* 15648*/     OPC_CheckType, MVT::v16i8,
/* 15650*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15658*/    0, /*End of Scope*/
/* 15659*/   /*Scope*/ 39, /*->15699*/
/* 15660*/    OPC_RecordChild0, // #1 = $c
/* 15661*/    OPC_MoveChild1,
/* 15662*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15665*/    OPC_Scope, 15, /*->15682*/ // 2 children in Scope
/* 15667*/     OPC_RecordChild0, // #2 = $v1
/* 15668*/     OPC_CheckChild1Same, 0,
/* 15670*/     OPC_MoveParent,
/* 15671*/     OPC_MoveParent,
/* 15672*/     OPC_CheckType, MVT::v16i8,
/* 15674*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15682*/    /*Scope*/ 15, /*->15698*/
/* 15683*/     OPC_CheckChild0Same, 0,
/* 15685*/     OPC_RecordChild1, // #2 = $v1
/* 15686*/     OPC_MoveParent,
/* 15687*/     OPC_MoveParent,
/* 15688*/     OPC_CheckType, MVT::v16i8,
/* 15690*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15698*/    0, /*End of Scope*/
/* 15699*/   0, /*End of Scope*/
/* 15700*/  /*Scope*/ 64, /*->15765*/
/* 15701*/   OPC_MoveChild0,
/* 15702*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15705*/   OPC_Scope, 21, /*->15728*/ // 2 children in Scope
/* 15707*/    OPC_MoveChild0,
/* 15708*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15711*/    OPC_RecordChild0, // #0 = $v2
/* 15712*/    OPC_RecordChild1, // #1 = $v1
/* 15713*/    OPC_MoveParent,
/* 15714*/    OPC_RecordChild1, // #2 = $c
/* 15715*/    OPC_MoveParent,
/* 15716*/    OPC_CheckChild1Same, 0,
/* 15718*/    OPC_CheckType, MVT::v8i16,
/* 15720*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15728*/   /*Scope*/ 35, /*->15764*/
/* 15729*/    OPC_RecordChild0, // #0 = $c
/* 15730*/    OPC_MoveChild1,
/* 15731*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15734*/    OPC_RecordChild0, // #1 = $v1
/* 15735*/    OPC_RecordChild1, // #2 = $v2
/* 15736*/    OPC_MoveParent,
/* 15737*/    OPC_MoveParent,
/* 15738*/    OPC_CheckType, MVT::v8i16,
/* 15740*/    OPC_Scope, 10, /*->15752*/ // 2 children in Scope
/* 15742*/     OPC_CheckChild1Same, 2,
/* 15744*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15752*/    /*Scope*/ 10, /*->15763*/
/* 15753*/     OPC_CheckChild1Same, 1,
/* 15755*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15763*/    0, /*End of Scope*/
/* 15764*/   0, /*End of Scope*/
/* 15765*/  /*Scope*/ 88, /*->15854*/
/* 15766*/   OPC_RecordChild0, // #0 = $v2
/* 15767*/   OPC_MoveChild1,
/* 15768*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15771*/   OPC_Scope, 40, /*->15813*/ // 2 children in Scope
/* 15773*/    OPC_MoveChild0,
/* 15774*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15777*/    OPC_Scope, 16, /*->15795*/ // 2 children in Scope
/* 15779*/     OPC_RecordChild0, // #1 = $v1
/* 15780*/     OPC_CheckChild1Same, 0,
/* 15782*/     OPC_MoveParent,
/* 15783*/     OPC_RecordChild1, // #2 = $c
/* 15784*/     OPC_MoveParent,
/* 15785*/     OPC_CheckType, MVT::v8i16,
/* 15787*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15795*/    /*Scope*/ 16, /*->15812*/
/* 15796*/     OPC_CheckChild0Same, 0,
/* 15798*/     OPC_RecordChild1, // #1 = $v1
/* 15799*/     OPC_MoveParent,
/* 15800*/     OPC_RecordChild1, // #2 = $c
/* 15801*/     OPC_MoveParent,
/* 15802*/     OPC_CheckType, MVT::v8i16,
/* 15804*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15812*/    0, /*End of Scope*/
/* 15813*/   /*Scope*/ 39, /*->15853*/
/* 15814*/    OPC_RecordChild0, // #1 = $c
/* 15815*/    OPC_MoveChild1,
/* 15816*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15819*/    OPC_Scope, 15, /*->15836*/ // 2 children in Scope
/* 15821*/     OPC_RecordChild0, // #2 = $v1
/* 15822*/     OPC_CheckChild1Same, 0,
/* 15824*/     OPC_MoveParent,
/* 15825*/     OPC_MoveParent,
/* 15826*/     OPC_CheckType, MVT::v8i16,
/* 15828*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15836*/    /*Scope*/ 15, /*->15852*/
/* 15837*/     OPC_CheckChild0Same, 0,
/* 15839*/     OPC_RecordChild1, // #2 = $v1
/* 15840*/     OPC_MoveParent,
/* 15841*/     OPC_MoveParent,
/* 15842*/     OPC_CheckType, MVT::v8i16,
/* 15844*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15852*/    0, /*End of Scope*/
/* 15853*/   0, /*End of Scope*/
/* 15854*/  /*Scope*/ 64, /*->15919*/
/* 15855*/   OPC_MoveChild0,
/* 15856*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15859*/   OPC_Scope, 21, /*->15882*/ // 2 children in Scope
/* 15861*/    OPC_MoveChild0,
/* 15862*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15865*/    OPC_RecordChild0, // #0 = $v2
/* 15866*/    OPC_RecordChild1, // #1 = $v1
/* 15867*/    OPC_MoveParent,
/* 15868*/    OPC_RecordChild1, // #2 = $c
/* 15869*/    OPC_MoveParent,
/* 15870*/    OPC_CheckChild1Same, 0,
/* 15872*/    OPC_CheckType, MVT::v4i32,
/* 15874*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15882*/   /*Scope*/ 35, /*->15918*/
/* 15883*/    OPC_RecordChild0, // #0 = $c
/* 15884*/    OPC_MoveChild1,
/* 15885*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15888*/    OPC_RecordChild0, // #1 = $v1
/* 15889*/    OPC_RecordChild1, // #2 = $v2
/* 15890*/    OPC_MoveParent,
/* 15891*/    OPC_MoveParent,
/* 15892*/    OPC_CheckType, MVT::v4i32,
/* 15894*/    OPC_Scope, 10, /*->15906*/ // 2 children in Scope
/* 15896*/     OPC_CheckChild1Same, 2,
/* 15898*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15906*/    /*Scope*/ 10, /*->15917*/
/* 15907*/     OPC_CheckChild1Same, 1,
/* 15909*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15917*/    0, /*End of Scope*/
/* 15918*/   0, /*End of Scope*/
/* 15919*/  /*Scope*/ 88, /*->16008*/
/* 15920*/   OPC_RecordChild0, // #0 = $v2
/* 15921*/   OPC_MoveChild1,
/* 15922*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15925*/   OPC_Scope, 40, /*->15967*/ // 2 children in Scope
/* 15927*/    OPC_MoveChild0,
/* 15928*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15931*/    OPC_Scope, 16, /*->15949*/ // 2 children in Scope
/* 15933*/     OPC_RecordChild0, // #1 = $v1
/* 15934*/     OPC_CheckChild1Same, 0,
/* 15936*/     OPC_MoveParent,
/* 15937*/     OPC_RecordChild1, // #2 = $c
/* 15938*/     OPC_MoveParent,
/* 15939*/     OPC_CheckType, MVT::v4i32,
/* 15941*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15949*/    /*Scope*/ 16, /*->15966*/
/* 15950*/     OPC_CheckChild0Same, 0,
/* 15952*/     OPC_RecordChild1, // #1 = $v1
/* 15953*/     OPC_MoveParent,
/* 15954*/     OPC_RecordChild1, // #2 = $c
/* 15955*/     OPC_MoveParent,
/* 15956*/     OPC_CheckType, MVT::v4i32,
/* 15958*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15966*/    0, /*End of Scope*/
/* 15967*/   /*Scope*/ 39, /*->16007*/
/* 15968*/    OPC_RecordChild0, // #1 = $c
/* 15969*/    OPC_MoveChild1,
/* 15970*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15973*/    OPC_Scope, 15, /*->15990*/ // 2 children in Scope
/* 15975*/     OPC_RecordChild0, // #2 = $v1
/* 15976*/     OPC_CheckChild1Same, 0,
/* 15978*/     OPC_MoveParent,
/* 15979*/     OPC_MoveParent,
/* 15980*/     OPC_CheckType, MVT::v4i32,
/* 15982*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15990*/    /*Scope*/ 15, /*->16006*/
/* 15991*/     OPC_CheckChild0Same, 0,
/* 15993*/     OPC_RecordChild1, // #2 = $v1
/* 15994*/     OPC_MoveParent,
/* 15995*/     OPC_MoveParent,
/* 15996*/     OPC_CheckType, MVT::v4i32,
/* 15998*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16006*/    0, /*End of Scope*/
/* 16007*/   0, /*End of Scope*/
/* 16008*/  /*Scope*/ 64, /*->16073*/
/* 16009*/   OPC_MoveChild0,
/* 16010*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16013*/   OPC_Scope, 21, /*->16036*/ // 2 children in Scope
/* 16015*/    OPC_MoveChild0,
/* 16016*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16019*/    OPC_RecordChild0, // #0 = $v2
/* 16020*/    OPC_RecordChild1, // #1 = $v1
/* 16021*/    OPC_MoveParent,
/* 16022*/    OPC_RecordChild1, // #2 = $c
/* 16023*/    OPC_MoveParent,
/* 16024*/    OPC_CheckChild1Same, 0,
/* 16026*/    OPC_CheckType, MVT::v2i64,
/* 16028*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16036*/   /*Scope*/ 35, /*->16072*/
/* 16037*/    OPC_RecordChild0, // #0 = $c
/* 16038*/    OPC_MoveChild1,
/* 16039*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16042*/    OPC_RecordChild0, // #1 = $v1
/* 16043*/    OPC_RecordChild1, // #2 = $v2
/* 16044*/    OPC_MoveParent,
/* 16045*/    OPC_MoveParent,
/* 16046*/    OPC_CheckType, MVT::v2i64,
/* 16048*/    OPC_Scope, 10, /*->16060*/ // 2 children in Scope
/* 16050*/     OPC_CheckChild1Same, 2,
/* 16052*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16060*/    /*Scope*/ 10, /*->16071*/
/* 16061*/     OPC_CheckChild1Same, 1,
/* 16063*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16071*/    0, /*End of Scope*/
/* 16072*/   0, /*End of Scope*/
/* 16073*/  /*Scope*/ 43|128,1/*171*/, /*->16246*/
/* 16075*/   OPC_RecordChild0, // #0 = $v2
/* 16076*/   OPC_Scope, 127, /*->16205*/ // 2 children in Scope
/* 16078*/    OPC_MoveChild1,
/* 16079*/    OPC_Scope, 86, /*->16167*/ // 2 children in Scope
/* 16081*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16084*/     OPC_Scope, 40, /*->16126*/ // 2 children in Scope
/* 16086*/      OPC_MoveChild0,
/* 16087*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16090*/      OPC_Scope, 16, /*->16108*/ // 2 children in Scope
/* 16092*/       OPC_RecordChild0, // #1 = $v1
/* 16093*/       OPC_CheckChild1Same, 0,
/* 16095*/       OPC_MoveParent,
/* 16096*/       OPC_RecordChild1, // #2 = $c
/* 16097*/       OPC_MoveParent,
/* 16098*/       OPC_CheckType, MVT::v2i64,
/* 16100*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16108*/      /*Scope*/ 16, /*->16125*/
/* 16109*/       OPC_CheckChild0Same, 0,
/* 16111*/       OPC_RecordChild1, // #1 = $v1
/* 16112*/       OPC_MoveParent,
/* 16113*/       OPC_RecordChild1, // #2 = $c
/* 16114*/       OPC_MoveParent,
/* 16115*/       OPC_CheckType, MVT::v2i64,
/* 16117*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16125*/      0, /*End of Scope*/
/* 16126*/     /*Scope*/ 39, /*->16166*/
/* 16127*/      OPC_RecordChild0, // #1 = $c
/* 16128*/      OPC_MoveChild1,
/* 16129*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16132*/      OPC_Scope, 15, /*->16149*/ // 2 children in Scope
/* 16134*/       OPC_RecordChild0, // #2 = $v1
/* 16135*/       OPC_CheckChild1Same, 0,
/* 16137*/       OPC_MoveParent,
/* 16138*/       OPC_MoveParent,
/* 16139*/       OPC_CheckType, MVT::v2i64,
/* 16141*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16149*/      /*Scope*/ 15, /*->16165*/
/* 16150*/       OPC_CheckChild0Same, 0,
/* 16152*/       OPC_RecordChild1, // #2 = $v1
/* 16153*/       OPC_MoveParent,
/* 16154*/       OPC_MoveParent,
/* 16155*/       OPC_CheckType, MVT::v2i64,
/* 16157*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16165*/      0, /*End of Scope*/
/* 16166*/     0, /*End of Scope*/
/* 16167*/    /*Scope*/ 36, /*->16204*/
/* 16168*/     OPC_CheckImmAllOnesV,
/* 16169*/     OPC_MoveParent,
/* 16170*/     OPC_SwitchType /*4 cases */, 6, MVT::v16i8,// ->16179
/* 16173*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16179*/     /*SwitchType*/ 6, MVT::v8i16,// ->16187
/* 16181*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16187*/     /*SwitchType*/ 6, MVT::v4i32,// ->16195
/* 16189*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16195*/     /*SwitchType*/ 6, MVT::v2i64,// ->16203
/* 16197*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16203*/     0, // EndSwitchType
/* 16204*/    0, /*End of Scope*/
/* 16205*/   /*Scope*/ 39, /*->16245*/
/* 16206*/    OPC_RecordChild1, // #1 = $rhs
/* 16207*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->16217
/* 16210*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16217*/    /*SwitchType*/ 7, MVT::v8i16,// ->16226
/* 16219*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16226*/    /*SwitchType*/ 7, MVT::v4i32,// ->16235
/* 16228*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16235*/    /*SwitchType*/ 7, MVT::v2i64,// ->16244
/* 16237*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16244*/    0, // EndSwitchType
/* 16245*/   0, /*End of Scope*/
/* 16246*/  0, /*End of Scope*/
/* 16247*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16271
/* 16250*/  OPC_RecordChild0, // #0 = $src
/* 16251*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16261
/* 16254*/   OPC_CheckChild0TypeI32,
/* 16255*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16261*/  /*SwitchType*/ 7, MVT::i64,// ->16270
/* 16263*/   OPC_CheckChild0TypeI64,
/* 16264*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16270*/  0, // EndSwitchType
/* 16271*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16295
/* 16274*/  OPC_RecordChild0, // #0 = $src
/* 16275*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16285
/* 16278*/   OPC_CheckChild0TypeI32,
/* 16279*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16285*/  /*SwitchType*/ 7, MVT::i64,// ->16294
/* 16287*/   OPC_CheckChild0TypeI64,
/* 16288*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16294*/  0, // EndSwitchType
/* 16295*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16330
/* 16298*/  OPC_RecordChild0, // #0 = $src
/* 16299*/  OPC_SwitchType /*3 cases */, 7, MVT::i32,// ->16309
/* 16302*/   OPC_CheckChild0TypeI32,
/* 16303*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16309*/  /*SwitchType*/ 7, MVT::i64,// ->16318
/* 16311*/   OPC_CheckChild0TypeI64,
/* 16312*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16318*/  /*SwitchType*/ 9, MVT::v16i8,// ->16329
/* 16320*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16322*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16323*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16329*/  0, // EndSwitchType
/* 16330*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16340
/* 16333*/  OPC_RecordChild0, // #0 = $src
/* 16334*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16340*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16350
/* 16343*/  OPC_RecordChild0, // #0 = $src
/* 16344*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16350*/ /*SwitchOpcode*/ 111, TARGET_VAL(ISD::FP_TO_SINT),// ->16464
/* 16353*/  OPC_RecordChild0, // #0 = $src
/* 16354*/  OPC_Scope, 48, /*->16404*/ // 3 children in Scope
/* 16356*/   OPC_CheckChild0Type, MVT::f32,
/* 16358*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16381
/* 16361*/    OPC_Scope, 8, /*->16371*/ // 2 children in Scope
/* 16363*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16365*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16371*/    /*Scope*/ 8, /*->16380*/
/* 16372*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16374*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16380*/    0, /*End of Scope*/
/* 16381*/   /*SwitchType*/ 20, MVT::i64,// ->16403
/* 16383*/    OPC_Scope, 8, /*->16393*/ // 2 children in Scope
/* 16385*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16387*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16393*/    /*Scope*/ 8, /*->16402*/
/* 16394*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16396*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16402*/    0, /*End of Scope*/
/* 16403*/   0, // EndSwitchType
/* 16404*/  /*Scope*/ 48, /*->16453*/
/* 16405*/   OPC_CheckChild0Type, MVT::f64,
/* 16407*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16430
/* 16410*/    OPC_Scope, 8, /*->16420*/ // 2 children in Scope
/* 16412*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16414*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16420*/    /*Scope*/ 8, /*->16429*/
/* 16421*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16423*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16429*/    0, /*End of Scope*/
/* 16430*/   /*SwitchType*/ 20, MVT::i64,// ->16452
/* 16432*/    OPC_Scope, 8, /*->16442*/ // 2 children in Scope
/* 16434*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16436*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16442*/    /*Scope*/ 8, /*->16451*/
/* 16443*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16445*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16451*/    0, /*End of Scope*/
/* 16452*/   0, // EndSwitchType
/* 16453*/  /*Scope*/ 9, /*->16463*/
/* 16454*/   OPC_CheckType, MVT::v4i32,
/* 16456*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16457*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16463*/  0, /*End of Scope*/
/* 16464*/ /*SwitchOpcode*/ 111, TARGET_VAL(ISD::FP_TO_UINT),// ->16578
/* 16467*/  OPC_RecordChild0, // #0 = $src
/* 16468*/  OPC_Scope, 48, /*->16518*/ // 3 children in Scope
/* 16470*/   OPC_CheckChild0Type, MVT::f32,
/* 16472*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16495
/* 16475*/    OPC_Scope, 8, /*->16485*/ // 2 children in Scope
/* 16477*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16479*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16485*/    /*Scope*/ 8, /*->16494*/
/* 16486*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16488*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16494*/    0, /*End of Scope*/
/* 16495*/   /*SwitchType*/ 20, MVT::i64,// ->16517
/* 16497*/    OPC_Scope, 8, /*->16507*/ // 2 children in Scope
/* 16499*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16501*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16507*/    /*Scope*/ 8, /*->16516*/
/* 16508*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16510*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16516*/    0, /*End of Scope*/
/* 16517*/   0, // EndSwitchType
/* 16518*/  /*Scope*/ 48, /*->16567*/
/* 16519*/   OPC_CheckChild0Type, MVT::f64,
/* 16521*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16544
/* 16524*/    OPC_Scope, 8, /*->16534*/ // 2 children in Scope
/* 16526*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16528*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16534*/    /*Scope*/ 8, /*->16543*/
/* 16535*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16537*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16543*/    0, /*End of Scope*/
/* 16544*/   /*SwitchType*/ 20, MVT::i64,// ->16566
/* 16546*/    OPC_Scope, 8, /*->16556*/ // 2 children in Scope
/* 16548*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16550*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16556*/    /*Scope*/ 8, /*->16565*/
/* 16557*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16559*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16565*/    0, /*End of Scope*/
/* 16566*/   0, // EndSwitchType
/* 16567*/  /*Scope*/ 9, /*->16577*/
/* 16568*/   OPC_CheckType, MVT::v4i32,
/* 16570*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16571*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16577*/  0, /*End of Scope*/
/* 16578*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16653
/* 16581*/  OPC_RecordChild0, // #0 = $src
/* 16582*/  OPC_Scope, 27, /*->16611*/ // 3 children in Scope
/* 16584*/   OPC_CheckChild0Type, MVT::f32,
/* 16586*/   OPC_MoveChild1,
/* 16587*/   OPC_Scope, 10, /*->16599*/ // 2 children in Scope
/* 16589*/    OPC_CheckValueType, MVT::i32,
/* 16591*/    OPC_MoveParent,
/* 16592*/    OPC_CheckTypeI32,
/* 16593*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16599*/   /*Scope*/ 10, /*->16610*/
/* 16600*/    OPC_CheckValueType, MVT::i64,
/* 16602*/    OPC_MoveParent,
/* 16603*/    OPC_CheckTypeI64,
/* 16604*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16610*/   0, /*End of Scope*/
/* 16611*/  /*Scope*/ 27, /*->16639*/
/* 16612*/   OPC_CheckChild0Type, MVT::f64,
/* 16614*/   OPC_MoveChild1,
/* 16615*/   OPC_Scope, 10, /*->16627*/ // 2 children in Scope
/* 16617*/    OPC_CheckValueType, MVT::i32,
/* 16619*/    OPC_MoveParent,
/* 16620*/    OPC_CheckTypeI32,
/* 16621*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16627*/   /*Scope*/ 10, /*->16638*/
/* 16628*/    OPC_CheckValueType, MVT::i64,
/* 16630*/    OPC_MoveParent,
/* 16631*/    OPC_CheckTypeI64,
/* 16632*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16638*/   0, /*End of Scope*/
/* 16639*/  /*Scope*/ 12, /*->16652*/
/* 16640*/   OPC_MoveChild1,
/* 16641*/   OPC_CheckValueType, MVT::i32,
/* 16643*/   OPC_MoveParent,
/* 16644*/   OPC_CheckType, MVT::v4i32,
/* 16646*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16652*/  0, /*End of Scope*/
/* 16653*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->16728
/* 16656*/  OPC_RecordChild0, // #0 = $src
/* 16657*/  OPC_Scope, 27, /*->16686*/ // 3 children in Scope
/* 16659*/   OPC_CheckChild0Type, MVT::f32,
/* 16661*/   OPC_MoveChild1,
/* 16662*/   OPC_Scope, 10, /*->16674*/ // 2 children in Scope
/* 16664*/    OPC_CheckValueType, MVT::i32,
/* 16666*/    OPC_MoveParent,
/* 16667*/    OPC_CheckTypeI32,
/* 16668*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16674*/   /*Scope*/ 10, /*->16685*/
/* 16675*/    OPC_CheckValueType, MVT::i64,
/* 16677*/    OPC_MoveParent,
/* 16678*/    OPC_CheckTypeI64,
/* 16679*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16685*/   0, /*End of Scope*/
/* 16686*/  /*Scope*/ 27, /*->16714*/
/* 16687*/   OPC_CheckChild0Type, MVT::f64,
/* 16689*/   OPC_MoveChild1,
/* 16690*/   OPC_Scope, 10, /*->16702*/ // 2 children in Scope
/* 16692*/    OPC_CheckValueType, MVT::i32,
/* 16694*/    OPC_MoveParent,
/* 16695*/    OPC_CheckTypeI32,
/* 16696*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16702*/   /*Scope*/ 10, /*->16713*/
/* 16703*/    OPC_CheckValueType, MVT::i64,
/* 16705*/    OPC_MoveParent,
/* 16706*/    OPC_CheckTypeI64,
/* 16707*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16713*/   0, /*End of Scope*/
/* 16714*/  /*Scope*/ 12, /*->16727*/
/* 16715*/   OPC_MoveChild1,
/* 16716*/   OPC_CheckValueType, MVT::i32,
/* 16718*/   OPC_MoveParent,
/* 16719*/   OPC_CheckType, MVT::v4i32,
/* 16721*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16727*/  0, /*End of Scope*/
/* 16728*/ /*SwitchOpcode*/ 95|128,1/*223*/, TARGET_VAL(ISD::BITCAST),// ->16955
/* 16732*/  OPC_RecordChild0, // #0 = $src
/* 16733*/  OPC_Scope, 9, /*->16744*/ // 10 children in Scope
/* 16735*/   OPC_CheckChild0Type, MVT::f32,
/* 16737*/   OPC_CheckTypeI32,
/* 16738*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16744*/  /*Scope*/ 9, /*->16754*/
/* 16745*/   OPC_CheckChild0Type, MVT::f64,
/* 16747*/   OPC_CheckTypeI64,
/* 16748*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16754*/  /*Scope*/ 9, /*->16764*/
/* 16755*/   OPC_CheckChild0TypeI32,
/* 16756*/   OPC_CheckType, MVT::f32,
/* 16758*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16764*/  /*Scope*/ 9, /*->16774*/
/* 16765*/   OPC_CheckChild0TypeI64,
/* 16766*/   OPC_CheckType, MVT::f64,
/* 16768*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 16774*/  /*Scope*/ 29, /*->16804*/
/* 16775*/   OPC_CheckChild0Type, MVT::v8i16,
/* 16777*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16783
/* 16780*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16783*/   /*SwitchType*/ 3, MVT::v4i32,// ->16788
/* 16785*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16788*/   /*SwitchType*/ 3, MVT::v2i64,// ->16793
/* 16790*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16793*/   /*SwitchType*/ 3, MVT::v4f32,// ->16798
/* 16795*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16798*/   /*SwitchType*/ 3, MVT::v2f64,// ->16803
/* 16800*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16803*/   0, // EndSwitchType
/* 16804*/  /*Scope*/ 29, /*->16834*/
/* 16805*/   OPC_CheckChild0Type, MVT::v4i32,
/* 16807*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16813
/* 16810*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16813*/   /*SwitchType*/ 3, MVT::v8i16,// ->16818
/* 16815*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16818*/   /*SwitchType*/ 3, MVT::v2i64,// ->16823
/* 16820*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16823*/   /*SwitchType*/ 3, MVT::v4f32,// ->16828
/* 16825*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16828*/   /*SwitchType*/ 3, MVT::v2f64,// ->16833
/* 16830*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16833*/   0, // EndSwitchType
/* 16834*/  /*Scope*/ 29, /*->16864*/
/* 16835*/   OPC_CheckChild0Type, MVT::v2i64,
/* 16837*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16843
/* 16840*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16843*/   /*SwitchType*/ 3, MVT::v8i16,// ->16848
/* 16845*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16848*/   /*SwitchType*/ 3, MVT::v4i32,// ->16853
/* 16850*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16853*/   /*SwitchType*/ 3, MVT::v4f32,// ->16858
/* 16855*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16858*/   /*SwitchType*/ 3, MVT::v2f64,// ->16863
/* 16860*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16863*/   0, // EndSwitchType
/* 16864*/  /*Scope*/ 29, /*->16894*/
/* 16865*/   OPC_CheckChild0Type, MVT::v4f32,
/* 16867*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16873
/* 16870*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16873*/   /*SwitchType*/ 3, MVT::v8i16,// ->16878
/* 16875*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16878*/   /*SwitchType*/ 3, MVT::v4i32,// ->16883
/* 16880*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16883*/   /*SwitchType*/ 3, MVT::v2i64,// ->16888
/* 16885*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16888*/   /*SwitchType*/ 3, MVT::v2f64,// ->16893
/* 16890*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16893*/   0, // EndSwitchType
/* 16894*/  /*Scope*/ 29, /*->16924*/
/* 16895*/   OPC_CheckChild0Type, MVT::v2f64,
/* 16897*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16903
/* 16900*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16903*/   /*SwitchType*/ 3, MVT::v8i16,// ->16908
/* 16905*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16908*/   /*SwitchType*/ 3, MVT::v4i32,// ->16913
/* 16910*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16913*/   /*SwitchType*/ 3, MVT::v2i64,// ->16918
/* 16915*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16918*/   /*SwitchType*/ 3, MVT::v4f32,// ->16923
/* 16920*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16923*/   0, // EndSwitchType
/* 16924*/  /*Scope*/ 29, /*->16954*/
/* 16925*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16927*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->16933
/* 16930*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16933*/   /*SwitchType*/ 3, MVT::v4i32,// ->16938
/* 16935*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16938*/   /*SwitchType*/ 3, MVT::v2i64,// ->16943
/* 16940*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16943*/   /*SwitchType*/ 3, MVT::v4f32,// ->16948
/* 16945*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16948*/   /*SwitchType*/ 3, MVT::v2f64,// ->16953
/* 16950*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16953*/   0, // EndSwitchType
/* 16954*/  0, /*End of Scope*/
/* 16955*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->16979
/* 16958*/  OPC_RecordNode, // #0 = $imm
/* 16959*/  OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->16969
/* 16962*/   OPC_EmitConvertToTarget0,
/* 16963*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 16969*/  /*SwitchType*/ 7, MVT::f64,// ->16978
/* 16971*/   OPC_EmitConvertToTarget0,
/* 16972*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 16978*/  0, // EndSwitchType
/* 16979*/ /*SwitchOpcode*/ 53, TARGET_VAL(ISD::SINT_TO_FP),// ->17035
/* 16982*/  OPC_RecordChild0, // #0 = $src
/* 16983*/  OPC_Scope, 19, /*->17004*/ // 3 children in Scope
/* 16985*/   OPC_CheckChild0TypeI32,
/* 16986*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->16995
/* 16989*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16995*/   /*SwitchType*/ 6, MVT::f64,// ->17003
/* 16997*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17003*/   0, // EndSwitchType
/* 17004*/  /*Scope*/ 19, /*->17024*/
/* 17005*/   OPC_CheckChild0TypeI64,
/* 17006*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17015
/* 17009*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17015*/   /*SwitchType*/ 6, MVT::f64,// ->17023
/* 17017*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17023*/   0, // EndSwitchType
/* 17024*/  /*Scope*/ 9, /*->17034*/
/* 17025*/   OPC_CheckType, MVT::v4f32,
/* 17027*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17028*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17034*/  0, /*End of Scope*/
/* 17035*/ /*SwitchOpcode*/ 53, TARGET_VAL(ISD::UINT_TO_FP),// ->17091
/* 17038*/  OPC_RecordChild0, // #0 = $src
/* 17039*/  OPC_Scope, 19, /*->17060*/ // 3 children in Scope
/* 17041*/   OPC_CheckChild0TypeI32,
/* 17042*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17051
/* 17045*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17051*/   /*SwitchType*/ 6, MVT::f64,// ->17059
/* 17053*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17059*/   0, // EndSwitchType
/* 17060*/  /*Scope*/ 19, /*->17080*/
/* 17061*/   OPC_CheckChild0TypeI64,
/* 17062*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17071
/* 17065*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17071*/   /*SwitchType*/ 6, MVT::f64,// ->17079
/* 17073*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17079*/   0, // EndSwitchType
/* 17080*/  /*Scope*/ 9, /*->17090*/
/* 17081*/   OPC_CheckType, MVT::v4f32,
/* 17083*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17084*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17090*/  0, /*End of Scope*/
/* 17091*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17101
/* 17094*/  OPC_RecordChild0, // #0 = $src
/* 17095*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17101*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17111
/* 17104*/  OPC_RecordChild0, // #0 = $src
/* 17105*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17111*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FADD),// ->17166
/* 17114*/  OPC_RecordChild0, // #0 = $lhs
/* 17115*/  OPC_RecordChild1, // #1 = $rhs
/* 17116*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17126
/* 17119*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17126*/  /*SwitchType*/ 7, MVT::f64,// ->17135
/* 17128*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17135*/  /*SwitchType*/ 8, MVT::v4f32,// ->17145
/* 17137*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17138*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17145*/  /*SwitchType*/ 8, MVT::v2f64,// ->17155
/* 17147*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17148*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17155*/  /*SwitchType*/ 8, MVT::v8f16,// ->17165
/* 17157*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17158*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17165*/  0, // EndSwitchType
/* 17166*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FSUB),// ->17221
/* 17169*/  OPC_RecordChild0, // #0 = $lhs
/* 17170*/  OPC_RecordChild1, // #1 = $rhs
/* 17171*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17181
/* 17174*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17181*/  /*SwitchType*/ 7, MVT::f64,// ->17190
/* 17183*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17190*/  /*SwitchType*/ 8, MVT::v4f32,// ->17200
/* 17192*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17193*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17200*/  /*SwitchType*/ 8, MVT::v2f64,// ->17210
/* 17202*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17203*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17210*/  /*SwitchType*/ 8, MVT::v8f16,// ->17220
/* 17212*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17213*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17220*/  0, // EndSwitchType
/* 17221*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMUL),// ->17276
/* 17224*/  OPC_RecordChild0, // #0 = $lhs
/* 17225*/  OPC_RecordChild1, // #1 = $rhs
/* 17226*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17236
/* 17229*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17236*/  /*SwitchType*/ 7, MVT::f64,// ->17245
/* 17238*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17245*/  /*SwitchType*/ 8, MVT::v4f32,// ->17255
/* 17247*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17248*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17255*/  /*SwitchType*/ 8, MVT::v2f64,// ->17265
/* 17257*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17258*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17265*/  /*SwitchType*/ 8, MVT::v8f16,// ->17275
/* 17267*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17268*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17275*/  0, // EndSwitchType
/* 17276*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FDIV),// ->17331
/* 17279*/  OPC_RecordChild0, // #0 = $lhs
/* 17280*/  OPC_RecordChild1, // #1 = $rhs
/* 17281*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17291
/* 17284*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17291*/  /*SwitchType*/ 7, MVT::f64,// ->17300
/* 17293*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17300*/  /*SwitchType*/ 8, MVT::v4f32,// ->17310
/* 17302*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17303*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17310*/  /*SwitchType*/ 8, MVT::v2f64,// ->17320
/* 17312*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17313*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17320*/  /*SwitchType*/ 8, MVT::v8f16,// ->17330
/* 17322*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17323*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17330*/  0, // EndSwitchType
/* 17331*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FSQRT),// ->17380
/* 17334*/  OPC_RecordChild0, // #0 = $src
/* 17335*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17344
/* 17338*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17344*/  /*SwitchType*/ 6, MVT::f64,// ->17352
/* 17346*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17352*/  /*SwitchType*/ 7, MVT::v4f32,// ->17361
/* 17354*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17355*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17361*/  /*SwitchType*/ 7, MVT::v2f64,// ->17370
/* 17363*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17364*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17370*/  /*SwitchType*/ 7, MVT::v8f16,// ->17379
/* 17372*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17373*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17379*/  0, // EndSwitchType
/* 17380*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FABS),// ->17429
/* 17383*/  OPC_RecordChild0, // #0 = $src
/* 17384*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17393
/* 17387*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17393*/  /*SwitchType*/ 6, MVT::f64,// ->17401
/* 17395*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17401*/  /*SwitchType*/ 7, MVT::v4f32,// ->17410
/* 17403*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17404*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17410*/  /*SwitchType*/ 7, MVT::v2f64,// ->17419
/* 17412*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17413*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17419*/  /*SwitchType*/ 7, MVT::v8f16,// ->17428
/* 17421*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17422*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17428*/  0, // EndSwitchType
/* 17429*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FNEG),// ->17478
/* 17432*/  OPC_RecordChild0, // #0 = $src
/* 17433*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17442
/* 17436*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17442*/  /*SwitchType*/ 6, MVT::f64,// ->17450
/* 17444*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17450*/  /*SwitchType*/ 7, MVT::v4f32,// ->17459
/* 17452*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17453*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17459*/  /*SwitchType*/ 7, MVT::v2f64,// ->17468
/* 17461*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17462*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17468*/  /*SwitchType*/ 7, MVT::v8f16,// ->17477
/* 17470*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17471*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17477*/  0, // EndSwitchType
/* 17478*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->17543
/* 17481*/  OPC_RecordChild0, // #0 = $lhs
/* 17482*/  OPC_RecordChild1, // #1 = $rhs
/* 17483*/  OPC_Scope, 28, /*->17513*/ // 2 children in Scope
/* 17485*/   OPC_CheckChild1Type, MVT::f32,
/* 17487*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->17497
/* 17490*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17497*/   /*SwitchType*/ 13, MVT::f64,// ->17512
/* 17499*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 17505*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17512*/   0, // EndSwitchType
/* 17513*/  /*Scope*/ 28, /*->17542*/
/* 17514*/   OPC_CheckChild1Type, MVT::f64,
/* 17516*/   OPC_SwitchType /*2 cases */, 7, MVT::f64,// ->17526
/* 17519*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17526*/   /*SwitchType*/ 13, MVT::f32,// ->17541
/* 17528*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 17534*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17541*/   0, // EndSwitchType
/* 17542*/  0, /*End of Scope*/
/* 17543*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMINIMUM),// ->17598
/* 17546*/  OPC_RecordChild0, // #0 = $lhs
/* 17547*/  OPC_RecordChild1, // #1 = $rhs
/* 17548*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17558
/* 17551*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17558*/  /*SwitchType*/ 7, MVT::f64,// ->17567
/* 17560*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17567*/  /*SwitchType*/ 8, MVT::v4f32,// ->17577
/* 17569*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17570*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17577*/  /*SwitchType*/ 8, MVT::v2f64,// ->17587
/* 17579*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17580*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17587*/  /*SwitchType*/ 8, MVT::v8f16,// ->17597
/* 17589*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17590*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17597*/  0, // EndSwitchType
/* 17598*/ /*SwitchOpcode*/ 52, TARGET_VAL(ISD::FMAXIMUM),// ->17653
/* 17601*/  OPC_RecordChild0, // #0 = $lhs
/* 17602*/  OPC_RecordChild1, // #1 = $rhs
/* 17603*/  OPC_SwitchType /*5 cases */, 7, MVT::f32,// ->17613
/* 17606*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17613*/  /*SwitchType*/ 7, MVT::f64,// ->17622
/* 17615*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17622*/  /*SwitchType*/ 8, MVT::v4f32,// ->17632
/* 17624*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17625*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17632*/  /*SwitchType*/ 8, MVT::v2f64,// ->17642
/* 17634*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17635*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17642*/  /*SwitchType*/ 8, MVT::v8f16,// ->17652
/* 17644*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17645*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 MVT::v8f16, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17652*/  0, // EndSwitchType
/* 17653*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FCEIL),// ->17702
/* 17656*/  OPC_RecordChild0, // #0 = $src
/* 17657*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17666
/* 17660*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17666*/  /*SwitchType*/ 6, MVT::f64,// ->17674
/* 17668*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17674*/  /*SwitchType*/ 7, MVT::v4f32,// ->17683
/* 17676*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17677*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17683*/  /*SwitchType*/ 7, MVT::v2f64,// ->17692
/* 17685*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17686*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17692*/  /*SwitchType*/ 7, MVT::v8f16,// ->17701
/* 17694*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17695*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17701*/  0, // EndSwitchType
/* 17702*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FFLOOR),// ->17751
/* 17705*/  OPC_RecordChild0, // #0 = $src
/* 17706*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17715
/* 17709*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17715*/  /*SwitchType*/ 6, MVT::f64,// ->17723
/* 17717*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17723*/  /*SwitchType*/ 7, MVT::v4f32,// ->17732
/* 17725*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17726*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17732*/  /*SwitchType*/ 7, MVT::v2f64,// ->17741
/* 17734*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17735*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17741*/  /*SwitchType*/ 7, MVT::v8f16,// ->17750
/* 17743*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17744*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17750*/  0, // EndSwitchType
/* 17751*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FTRUNC),// ->17800
/* 17754*/  OPC_RecordChild0, // #0 = $src
/* 17755*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17764
/* 17758*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17764*/  /*SwitchType*/ 6, MVT::f64,// ->17772
/* 17766*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17772*/  /*SwitchType*/ 7, MVT::v4f32,// ->17781
/* 17774*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17775*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17781*/  /*SwitchType*/ 7, MVT::v2f64,// ->17790
/* 17783*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17784*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17790*/  /*SwitchType*/ 7, MVT::v8f16,// ->17799
/* 17792*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17793*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17799*/  0, // EndSwitchType
/* 17800*/ /*SwitchOpcode*/ 46, TARGET_VAL(ISD::FNEARBYINT),// ->17849
/* 17803*/  OPC_RecordChild0, // #0 = $src
/* 17804*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17813
/* 17807*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17813*/  /*SwitchType*/ 6, MVT::f64,// ->17821
/* 17815*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17821*/  /*SwitchType*/ 7, MVT::v4f32,// ->17830
/* 17823*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17824*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17830*/  /*SwitchType*/ 7, MVT::v2f64,// ->17839
/* 17832*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17833*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17839*/  /*SwitchType*/ 7, MVT::v8f16,// ->17848
/* 17841*/   OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 17842*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17848*/  0, // EndSwitchType
/* 17849*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FRINT),// ->17895
/* 17852*/  OPC_RecordChild0, // #0 = $src
/* 17853*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17862
/* 17856*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17862*/  /*SwitchType*/ 6, MVT::f64,// ->17870
/* 17864*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17870*/  /*SwitchType*/ 6, MVT::v4f32,// ->17878
/* 17872*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17878*/  /*SwitchType*/ 6, MVT::v2f64,// ->17886
/* 17880*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 17886*/  /*SwitchType*/ 6, MVT::v8f16,// ->17894
/* 17888*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 17894*/  0, // EndSwitchType
/* 17895*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FROUNDEVEN),// ->17941
/* 17898*/  OPC_RecordChild0, // #0 = $src
/* 17899*/  OPC_SwitchType /*5 cases */, 6, MVT::f32,// ->17908
/* 17902*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17908*/  /*SwitchType*/ 6, MVT::f64,// ->17916
/* 17910*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17916*/  /*SwitchType*/ 6, MVT::v4f32,// ->17924
/* 17918*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17924*/  /*SwitchType*/ 6, MVT::v2f64,// ->17932
/* 17926*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 17932*/  /*SwitchType*/ 6, MVT::v8f16,// ->17940
/* 17934*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 MVT::v8f16, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 17940*/  0, // EndSwitchType
/* 17941*/ /*SwitchOpcode*/ 20|128,3/*404*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18349
/* 17945*/  OPC_RecordChild0, // #0 = $i0
/* 17946*/  OPC_MoveChild0,
/* 17947*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18281
/* 17952*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, MVT::i32,// ->18259
/* 17956*/    OPC_Scope, 51|128,1/*179*/, /*->18138*/ // 3 children in Scope
/* 17959*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17961*/     OPC_MoveSibling1,
/* 17962*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17965*/     OPC_RecordNode, // #1 = $i1
/* 17966*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17968*/     OPC_CheckTypeI32,
/* 17969*/     OPC_MoveSibling2,
/* 17970*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17973*/     OPC_RecordNode, // #2 = $i2
/* 17974*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17976*/     OPC_CheckTypeI32,
/* 17977*/     OPC_MoveSibling3,
/* 17978*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17981*/     OPC_RecordNode, // #3 = $i3
/* 17982*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17984*/     OPC_CheckTypeI32,
/* 17985*/     OPC_MoveSibling4,
/* 17986*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17989*/     OPC_RecordNode, // #4 = $i4
/* 17990*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17992*/     OPC_CheckTypeI32,
/* 17993*/     OPC_MoveSibling5,
/* 17994*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17997*/     OPC_RecordNode, // #5 = $i5
/* 17998*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18000*/     OPC_CheckTypeI32,
/* 18001*/     OPC_MoveSibling6,
/* 18002*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18005*/     OPC_RecordNode, // #6 = $i6
/* 18006*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18008*/     OPC_CheckTypeI32,
/* 18009*/     OPC_MoveSibling7,
/* 18010*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18013*/     OPC_RecordNode, // #7 = $i7
/* 18014*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18016*/     OPC_CheckTypeI32,
/* 18017*/     OPC_MoveSibling, 8,
/* 18019*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18022*/     OPC_RecordNode, // #8 = $i8
/* 18023*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18025*/     OPC_CheckTypeI32,
/* 18026*/     OPC_MoveSibling, 9,
/* 18028*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18031*/     OPC_RecordNode, // #9 = $i9
/* 18032*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18034*/     OPC_CheckTypeI32,
/* 18035*/     OPC_MoveSibling, 10,
/* 18037*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18040*/     OPC_RecordNode, // #10 = $iA
/* 18041*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18043*/     OPC_CheckTypeI32,
/* 18044*/     OPC_MoveSibling, 11,
/* 18046*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18049*/     OPC_RecordNode, // #11 = $iB
/* 18050*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18052*/     OPC_CheckTypeI32,
/* 18053*/     OPC_MoveSibling, 12,
/* 18055*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18058*/     OPC_RecordNode, // #12 = $iC
/* 18059*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18061*/     OPC_CheckTypeI32,
/* 18062*/     OPC_MoveSibling, 13,
/* 18064*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18067*/     OPC_RecordNode, // #13 = $iD
/* 18068*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18070*/     OPC_CheckTypeI32,
/* 18071*/     OPC_MoveSibling, 14,
/* 18073*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18076*/     OPC_RecordNode, // #14 = $iE
/* 18077*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18079*/     OPC_CheckTypeI32,
/* 18080*/     OPC_MoveSibling, 15,
/* 18082*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18085*/     OPC_RecordNode, // #15 = $iF
/* 18086*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 18088*/     OPC_CheckTypeI32,
/* 18089*/     OPC_MoveParent,
/* 18090*/     OPC_CheckType, MVT::v16i8,
/* 18092*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18093*/     OPC_EmitConvertToTarget0,
/* 18094*/     OPC_EmitConvertToTarget1,
/* 18095*/     OPC_EmitConvertToTarget2,
/* 18096*/     OPC_EmitConvertToTarget3,
/* 18097*/     OPC_EmitConvertToTarget4,
/* 18098*/     OPC_EmitConvertToTarget5,
/* 18099*/     OPC_EmitConvertToTarget6,
/* 18100*/     OPC_EmitConvertToTarget7,
/* 18101*/     OPC_EmitConvertToTarget, 8,
/* 18103*/     OPC_EmitConvertToTarget, 9,
/* 18105*/     OPC_EmitConvertToTarget, 10,
/* 18107*/     OPC_EmitConvertToTarget, 11,
/* 18109*/     OPC_EmitConvertToTarget, 12,
/* 18111*/     OPC_EmitConvertToTarget, 13,
/* 18113*/     OPC_EmitConvertToTarget, 14,
/* 18115*/     OPC_EmitConvertToTarget, 15,
/* 18117*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18138*/    /*Scope*/ 83, /*->18222*/
/* 18139*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18141*/     OPC_MoveSibling1,
/* 18142*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18145*/     OPC_RecordNode, // #1 = $i1
/* 18146*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18148*/     OPC_CheckTypeI32,
/* 18149*/     OPC_MoveSibling2,
/* 18150*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18153*/     OPC_RecordNode, // #2 = $i2
/* 18154*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18156*/     OPC_CheckTypeI32,
/* 18157*/     OPC_MoveSibling3,
/* 18158*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18161*/     OPC_RecordNode, // #3 = $i3
/* 18162*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18164*/     OPC_CheckTypeI32,
/* 18165*/     OPC_MoveSibling4,
/* 18166*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18169*/     OPC_RecordNode, // #4 = $i4
/* 18170*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18172*/     OPC_CheckTypeI32,
/* 18173*/     OPC_MoveSibling5,
/* 18174*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18177*/     OPC_RecordNode, // #5 = $i5
/* 18178*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18180*/     OPC_CheckTypeI32,
/* 18181*/     OPC_MoveSibling6,
/* 18182*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18185*/     OPC_RecordNode, // #6 = $i6
/* 18186*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18188*/     OPC_CheckTypeI32,
/* 18189*/     OPC_MoveSibling7,
/* 18190*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18193*/     OPC_RecordNode, // #7 = $i7
/* 18194*/     OPC_CheckPredicate, 15, // Predicate_ImmI16
/* 18196*/     OPC_CheckTypeI32,
/* 18197*/     OPC_MoveParent,
/* 18198*/     OPC_CheckType, MVT::v8i16,
/* 18200*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18201*/     OPC_EmitConvertToTarget0,
/* 18202*/     OPC_EmitConvertToTarget1,
/* 18203*/     OPC_EmitConvertToTarget2,
/* 18204*/     OPC_EmitConvertToTarget3,
/* 18205*/     OPC_EmitConvertToTarget4,
/* 18206*/     OPC_EmitConvertToTarget5,
/* 18207*/     OPC_EmitConvertToTarget6,
/* 18208*/     OPC_EmitConvertToTarget7,
/* 18209*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18222*/    /*Scope*/ 35, /*->18258*/
/* 18223*/     OPC_MoveSibling1,
/* 18224*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18227*/     OPC_RecordNode, // #1 = $i1
/* 18228*/     OPC_CheckTypeI32,
/* 18229*/     OPC_MoveSibling2,
/* 18230*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18233*/     OPC_RecordNode, // #2 = $i2
/* 18234*/     OPC_CheckTypeI32,
/* 18235*/     OPC_MoveSibling3,
/* 18236*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18239*/     OPC_RecordNode, // #3 = $i3
/* 18240*/     OPC_CheckTypeI32,
/* 18241*/     OPC_MoveParent,
/* 18242*/     OPC_CheckType, MVT::v4i32,
/* 18244*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18245*/     OPC_EmitConvertToTarget0,
/* 18246*/     OPC_EmitConvertToTarget1,
/* 18247*/     OPC_EmitConvertToTarget2,
/* 18248*/     OPC_EmitConvertToTarget3,
/* 18249*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18258*/    0, /*End of Scope*/
/* 18259*/   /*SwitchType*/ 19, MVT::i64,// ->18280
/* 18261*/    OPC_MoveSibling1,
/* 18262*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18265*/    OPC_RecordNode, // #1 = $i1
/* 18266*/    OPC_CheckTypeI64,
/* 18267*/    OPC_MoveParent,
/* 18268*/    OPC_CheckType, MVT::v2i64,
/* 18270*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18271*/    OPC_EmitConvertToTarget0,
/* 18272*/    OPC_EmitConvertToTarget1,
/* 18273*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18280*/   0, // EndSwitchType
/* 18281*/  /*SwitchOpcode*/ 64, TARGET_VAL(ISD::ConstantFP),// ->18348
/* 18284*/   OPC_SwitchType /*2 cases */, 38, MVT::f32,// ->18325
/* 18287*/    OPC_MoveSibling1,
/* 18288*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18291*/    OPC_RecordNode, // #1 = $i1
/* 18292*/    OPC_CheckType, MVT::f32,
/* 18294*/    OPC_MoveSibling2,
/* 18295*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18298*/    OPC_RecordNode, // #2 = $i2
/* 18299*/    OPC_CheckType, MVT::f32,
/* 18301*/    OPC_MoveSibling3,
/* 18302*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18305*/    OPC_RecordNode, // #3 = $i3
/* 18306*/    OPC_CheckType, MVT::f32,
/* 18308*/    OPC_MoveParent,
/* 18309*/    OPC_CheckType, MVT::v4f32,
/* 18311*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18312*/    OPC_EmitConvertToTarget0,
/* 18313*/    OPC_EmitConvertToTarget1,
/* 18314*/    OPC_EmitConvertToTarget2,
/* 18315*/    OPC_EmitConvertToTarget3,
/* 18316*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18325*/   /*SwitchType*/ 20, MVT::f64,// ->18347
/* 18327*/    OPC_MoveSibling1,
/* 18328*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18331*/    OPC_RecordNode, // #1 = $i1
/* 18332*/    OPC_CheckType, MVT::f64,
/* 18334*/    OPC_MoveParent,
/* 18335*/    OPC_CheckType, MVT::v2f64,
/* 18337*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18338*/    OPC_EmitConvertToTarget0,
/* 18339*/    OPC_EmitConvertToTarget1,
/* 18340*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18347*/   0, // EndSwitchType
/* 18348*/  0, // EndSwitchOpcode
/* 18349*/ /*SwitchOpcode*/ 1|128,16/*2049*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->20402
/* 18353*/  OPC_RecordChild0, // #0 = $x
/* 18354*/  OPC_Scope, 83|128,2/*339*/, /*->18696*/ // 6 children in Scope
/* 18357*/   OPC_CheckChild0Type, MVT::v16i8,
/* 18359*/   OPC_RecordChild1, // #1 = $y
/* 18360*/   OPC_CheckChild1Type, MVT::v16i8,
/* 18362*/   OPC_RecordChild2, // #2 = $m0
/* 18363*/   OPC_MoveChild2,
/* 18364*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18538
/* 18369*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18370*/    OPC_CheckTypeI32,
/* 18371*/    OPC_MoveSibling3,
/* 18372*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18375*/    OPC_RecordNode, // #3 = $m1
/* 18376*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18377*/    OPC_CheckTypeI32,
/* 18378*/    OPC_MoveSibling4,
/* 18379*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18382*/    OPC_RecordNode, // #4 = $m2
/* 18383*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18384*/    OPC_CheckTypeI32,
/* 18385*/    OPC_MoveSibling5,
/* 18386*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18389*/    OPC_RecordNode, // #5 = $m3
/* 18390*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18391*/    OPC_CheckTypeI32,
/* 18392*/    OPC_MoveSibling6,
/* 18393*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18396*/    OPC_RecordNode, // #6 = $m4
/* 18397*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18398*/    OPC_CheckTypeI32,
/* 18399*/    OPC_MoveSibling7,
/* 18400*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18403*/    OPC_RecordNode, // #7 = $m5
/* 18404*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18405*/    OPC_CheckTypeI32,
/* 18406*/    OPC_MoveSibling, 8,
/* 18408*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18411*/    OPC_RecordNode, // #8 = $m6
/* 18412*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18413*/    OPC_CheckTypeI32,
/* 18414*/    OPC_MoveSibling, 9,
/* 18416*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18419*/    OPC_RecordNode, // #9 = $m7
/* 18420*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18421*/    OPC_CheckTypeI32,
/* 18422*/    OPC_MoveSibling, 10,
/* 18424*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18427*/    OPC_RecordNode, // #10 = $m8
/* 18428*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18429*/    OPC_CheckTypeI32,
/* 18430*/    OPC_MoveSibling, 11,
/* 18432*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18435*/    OPC_RecordNode, // #11 = $m9
/* 18436*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18437*/    OPC_CheckTypeI32,
/* 18438*/    OPC_MoveSibling, 12,
/* 18440*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18443*/    OPC_RecordNode, // #12 = $mA
/* 18444*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18445*/    OPC_CheckTypeI32,
/* 18446*/    OPC_MoveSibling, 13,
/* 18448*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18451*/    OPC_RecordNode, // #13 = $mB
/* 18452*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18453*/    OPC_CheckTypeI32,
/* 18454*/    OPC_MoveSibling, 14,
/* 18456*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18459*/    OPC_RecordNode, // #14 = $mC
/* 18460*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18461*/    OPC_CheckTypeI32,
/* 18462*/    OPC_MoveSibling, 15,
/* 18464*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18467*/    OPC_RecordNode, // #15 = $mD
/* 18468*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18469*/    OPC_CheckTypeI32,
/* 18470*/    OPC_MoveSibling, 16,
/* 18472*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18475*/    OPC_RecordNode, // #16 = $mE
/* 18476*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18477*/    OPC_CheckTypeI32,
/* 18478*/    OPC_MoveSibling, 17,
/* 18480*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18483*/    OPC_RecordNode, // #17 = $mF
/* 18484*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18485*/    OPC_CheckTypeI32,
/* 18486*/    OPC_MoveParent,
/* 18487*/    OPC_CheckType, MVT::v16i8,
/* 18489*/    OPC_EmitConvertToTarget2,
/* 18490*/    OPC_EmitConvertToTarget3,
/* 18491*/    OPC_EmitConvertToTarget4,
/* 18492*/    OPC_EmitConvertToTarget5,
/* 18493*/    OPC_EmitConvertToTarget6,
/* 18494*/    OPC_EmitConvertToTarget7,
/* 18495*/    OPC_EmitConvertToTarget, 8,
/* 18497*/    OPC_EmitConvertToTarget, 9,
/* 18499*/    OPC_EmitConvertToTarget, 10,
/* 18501*/    OPC_EmitConvertToTarget, 11,
/* 18503*/    OPC_EmitConvertToTarget, 12,
/* 18505*/    OPC_EmitConvertToTarget, 13,
/* 18507*/    OPC_EmitConvertToTarget, 14,
/* 18509*/    OPC_EmitConvertToTarget, 15,
/* 18511*/    OPC_EmitConvertToTarget, 16,
/* 18513*/    OPC_EmitConvertToTarget, 17,
/* 18515*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18538*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->18695
/* 18542*/    OPC_CheckTypeI32,
/* 18543*/    OPC_MoveSibling3,
/* 18544*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18547*/    OPC_RecordNode, // #3 = $m1
/* 18548*/    OPC_CheckTypeI32,
/* 18549*/    OPC_MoveSibling4,
/* 18550*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18553*/    OPC_RecordNode, // #4 = $m2
/* 18554*/    OPC_CheckTypeI32,
/* 18555*/    OPC_MoveSibling5,
/* 18556*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18559*/    OPC_RecordNode, // #5 = $m3
/* 18560*/    OPC_CheckTypeI32,
/* 18561*/    OPC_MoveSibling6,
/* 18562*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18565*/    OPC_RecordNode, // #6 = $m4
/* 18566*/    OPC_CheckTypeI32,
/* 18567*/    OPC_MoveSibling7,
/* 18568*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18571*/    OPC_RecordNode, // #7 = $m5
/* 18572*/    OPC_CheckTypeI32,
/* 18573*/    OPC_MoveSibling, 8,
/* 18575*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18578*/    OPC_RecordNode, // #8 = $m6
/* 18579*/    OPC_CheckTypeI32,
/* 18580*/    OPC_MoveSibling, 9,
/* 18582*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18585*/    OPC_RecordNode, // #9 = $m7
/* 18586*/    OPC_CheckTypeI32,
/* 18587*/    OPC_MoveSibling, 10,
/* 18589*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18592*/    OPC_RecordNode, // #10 = $m8
/* 18593*/    OPC_CheckTypeI32,
/* 18594*/    OPC_MoveSibling, 11,
/* 18596*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18599*/    OPC_RecordNode, // #11 = $m9
/* 18600*/    OPC_CheckTypeI32,
/* 18601*/    OPC_MoveSibling, 12,
/* 18603*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18606*/    OPC_RecordNode, // #12 = $mA
/* 18607*/    OPC_CheckTypeI32,
/* 18608*/    OPC_MoveSibling, 13,
/* 18610*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18613*/    OPC_RecordNode, // #13 = $mB
/* 18614*/    OPC_CheckTypeI32,
/* 18615*/    OPC_MoveSibling, 14,
/* 18617*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18620*/    OPC_RecordNode, // #14 = $mC
/* 18621*/    OPC_CheckTypeI32,
/* 18622*/    OPC_MoveSibling, 15,
/* 18624*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18627*/    OPC_RecordNode, // #15 = $mD
/* 18628*/    OPC_CheckTypeI32,
/* 18629*/    OPC_MoveSibling, 16,
/* 18631*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18634*/    OPC_RecordNode, // #16 = $mE
/* 18635*/    OPC_CheckTypeI32,
/* 18636*/    OPC_MoveSibling, 17,
/* 18638*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18641*/    OPC_RecordNode, // #17 = $mF
/* 18642*/    OPC_CheckTypeI32,
/* 18643*/    OPC_MoveParent,
/* 18644*/    OPC_CheckType, MVT::v16i8,
/* 18646*/    OPC_EmitConvertToTarget2,
/* 18647*/    OPC_EmitConvertToTarget3,
/* 18648*/    OPC_EmitConvertToTarget4,
/* 18649*/    OPC_EmitConvertToTarget5,
/* 18650*/    OPC_EmitConvertToTarget6,
/* 18651*/    OPC_EmitConvertToTarget7,
/* 18652*/    OPC_EmitConvertToTarget, 8,
/* 18654*/    OPC_EmitConvertToTarget, 9,
/* 18656*/    OPC_EmitConvertToTarget, 10,
/* 18658*/    OPC_EmitConvertToTarget, 11,
/* 18660*/    OPC_EmitConvertToTarget, 12,
/* 18662*/    OPC_EmitConvertToTarget, 13,
/* 18664*/    OPC_EmitConvertToTarget, 14,
/* 18666*/    OPC_EmitConvertToTarget, 15,
/* 18668*/    OPC_EmitConvertToTarget, 16,
/* 18670*/    OPC_EmitConvertToTarget, 17,
/* 18672*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18695*/   0, // EndSwitchOpcode
/* 18696*/  /*Scope*/ 83|128,2/*339*/, /*->19037*/
/* 18698*/   OPC_CheckChild0Type, MVT::v8i16,
/* 18700*/   OPC_RecordChild1, // #1 = $y
/* 18701*/   OPC_CheckChild1Type, MVT::v8i16,
/* 18703*/   OPC_RecordChild2, // #2 = $m0
/* 18704*/   OPC_MoveChild2,
/* 18705*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18879
/* 18710*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18711*/    OPC_CheckTypeI32,
/* 18712*/    OPC_MoveSibling3,
/* 18713*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18716*/    OPC_RecordNode, // #3 = $m1
/* 18717*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18718*/    OPC_CheckTypeI32,
/* 18719*/    OPC_MoveSibling4,
/* 18720*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18723*/    OPC_RecordNode, // #4 = $m2
/* 18724*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18725*/    OPC_CheckTypeI32,
/* 18726*/    OPC_MoveSibling5,
/* 18727*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18730*/    OPC_RecordNode, // #5 = $m3
/* 18731*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18732*/    OPC_CheckTypeI32,
/* 18733*/    OPC_MoveSibling6,
/* 18734*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18737*/    OPC_RecordNode, // #6 = $m4
/* 18738*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18739*/    OPC_CheckTypeI32,
/* 18740*/    OPC_MoveSibling7,
/* 18741*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18744*/    OPC_RecordNode, // #7 = $m5
/* 18745*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18746*/    OPC_CheckTypeI32,
/* 18747*/    OPC_MoveSibling, 8,
/* 18749*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18752*/    OPC_RecordNode, // #8 = $m6
/* 18753*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18754*/    OPC_CheckTypeI32,
/* 18755*/    OPC_MoveSibling, 9,
/* 18757*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18760*/    OPC_RecordNode, // #9 = $m7
/* 18761*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18762*/    OPC_CheckTypeI32,
/* 18763*/    OPC_MoveSibling, 10,
/* 18765*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18768*/    OPC_RecordNode, // #10 = $m8
/* 18769*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18770*/    OPC_CheckTypeI32,
/* 18771*/    OPC_MoveSibling, 11,
/* 18773*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18776*/    OPC_RecordNode, // #11 = $m9
/* 18777*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18778*/    OPC_CheckTypeI32,
/* 18779*/    OPC_MoveSibling, 12,
/* 18781*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18784*/    OPC_RecordNode, // #12 = $mA
/* 18785*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18786*/    OPC_CheckTypeI32,
/* 18787*/    OPC_MoveSibling, 13,
/* 18789*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18792*/    OPC_RecordNode, // #13 = $mB
/* 18793*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18794*/    OPC_CheckTypeI32,
/* 18795*/    OPC_MoveSibling, 14,
/* 18797*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18800*/    OPC_RecordNode, // #14 = $mC
/* 18801*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18802*/    OPC_CheckTypeI32,
/* 18803*/    OPC_MoveSibling, 15,
/* 18805*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18808*/    OPC_RecordNode, // #15 = $mD
/* 18809*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18810*/    OPC_CheckTypeI32,
/* 18811*/    OPC_MoveSibling, 16,
/* 18813*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18816*/    OPC_RecordNode, // #16 = $mE
/* 18817*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18818*/    OPC_CheckTypeI32,
/* 18819*/    OPC_MoveSibling, 17,
/* 18821*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18824*/    OPC_RecordNode, // #17 = $mF
/* 18825*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18826*/    OPC_CheckTypeI32,
/* 18827*/    OPC_MoveParent,
/* 18828*/    OPC_CheckType, MVT::v8i16,
/* 18830*/    OPC_EmitConvertToTarget2,
/* 18831*/    OPC_EmitConvertToTarget3,
/* 18832*/    OPC_EmitConvertToTarget4,
/* 18833*/    OPC_EmitConvertToTarget5,
/* 18834*/    OPC_EmitConvertToTarget6,
/* 18835*/    OPC_EmitConvertToTarget7,
/* 18836*/    OPC_EmitConvertToTarget, 8,
/* 18838*/    OPC_EmitConvertToTarget, 9,
/* 18840*/    OPC_EmitConvertToTarget, 10,
/* 18842*/    OPC_EmitConvertToTarget, 11,
/* 18844*/    OPC_EmitConvertToTarget, 12,
/* 18846*/    OPC_EmitConvertToTarget, 13,
/* 18848*/    OPC_EmitConvertToTarget, 14,
/* 18850*/    OPC_EmitConvertToTarget, 15,
/* 18852*/    OPC_EmitConvertToTarget, 16,
/* 18854*/    OPC_EmitConvertToTarget, 17,
/* 18856*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18879*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19036
/* 18883*/    OPC_CheckTypeI32,
/* 18884*/    OPC_MoveSibling3,
/* 18885*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18888*/    OPC_RecordNode, // #3 = $m1
/* 18889*/    OPC_CheckTypeI32,
/* 18890*/    OPC_MoveSibling4,
/* 18891*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18894*/    OPC_RecordNode, // #4 = $m2
/* 18895*/    OPC_CheckTypeI32,
/* 18896*/    OPC_MoveSibling5,
/* 18897*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18900*/    OPC_RecordNode, // #5 = $m3
/* 18901*/    OPC_CheckTypeI32,
/* 18902*/    OPC_MoveSibling6,
/* 18903*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18906*/    OPC_RecordNode, // #6 = $m4
/* 18907*/    OPC_CheckTypeI32,
/* 18908*/    OPC_MoveSibling7,
/* 18909*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18912*/    OPC_RecordNode, // #7 = $m5
/* 18913*/    OPC_CheckTypeI32,
/* 18914*/    OPC_MoveSibling, 8,
/* 18916*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18919*/    OPC_RecordNode, // #8 = $m6
/* 18920*/    OPC_CheckTypeI32,
/* 18921*/    OPC_MoveSibling, 9,
/* 18923*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18926*/    OPC_RecordNode, // #9 = $m7
/* 18927*/    OPC_CheckTypeI32,
/* 18928*/    OPC_MoveSibling, 10,
/* 18930*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18933*/    OPC_RecordNode, // #10 = $m8
/* 18934*/    OPC_CheckTypeI32,
/* 18935*/    OPC_MoveSibling, 11,
/* 18937*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18940*/    OPC_RecordNode, // #11 = $m9
/* 18941*/    OPC_CheckTypeI32,
/* 18942*/    OPC_MoveSibling, 12,
/* 18944*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18947*/    OPC_RecordNode, // #12 = $mA
/* 18948*/    OPC_CheckTypeI32,
/* 18949*/    OPC_MoveSibling, 13,
/* 18951*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18954*/    OPC_RecordNode, // #13 = $mB
/* 18955*/    OPC_CheckTypeI32,
/* 18956*/    OPC_MoveSibling, 14,
/* 18958*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18961*/    OPC_RecordNode, // #14 = $mC
/* 18962*/    OPC_CheckTypeI32,
/* 18963*/    OPC_MoveSibling, 15,
/* 18965*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18968*/    OPC_RecordNode, // #15 = $mD
/* 18969*/    OPC_CheckTypeI32,
/* 18970*/    OPC_MoveSibling, 16,
/* 18972*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18975*/    OPC_RecordNode, // #16 = $mE
/* 18976*/    OPC_CheckTypeI32,
/* 18977*/    OPC_MoveSibling, 17,
/* 18979*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18982*/    OPC_RecordNode, // #17 = $mF
/* 18983*/    OPC_CheckTypeI32,
/* 18984*/    OPC_MoveParent,
/* 18985*/    OPC_CheckType, MVT::v8i16,
/* 18987*/    OPC_EmitConvertToTarget2,
/* 18988*/    OPC_EmitConvertToTarget3,
/* 18989*/    OPC_EmitConvertToTarget4,
/* 18990*/    OPC_EmitConvertToTarget5,
/* 18991*/    OPC_EmitConvertToTarget6,
/* 18992*/    OPC_EmitConvertToTarget7,
/* 18993*/    OPC_EmitConvertToTarget, 8,
/* 18995*/    OPC_EmitConvertToTarget, 9,
/* 18997*/    OPC_EmitConvertToTarget, 10,
/* 18999*/    OPC_EmitConvertToTarget, 11,
/* 19001*/    OPC_EmitConvertToTarget, 12,
/* 19003*/    OPC_EmitConvertToTarget, 13,
/* 19005*/    OPC_EmitConvertToTarget, 14,
/* 19007*/    OPC_EmitConvertToTarget, 15,
/* 19009*/    OPC_EmitConvertToTarget, 16,
/* 19011*/    OPC_EmitConvertToTarget, 17,
/* 19013*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19036*/   0, // EndSwitchOpcode
/* 19037*/  /*Scope*/ 83|128,2/*339*/, /*->19378*/
/* 19039*/   OPC_CheckChild0Type, MVT::v4i32,
/* 19041*/   OPC_RecordChild1, // #1 = $y
/* 19042*/   OPC_CheckChild1Type, MVT::v4i32,
/* 19044*/   OPC_RecordChild2, // #2 = $m0
/* 19045*/   OPC_MoveChild2,
/* 19046*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19220
/* 19051*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19052*/    OPC_CheckTypeI32,
/* 19053*/    OPC_MoveSibling3,
/* 19054*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19057*/    OPC_RecordNode, // #3 = $m1
/* 19058*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19059*/    OPC_CheckTypeI32,
/* 19060*/    OPC_MoveSibling4,
/* 19061*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19064*/    OPC_RecordNode, // #4 = $m2
/* 19065*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19066*/    OPC_CheckTypeI32,
/* 19067*/    OPC_MoveSibling5,
/* 19068*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19071*/    OPC_RecordNode, // #5 = $m3
/* 19072*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19073*/    OPC_CheckTypeI32,
/* 19074*/    OPC_MoveSibling6,
/* 19075*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19078*/    OPC_RecordNode, // #6 = $m4
/* 19079*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19080*/    OPC_CheckTypeI32,
/* 19081*/    OPC_MoveSibling7,
/* 19082*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19085*/    OPC_RecordNode, // #7 = $m5
/* 19086*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19087*/    OPC_CheckTypeI32,
/* 19088*/    OPC_MoveSibling, 8,
/* 19090*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19093*/    OPC_RecordNode, // #8 = $m6
/* 19094*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19095*/    OPC_CheckTypeI32,
/* 19096*/    OPC_MoveSibling, 9,
/* 19098*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19101*/    OPC_RecordNode, // #9 = $m7
/* 19102*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19103*/    OPC_CheckTypeI32,
/* 19104*/    OPC_MoveSibling, 10,
/* 19106*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19109*/    OPC_RecordNode, // #10 = $m8
/* 19110*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19111*/    OPC_CheckTypeI32,
/* 19112*/    OPC_MoveSibling, 11,
/* 19114*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19117*/    OPC_RecordNode, // #11 = $m9
/* 19118*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19119*/    OPC_CheckTypeI32,
/* 19120*/    OPC_MoveSibling, 12,
/* 19122*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19125*/    OPC_RecordNode, // #12 = $mA
/* 19126*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19127*/    OPC_CheckTypeI32,
/* 19128*/    OPC_MoveSibling, 13,
/* 19130*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19133*/    OPC_RecordNode, // #13 = $mB
/* 19134*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19135*/    OPC_CheckTypeI32,
/* 19136*/    OPC_MoveSibling, 14,
/* 19138*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19141*/    OPC_RecordNode, // #14 = $mC
/* 19142*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19143*/    OPC_CheckTypeI32,
/* 19144*/    OPC_MoveSibling, 15,
/* 19146*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19149*/    OPC_RecordNode, // #15 = $mD
/* 19150*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19151*/    OPC_CheckTypeI32,
/* 19152*/    OPC_MoveSibling, 16,
/* 19154*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19157*/    OPC_RecordNode, // #16 = $mE
/* 19158*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19159*/    OPC_CheckTypeI32,
/* 19160*/    OPC_MoveSibling, 17,
/* 19162*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19165*/    OPC_RecordNode, // #17 = $mF
/* 19166*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19167*/    OPC_CheckTypeI32,
/* 19168*/    OPC_MoveParent,
/* 19169*/    OPC_CheckType, MVT::v4i32,
/* 19171*/    OPC_EmitConvertToTarget2,
/* 19172*/    OPC_EmitConvertToTarget3,
/* 19173*/    OPC_EmitConvertToTarget4,
/* 19174*/    OPC_EmitConvertToTarget5,
/* 19175*/    OPC_EmitConvertToTarget6,
/* 19176*/    OPC_EmitConvertToTarget7,
/* 19177*/    OPC_EmitConvertToTarget, 8,
/* 19179*/    OPC_EmitConvertToTarget, 9,
/* 19181*/    OPC_EmitConvertToTarget, 10,
/* 19183*/    OPC_EmitConvertToTarget, 11,
/* 19185*/    OPC_EmitConvertToTarget, 12,
/* 19187*/    OPC_EmitConvertToTarget, 13,
/* 19189*/    OPC_EmitConvertToTarget, 14,
/* 19191*/    OPC_EmitConvertToTarget, 15,
/* 19193*/    OPC_EmitConvertToTarget, 16,
/* 19195*/    OPC_EmitConvertToTarget, 17,
/* 19197*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19220*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19377
/* 19224*/    OPC_CheckTypeI32,
/* 19225*/    OPC_MoveSibling3,
/* 19226*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19229*/    OPC_RecordNode, // #3 = $m1
/* 19230*/    OPC_CheckTypeI32,
/* 19231*/    OPC_MoveSibling4,
/* 19232*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19235*/    OPC_RecordNode, // #4 = $m2
/* 19236*/    OPC_CheckTypeI32,
/* 19237*/    OPC_MoveSibling5,
/* 19238*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19241*/    OPC_RecordNode, // #5 = $m3
/* 19242*/    OPC_CheckTypeI32,
/* 19243*/    OPC_MoveSibling6,
/* 19244*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19247*/    OPC_RecordNode, // #6 = $m4
/* 19248*/    OPC_CheckTypeI32,
/* 19249*/    OPC_MoveSibling7,
/* 19250*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19253*/    OPC_RecordNode, // #7 = $m5
/* 19254*/    OPC_CheckTypeI32,
/* 19255*/    OPC_MoveSibling, 8,
/* 19257*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19260*/    OPC_RecordNode, // #8 = $m6
/* 19261*/    OPC_CheckTypeI32,
/* 19262*/    OPC_MoveSibling, 9,
/* 19264*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19267*/    OPC_RecordNode, // #9 = $m7
/* 19268*/    OPC_CheckTypeI32,
/* 19269*/    OPC_MoveSibling, 10,
/* 19271*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19274*/    OPC_RecordNode, // #10 = $m8
/* 19275*/    OPC_CheckTypeI32,
/* 19276*/    OPC_MoveSibling, 11,
/* 19278*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19281*/    OPC_RecordNode, // #11 = $m9
/* 19282*/    OPC_CheckTypeI32,
/* 19283*/    OPC_MoveSibling, 12,
/* 19285*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19288*/    OPC_RecordNode, // #12 = $mA
/* 19289*/    OPC_CheckTypeI32,
/* 19290*/    OPC_MoveSibling, 13,
/* 19292*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19295*/    OPC_RecordNode, // #13 = $mB
/* 19296*/    OPC_CheckTypeI32,
/* 19297*/    OPC_MoveSibling, 14,
/* 19299*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19302*/    OPC_RecordNode, // #14 = $mC
/* 19303*/    OPC_CheckTypeI32,
/* 19304*/    OPC_MoveSibling, 15,
/* 19306*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19309*/    OPC_RecordNode, // #15 = $mD
/* 19310*/    OPC_CheckTypeI32,
/* 19311*/    OPC_MoveSibling, 16,
/* 19313*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19316*/    OPC_RecordNode, // #16 = $mE
/* 19317*/    OPC_CheckTypeI32,
/* 19318*/    OPC_MoveSibling, 17,
/* 19320*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19323*/    OPC_RecordNode, // #17 = $mF
/* 19324*/    OPC_CheckTypeI32,
/* 19325*/    OPC_MoveParent,
/* 19326*/    OPC_CheckType, MVT::v4i32,
/* 19328*/    OPC_EmitConvertToTarget2,
/* 19329*/    OPC_EmitConvertToTarget3,
/* 19330*/    OPC_EmitConvertToTarget4,
/* 19331*/    OPC_EmitConvertToTarget5,
/* 19332*/    OPC_EmitConvertToTarget6,
/* 19333*/    OPC_EmitConvertToTarget7,
/* 19334*/    OPC_EmitConvertToTarget, 8,
/* 19336*/    OPC_EmitConvertToTarget, 9,
/* 19338*/    OPC_EmitConvertToTarget, 10,
/* 19340*/    OPC_EmitConvertToTarget, 11,
/* 19342*/    OPC_EmitConvertToTarget, 12,
/* 19344*/    OPC_EmitConvertToTarget, 13,
/* 19346*/    OPC_EmitConvertToTarget, 14,
/* 19348*/    OPC_EmitConvertToTarget, 15,
/* 19350*/    OPC_EmitConvertToTarget, 16,
/* 19352*/    OPC_EmitConvertToTarget, 17,
/* 19354*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19377*/   0, // EndSwitchOpcode
/* 19378*/  /*Scope*/ 83|128,2/*339*/, /*->19719*/
/* 19380*/   OPC_CheckChild0Type, MVT::v2i64,
/* 19382*/   OPC_RecordChild1, // #1 = $y
/* 19383*/   OPC_CheckChild1Type, MVT::v2i64,
/* 19385*/   OPC_RecordChild2, // #2 = $m0
/* 19386*/   OPC_MoveChild2,
/* 19387*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19561
/* 19392*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19393*/    OPC_CheckTypeI32,
/* 19394*/    OPC_MoveSibling3,
/* 19395*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19398*/    OPC_RecordNode, // #3 = $m1
/* 19399*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19400*/    OPC_CheckTypeI32,
/* 19401*/    OPC_MoveSibling4,
/* 19402*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19405*/    OPC_RecordNode, // #4 = $m2
/* 19406*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19407*/    OPC_CheckTypeI32,
/* 19408*/    OPC_MoveSibling5,
/* 19409*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19412*/    OPC_RecordNode, // #5 = $m3
/* 19413*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19414*/    OPC_CheckTypeI32,
/* 19415*/    OPC_MoveSibling6,
/* 19416*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19419*/    OPC_RecordNode, // #6 = $m4
/* 19420*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19421*/    OPC_CheckTypeI32,
/* 19422*/    OPC_MoveSibling7,
/* 19423*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19426*/    OPC_RecordNode, // #7 = $m5
/* 19427*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19428*/    OPC_CheckTypeI32,
/* 19429*/    OPC_MoveSibling, 8,
/* 19431*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19434*/    OPC_RecordNode, // #8 = $m6
/* 19435*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19436*/    OPC_CheckTypeI32,
/* 19437*/    OPC_MoveSibling, 9,
/* 19439*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19442*/    OPC_RecordNode, // #9 = $m7
/* 19443*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19444*/    OPC_CheckTypeI32,
/* 19445*/    OPC_MoveSibling, 10,
/* 19447*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19450*/    OPC_RecordNode, // #10 = $m8
/* 19451*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19452*/    OPC_CheckTypeI32,
/* 19453*/    OPC_MoveSibling, 11,
/* 19455*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19458*/    OPC_RecordNode, // #11 = $m9
/* 19459*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19460*/    OPC_CheckTypeI32,
/* 19461*/    OPC_MoveSibling, 12,
/* 19463*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19466*/    OPC_RecordNode, // #12 = $mA
/* 19467*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19468*/    OPC_CheckTypeI32,
/* 19469*/    OPC_MoveSibling, 13,
/* 19471*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19474*/    OPC_RecordNode, // #13 = $mB
/* 19475*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19476*/    OPC_CheckTypeI32,
/* 19477*/    OPC_MoveSibling, 14,
/* 19479*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19482*/    OPC_RecordNode, // #14 = $mC
/* 19483*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19484*/    OPC_CheckTypeI32,
/* 19485*/    OPC_MoveSibling, 15,
/* 19487*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19490*/    OPC_RecordNode, // #15 = $mD
/* 19491*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19492*/    OPC_CheckTypeI32,
/* 19493*/    OPC_MoveSibling, 16,
/* 19495*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19498*/    OPC_RecordNode, // #16 = $mE
/* 19499*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19500*/    OPC_CheckTypeI32,
/* 19501*/    OPC_MoveSibling, 17,
/* 19503*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19506*/    OPC_RecordNode, // #17 = $mF
/* 19507*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19508*/    OPC_CheckTypeI32,
/* 19509*/    OPC_MoveParent,
/* 19510*/    OPC_CheckType, MVT::v2i64,
/* 19512*/    OPC_EmitConvertToTarget2,
/* 19513*/    OPC_EmitConvertToTarget3,
/* 19514*/    OPC_EmitConvertToTarget4,
/* 19515*/    OPC_EmitConvertToTarget5,
/* 19516*/    OPC_EmitConvertToTarget6,
/* 19517*/    OPC_EmitConvertToTarget7,
/* 19518*/    OPC_EmitConvertToTarget, 8,
/* 19520*/    OPC_EmitConvertToTarget, 9,
/* 19522*/    OPC_EmitConvertToTarget, 10,
/* 19524*/    OPC_EmitConvertToTarget, 11,
/* 19526*/    OPC_EmitConvertToTarget, 12,
/* 19528*/    OPC_EmitConvertToTarget, 13,
/* 19530*/    OPC_EmitConvertToTarget, 14,
/* 19532*/    OPC_EmitConvertToTarget, 15,
/* 19534*/    OPC_EmitConvertToTarget, 16,
/* 19536*/    OPC_EmitConvertToTarget, 17,
/* 19538*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19561*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19718
/* 19565*/    OPC_CheckTypeI32,
/* 19566*/    OPC_MoveSibling3,
/* 19567*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19570*/    OPC_RecordNode, // #3 = $m1
/* 19571*/    OPC_CheckTypeI32,
/* 19572*/    OPC_MoveSibling4,
/* 19573*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19576*/    OPC_RecordNode, // #4 = $m2
/* 19577*/    OPC_CheckTypeI32,
/* 19578*/    OPC_MoveSibling5,
/* 19579*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19582*/    OPC_RecordNode, // #5 = $m3
/* 19583*/    OPC_CheckTypeI32,
/* 19584*/    OPC_MoveSibling6,
/* 19585*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19588*/    OPC_RecordNode, // #6 = $m4
/* 19589*/    OPC_CheckTypeI32,
/* 19590*/    OPC_MoveSibling7,
/* 19591*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19594*/    OPC_RecordNode, // #7 = $m5
/* 19595*/    OPC_CheckTypeI32,
/* 19596*/    OPC_MoveSibling, 8,
/* 19598*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19601*/    OPC_RecordNode, // #8 = $m6
/* 19602*/    OPC_CheckTypeI32,
/* 19603*/    OPC_MoveSibling, 9,
/* 19605*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19608*/    OPC_RecordNode, // #9 = $m7
/* 19609*/    OPC_CheckTypeI32,
/* 19610*/    OPC_MoveSibling, 10,
/* 19612*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19615*/    OPC_RecordNode, // #10 = $m8
/* 19616*/    OPC_CheckTypeI32,
/* 19617*/    OPC_MoveSibling, 11,
/* 19619*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19622*/    OPC_RecordNode, // #11 = $m9
/* 19623*/    OPC_CheckTypeI32,
/* 19624*/    OPC_MoveSibling, 12,
/* 19626*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19629*/    OPC_RecordNode, // #12 = $mA
/* 19630*/    OPC_CheckTypeI32,
/* 19631*/    OPC_MoveSibling, 13,
/* 19633*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19636*/    OPC_RecordNode, // #13 = $mB
/* 19637*/    OPC_CheckTypeI32,
/* 19638*/    OPC_MoveSibling, 14,
/* 19640*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19643*/    OPC_RecordNode, // #14 = $mC
/* 19644*/    OPC_CheckTypeI32,
/* 19645*/    OPC_MoveSibling, 15,
/* 19647*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19650*/    OPC_RecordNode, // #15 = $mD
/* 19651*/    OPC_CheckTypeI32,
/* 19652*/    OPC_MoveSibling, 16,
/* 19654*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19657*/    OPC_RecordNode, // #16 = $mE
/* 19658*/    OPC_CheckTypeI32,
/* 19659*/    OPC_MoveSibling, 17,
/* 19661*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19664*/    OPC_RecordNode, // #17 = $mF
/* 19665*/    OPC_CheckTypeI32,
/* 19666*/    OPC_MoveParent,
/* 19667*/    OPC_CheckType, MVT::v2i64,
/* 19669*/    OPC_EmitConvertToTarget2,
/* 19670*/    OPC_EmitConvertToTarget3,
/* 19671*/    OPC_EmitConvertToTarget4,
/* 19672*/    OPC_EmitConvertToTarget5,
/* 19673*/    OPC_EmitConvertToTarget6,
/* 19674*/    OPC_EmitConvertToTarget7,
/* 19675*/    OPC_EmitConvertToTarget, 8,
/* 19677*/    OPC_EmitConvertToTarget, 9,
/* 19679*/    OPC_EmitConvertToTarget, 10,
/* 19681*/    OPC_EmitConvertToTarget, 11,
/* 19683*/    OPC_EmitConvertToTarget, 12,
/* 19685*/    OPC_EmitConvertToTarget, 13,
/* 19687*/    OPC_EmitConvertToTarget, 14,
/* 19689*/    OPC_EmitConvertToTarget, 15,
/* 19691*/    OPC_EmitConvertToTarget, 16,
/* 19693*/    OPC_EmitConvertToTarget, 17,
/* 19695*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19718*/   0, // EndSwitchOpcode
/* 19719*/  /*Scope*/ 83|128,2/*339*/, /*->20060*/
/* 19721*/   OPC_CheckChild0Type, MVT::v4f32,
/* 19723*/   OPC_RecordChild1, // #1 = $y
/* 19724*/   OPC_CheckChild1Type, MVT::v4f32,
/* 19726*/   OPC_RecordChild2, // #2 = $m0
/* 19727*/   OPC_MoveChild2,
/* 19728*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19902
/* 19733*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19734*/    OPC_CheckTypeI32,
/* 19735*/    OPC_MoveSibling3,
/* 19736*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19739*/    OPC_RecordNode, // #3 = $m1
/* 19740*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19741*/    OPC_CheckTypeI32,
/* 19742*/    OPC_MoveSibling4,
/* 19743*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19746*/    OPC_RecordNode, // #4 = $m2
/* 19747*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19748*/    OPC_CheckTypeI32,
/* 19749*/    OPC_MoveSibling5,
/* 19750*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19753*/    OPC_RecordNode, // #5 = $m3
/* 19754*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19755*/    OPC_CheckTypeI32,
/* 19756*/    OPC_MoveSibling6,
/* 19757*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19760*/    OPC_RecordNode, // #6 = $m4
/* 19761*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19762*/    OPC_CheckTypeI32,
/* 19763*/    OPC_MoveSibling7,
/* 19764*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19767*/    OPC_RecordNode, // #7 = $m5
/* 19768*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19769*/    OPC_CheckTypeI32,
/* 19770*/    OPC_MoveSibling, 8,
/* 19772*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19775*/    OPC_RecordNode, // #8 = $m6
/* 19776*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19777*/    OPC_CheckTypeI32,
/* 19778*/    OPC_MoveSibling, 9,
/* 19780*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19783*/    OPC_RecordNode, // #9 = $m7
/* 19784*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19785*/    OPC_CheckTypeI32,
/* 19786*/    OPC_MoveSibling, 10,
/* 19788*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19791*/    OPC_RecordNode, // #10 = $m8
/* 19792*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19793*/    OPC_CheckTypeI32,
/* 19794*/    OPC_MoveSibling, 11,
/* 19796*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19799*/    OPC_RecordNode, // #11 = $m9
/* 19800*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19801*/    OPC_CheckTypeI32,
/* 19802*/    OPC_MoveSibling, 12,
/* 19804*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19807*/    OPC_RecordNode, // #12 = $mA
/* 19808*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19809*/    OPC_CheckTypeI32,
/* 19810*/    OPC_MoveSibling, 13,
/* 19812*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19815*/    OPC_RecordNode, // #13 = $mB
/* 19816*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19817*/    OPC_CheckTypeI32,
/* 19818*/    OPC_MoveSibling, 14,
/* 19820*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19823*/    OPC_RecordNode, // #14 = $mC
/* 19824*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19825*/    OPC_CheckTypeI32,
/* 19826*/    OPC_MoveSibling, 15,
/* 19828*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19831*/    OPC_RecordNode, // #15 = $mD
/* 19832*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19833*/    OPC_CheckTypeI32,
/* 19834*/    OPC_MoveSibling, 16,
/* 19836*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19839*/    OPC_RecordNode, // #16 = $mE
/* 19840*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19841*/    OPC_CheckTypeI32,
/* 19842*/    OPC_MoveSibling, 17,
/* 19844*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19847*/    OPC_RecordNode, // #17 = $mF
/* 19848*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19849*/    OPC_CheckTypeI32,
/* 19850*/    OPC_MoveParent,
/* 19851*/    OPC_CheckType, MVT::v4f32,
/* 19853*/    OPC_EmitConvertToTarget2,
/* 19854*/    OPC_EmitConvertToTarget3,
/* 19855*/    OPC_EmitConvertToTarget4,
/* 19856*/    OPC_EmitConvertToTarget5,
/* 19857*/    OPC_EmitConvertToTarget6,
/* 19858*/    OPC_EmitConvertToTarget7,
/* 19859*/    OPC_EmitConvertToTarget, 8,
/* 19861*/    OPC_EmitConvertToTarget, 9,
/* 19863*/    OPC_EmitConvertToTarget, 10,
/* 19865*/    OPC_EmitConvertToTarget, 11,
/* 19867*/    OPC_EmitConvertToTarget, 12,
/* 19869*/    OPC_EmitConvertToTarget, 13,
/* 19871*/    OPC_EmitConvertToTarget, 14,
/* 19873*/    OPC_EmitConvertToTarget, 15,
/* 19875*/    OPC_EmitConvertToTarget, 16,
/* 19877*/    OPC_EmitConvertToTarget, 17,
/* 19879*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19902*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20059
/* 19906*/    OPC_CheckTypeI32,
/* 19907*/    OPC_MoveSibling3,
/* 19908*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19911*/    OPC_RecordNode, // #3 = $m1
/* 19912*/    OPC_CheckTypeI32,
/* 19913*/    OPC_MoveSibling4,
/* 19914*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19917*/    OPC_RecordNode, // #4 = $m2
/* 19918*/    OPC_CheckTypeI32,
/* 19919*/    OPC_MoveSibling5,
/* 19920*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19923*/    OPC_RecordNode, // #5 = $m3
/* 19924*/    OPC_CheckTypeI32,
/* 19925*/    OPC_MoveSibling6,
/* 19926*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19929*/    OPC_RecordNode, // #6 = $m4
/* 19930*/    OPC_CheckTypeI32,
/* 19931*/    OPC_MoveSibling7,
/* 19932*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19935*/    OPC_RecordNode, // #7 = $m5
/* 19936*/    OPC_CheckTypeI32,
/* 19937*/    OPC_MoveSibling, 8,
/* 19939*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19942*/    OPC_RecordNode, // #8 = $m6
/* 19943*/    OPC_CheckTypeI32,
/* 19944*/    OPC_MoveSibling, 9,
/* 19946*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19949*/    OPC_RecordNode, // #9 = $m7
/* 19950*/    OPC_CheckTypeI32,
/* 19951*/    OPC_MoveSibling, 10,
/* 19953*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19956*/    OPC_RecordNode, // #10 = $m8
/* 19957*/    OPC_CheckTypeI32,
/* 19958*/    OPC_MoveSibling, 11,
/* 19960*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19963*/    OPC_RecordNode, // #11 = $m9
/* 19964*/    OPC_CheckTypeI32,
/* 19965*/    OPC_MoveSibling, 12,
/* 19967*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19970*/    OPC_RecordNode, // #12 = $mA
/* 19971*/    OPC_CheckTypeI32,
/* 19972*/    OPC_MoveSibling, 13,
/* 19974*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19977*/    OPC_RecordNode, // #13 = $mB
/* 19978*/    OPC_CheckTypeI32,
/* 19979*/    OPC_MoveSibling, 14,
/* 19981*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19984*/    OPC_RecordNode, // #14 = $mC
/* 19985*/    OPC_CheckTypeI32,
/* 19986*/    OPC_MoveSibling, 15,
/* 19988*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19991*/    OPC_RecordNode, // #15 = $mD
/* 19992*/    OPC_CheckTypeI32,
/* 19993*/    OPC_MoveSibling, 16,
/* 19995*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19998*/    OPC_RecordNode, // #16 = $mE
/* 19999*/    OPC_CheckTypeI32,
/* 20000*/    OPC_MoveSibling, 17,
/* 20002*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20005*/    OPC_RecordNode, // #17 = $mF
/* 20006*/    OPC_CheckTypeI32,
/* 20007*/    OPC_MoveParent,
/* 20008*/    OPC_CheckType, MVT::v4f32,
/* 20010*/    OPC_EmitConvertToTarget2,
/* 20011*/    OPC_EmitConvertToTarget3,
/* 20012*/    OPC_EmitConvertToTarget4,
/* 20013*/    OPC_EmitConvertToTarget5,
/* 20014*/    OPC_EmitConvertToTarget6,
/* 20015*/    OPC_EmitConvertToTarget7,
/* 20016*/    OPC_EmitConvertToTarget, 8,
/* 20018*/    OPC_EmitConvertToTarget, 9,
/* 20020*/    OPC_EmitConvertToTarget, 10,
/* 20022*/    OPC_EmitConvertToTarget, 11,
/* 20024*/    OPC_EmitConvertToTarget, 12,
/* 20026*/    OPC_EmitConvertToTarget, 13,
/* 20028*/    OPC_EmitConvertToTarget, 14,
/* 20030*/    OPC_EmitConvertToTarget, 15,
/* 20032*/    OPC_EmitConvertToTarget, 16,
/* 20034*/    OPC_EmitConvertToTarget, 17,
/* 20036*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20059*/   0, // EndSwitchOpcode
/* 20060*/  /*Scope*/ 83|128,2/*339*/, /*->20401*/
/* 20062*/   OPC_CheckChild0Type, MVT::v2f64,
/* 20064*/   OPC_RecordChild1, // #1 = $y
/* 20065*/   OPC_CheckChild1Type, MVT::v2f64,
/* 20067*/   OPC_RecordChild2, // #2 = $m0
/* 20068*/   OPC_MoveChild2,
/* 20069*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20243
/* 20074*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20075*/    OPC_CheckTypeI32,
/* 20076*/    OPC_MoveSibling3,
/* 20077*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20080*/    OPC_RecordNode, // #3 = $m1
/* 20081*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20082*/    OPC_CheckTypeI32,
/* 20083*/    OPC_MoveSibling4,
/* 20084*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20087*/    OPC_RecordNode, // #4 = $m2
/* 20088*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20089*/    OPC_CheckTypeI32,
/* 20090*/    OPC_MoveSibling5,
/* 20091*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20094*/    OPC_RecordNode, // #5 = $m3
/* 20095*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20096*/    OPC_CheckTypeI32,
/* 20097*/    OPC_MoveSibling6,
/* 20098*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20101*/    OPC_RecordNode, // #6 = $m4
/* 20102*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20103*/    OPC_CheckTypeI32,
/* 20104*/    OPC_MoveSibling7,
/* 20105*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20108*/    OPC_RecordNode, // #7 = $m5
/* 20109*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20110*/    OPC_CheckTypeI32,
/* 20111*/    OPC_MoveSibling, 8,
/* 20113*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20116*/    OPC_RecordNode, // #8 = $m6
/* 20117*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20118*/    OPC_CheckTypeI32,
/* 20119*/    OPC_MoveSibling, 9,
/* 20121*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20124*/    OPC_RecordNode, // #9 = $m7
/* 20125*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20126*/    OPC_CheckTypeI32,
/* 20127*/    OPC_MoveSibling, 10,
/* 20129*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20132*/    OPC_RecordNode, // #10 = $m8
/* 20133*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20134*/    OPC_CheckTypeI32,
/* 20135*/    OPC_MoveSibling, 11,
/* 20137*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20140*/    OPC_RecordNode, // #11 = $m9
/* 20141*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20142*/    OPC_CheckTypeI32,
/* 20143*/    OPC_MoveSibling, 12,
/* 20145*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20148*/    OPC_RecordNode, // #12 = $mA
/* 20149*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20150*/    OPC_CheckTypeI32,
/* 20151*/    OPC_MoveSibling, 13,
/* 20153*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20156*/    OPC_RecordNode, // #13 = $mB
/* 20157*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20158*/    OPC_CheckTypeI32,
/* 20159*/    OPC_MoveSibling, 14,
/* 20161*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20164*/    OPC_RecordNode, // #14 = $mC
/* 20165*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20166*/    OPC_CheckTypeI32,
/* 20167*/    OPC_MoveSibling, 15,
/* 20169*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20172*/    OPC_RecordNode, // #15 = $mD
/* 20173*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20174*/    OPC_CheckTypeI32,
/* 20175*/    OPC_MoveSibling, 16,
/* 20177*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20180*/    OPC_RecordNode, // #16 = $mE
/* 20181*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20182*/    OPC_CheckTypeI32,
/* 20183*/    OPC_MoveSibling, 17,
/* 20185*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20188*/    OPC_RecordNode, // #17 = $mF
/* 20189*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20190*/    OPC_CheckTypeI32,
/* 20191*/    OPC_MoveParent,
/* 20192*/    OPC_CheckType, MVT::v2f64,
/* 20194*/    OPC_EmitConvertToTarget2,
/* 20195*/    OPC_EmitConvertToTarget3,
/* 20196*/    OPC_EmitConvertToTarget4,
/* 20197*/    OPC_EmitConvertToTarget5,
/* 20198*/    OPC_EmitConvertToTarget6,
/* 20199*/    OPC_EmitConvertToTarget7,
/* 20200*/    OPC_EmitConvertToTarget, 8,
/* 20202*/    OPC_EmitConvertToTarget, 9,
/* 20204*/    OPC_EmitConvertToTarget, 10,
/* 20206*/    OPC_EmitConvertToTarget, 11,
/* 20208*/    OPC_EmitConvertToTarget, 12,
/* 20210*/    OPC_EmitConvertToTarget, 13,
/* 20212*/    OPC_EmitConvertToTarget, 14,
/* 20214*/    OPC_EmitConvertToTarget, 15,
/* 20216*/    OPC_EmitConvertToTarget, 16,
/* 20218*/    OPC_EmitConvertToTarget, 17,
/* 20220*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20243*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20400
/* 20247*/    OPC_CheckTypeI32,
/* 20248*/    OPC_MoveSibling3,
/* 20249*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20252*/    OPC_RecordNode, // #3 = $m1
/* 20253*/    OPC_CheckTypeI32,
/* 20254*/    OPC_MoveSibling4,
/* 20255*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20258*/    OPC_RecordNode, // #4 = $m2
/* 20259*/    OPC_CheckTypeI32,
/* 20260*/    OPC_MoveSibling5,
/* 20261*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20264*/    OPC_RecordNode, // #5 = $m3
/* 20265*/    OPC_CheckTypeI32,
/* 20266*/    OPC_MoveSibling6,
/* 20267*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20270*/    OPC_RecordNode, // #6 = $m4
/* 20271*/    OPC_CheckTypeI32,
/* 20272*/    OPC_MoveSibling7,
/* 20273*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20276*/    OPC_RecordNode, // #7 = $m5
/* 20277*/    OPC_CheckTypeI32,
/* 20278*/    OPC_MoveSibling, 8,
/* 20280*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20283*/    OPC_RecordNode, // #8 = $m6
/* 20284*/    OPC_CheckTypeI32,
/* 20285*/    OPC_MoveSibling, 9,
/* 20287*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20290*/    OPC_RecordNode, // #9 = $m7
/* 20291*/    OPC_CheckTypeI32,
/* 20292*/    OPC_MoveSibling, 10,
/* 20294*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20297*/    OPC_RecordNode, // #10 = $m8
/* 20298*/    OPC_CheckTypeI32,
/* 20299*/    OPC_MoveSibling, 11,
/* 20301*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20304*/    OPC_RecordNode, // #11 = $m9
/* 20305*/    OPC_CheckTypeI32,
/* 20306*/    OPC_MoveSibling, 12,
/* 20308*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20311*/    OPC_RecordNode, // #12 = $mA
/* 20312*/    OPC_CheckTypeI32,
/* 20313*/    OPC_MoveSibling, 13,
/* 20315*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20318*/    OPC_RecordNode, // #13 = $mB
/* 20319*/    OPC_CheckTypeI32,
/* 20320*/    OPC_MoveSibling, 14,
/* 20322*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20325*/    OPC_RecordNode, // #14 = $mC
/* 20326*/    OPC_CheckTypeI32,
/* 20327*/    OPC_MoveSibling, 15,
/* 20329*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20332*/    OPC_RecordNode, // #15 = $mD
/* 20333*/    OPC_CheckTypeI32,
/* 20334*/    OPC_MoveSibling, 16,
/* 20336*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20339*/    OPC_RecordNode, // #16 = $mE
/* 20340*/    OPC_CheckTypeI32,
/* 20341*/    OPC_MoveSibling, 17,
/* 20343*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20346*/    OPC_RecordNode, // #17 = $mF
/* 20347*/    OPC_CheckTypeI32,
/* 20348*/    OPC_MoveParent,
/* 20349*/    OPC_CheckType, MVT::v2f64,
/* 20351*/    OPC_EmitConvertToTarget2,
/* 20352*/    OPC_EmitConvertToTarget3,
/* 20353*/    OPC_EmitConvertToTarget4,
/* 20354*/    OPC_EmitConvertToTarget5,
/* 20355*/    OPC_EmitConvertToTarget6,
/* 20356*/    OPC_EmitConvertToTarget7,
/* 20357*/    OPC_EmitConvertToTarget, 8,
/* 20359*/    OPC_EmitConvertToTarget, 9,
/* 20361*/    OPC_EmitConvertToTarget, 10,
/* 20363*/    OPC_EmitConvertToTarget, 11,
/* 20365*/    OPC_EmitConvertToTarget, 12,
/* 20367*/    OPC_EmitConvertToTarget, 13,
/* 20369*/    OPC_EmitConvertToTarget, 14,
/* 20371*/    OPC_EmitConvertToTarget, 15,
/* 20373*/    OPC_EmitConvertToTarget, 16,
/* 20375*/    OPC_EmitConvertToTarget, 17,
/* 20377*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20400*/   0, // EndSwitchOpcode
/* 20401*/  0, /*End of Scope*/
/* 20402*/ /*SwitchOpcode*/ 41|128,5/*681*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->21087
/* 20406*/  OPC_Scope, 6|128,1/*134*/, /*->20543*/ // 2 children in Scope
/* 20409*/   OPC_MoveChild0,
/* 20410*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20413*/   OPC_CheckChild0Integer, 0, 
/* 20415*/   OPC_Scope, 62, /*->20479*/ // 2 children in Scope
/* 20417*/    OPC_CheckChild0TypeI32,
/* 20418*/    OPC_MoveSibling1,
/* 20419*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20422*/    OPC_RecordMemRef,
/* 20423*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20424*/    OPC_CheckFoldableChainNode,
/* 20425*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20426*/    OPC_CheckTypeI32,
/* 20427*/    OPC_Scope, 24, /*->20453*/ // 2 children in Scope
/* 20429*/     OPC_CheckChild1TypeI32,
/* 20430*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20432*/     OPC_CheckPredicate7,  // Predicate_load
/* 20433*/     OPC_MoveParent,
/* 20434*/     OPC_CheckChild2Integer, 0, 
/* 20436*/     OPC_CheckType, MVT::v4i32,
/* 20438*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20439*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20441*/     OPC_EmitMergeInputChains1_0,
/* 20442*/     OPC_EmitInteger32, 0, 
/* 20444*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20453*/    /*Scope*/ 24, /*->20478*/
/* 20454*/     OPC_CheckChild1TypeI64,
/* 20455*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20457*/     OPC_CheckPredicate7,  // Predicate_load
/* 20458*/     OPC_MoveParent,
/* 20459*/     OPC_CheckChild2Integer, 0, 
/* 20461*/     OPC_CheckType, MVT::v4i32,
/* 20463*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20464*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20466*/     OPC_EmitMergeInputChains1_0,
/* 20467*/     OPC_EmitInteger32, 0, 
/* 20469*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20478*/    0, /*End of Scope*/
/* 20479*/   /*Scope*/ 62, /*->20542*/
/* 20480*/    OPC_CheckChild0TypeI64,
/* 20481*/    OPC_MoveSibling1,
/* 20482*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20485*/    OPC_RecordMemRef,
/* 20486*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20487*/    OPC_CheckFoldableChainNode,
/* 20488*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20489*/    OPC_CheckTypeI64,
/* 20490*/    OPC_Scope, 24, /*->20516*/ // 2 children in Scope
/* 20492*/     OPC_CheckChild1TypeI32,
/* 20493*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20495*/     OPC_CheckPredicate7,  // Predicate_load
/* 20496*/     OPC_MoveParent,
/* 20497*/     OPC_CheckChild2Integer, 0, 
/* 20499*/     OPC_CheckType, MVT::v2i64,
/* 20501*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20502*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20504*/     OPC_EmitMergeInputChains1_0,
/* 20505*/     OPC_EmitInteger32, 0, 
/* 20507*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20516*/    /*Scope*/ 24, /*->20541*/
/* 20517*/     OPC_CheckChild1TypeI64,
/* 20518*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20520*/     OPC_CheckPredicate7,  // Predicate_load
/* 20521*/     OPC_MoveParent,
/* 20522*/     OPC_CheckChild2Integer, 0, 
/* 20524*/     OPC_CheckType, MVT::v2i64,
/* 20526*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20527*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20529*/     OPC_EmitMergeInputChains1_0,
/* 20530*/     OPC_EmitInteger32, 0, 
/* 20532*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20541*/    0, /*End of Scope*/
/* 20542*/   0, /*End of Scope*/
/* 20543*/  /*Scope*/ 29|128,4/*541*/, /*->21086*/
/* 20545*/   OPC_RecordChild0, // #0 = $vec
/* 20546*/   OPC_Scope, 36|128,2/*292*/, /*->20841*/ // 2 children in Scope
/* 20549*/    OPC_MoveChild1,
/* 20550*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20553*/    OPC_RecordMemRef,
/* 20554*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 20555*/    OPC_CheckFoldableChainNode,
/* 20556*/    OPC_RecordChild1, // #2 = $addr
/* 20557*/    OPC_Scope, 11|128,1/*139*/, /*->20699*/ // 2 children in Scope
/* 20560*/     OPC_CheckChild1TypeI32,
/* 20561*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20563*/     OPC_Scope, 67, /*->20632*/ // 2 children in Scope
/* 20565*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 20567*/      OPC_CheckTypeI32,
/* 20568*/      OPC_Scope, 30, /*->20600*/ // 2 children in Scope
/* 20570*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20571*/       OPC_MoveSibling2,
/* 20572*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20575*/       OPC_RecordNode, // #3 = $idx
/* 20576*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20578*/       OPC_CheckTypeI32,
/* 20579*/       OPC_MoveParent,
/* 20580*/       OPC_CheckType, MVT::v16i8,
/* 20582*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20583*/       OPC_EmitMergeInputChains1_1,
/* 20584*/       OPC_EmitInteger32, 0, 
/* 20586*/       OPC_EmitInteger32, 0, 
/* 20588*/       OPC_EmitConvertToTarget3,
/* 20589*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20600*/      /*Scope*/ 30, /*->20631*/
/* 20601*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20602*/       OPC_MoveSibling2,
/* 20603*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20606*/       OPC_RecordNode, // #3 = $idx
/* 20607*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20609*/       OPC_CheckTypeI32,
/* 20610*/       OPC_MoveParent,
/* 20611*/       OPC_CheckType, MVT::v8i16,
/* 20613*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20614*/       OPC_EmitMergeInputChains1_1,
/* 20615*/       OPC_EmitInteger32, 0, 
/* 20617*/       OPC_EmitInteger32, 0, 
/* 20619*/       OPC_EmitConvertToTarget3,
/* 20620*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20631*/      0, /*End of Scope*/
/* 20632*/     /*Scope*/ 65, /*->20698*/
/* 20633*/      OPC_CheckPredicate7,  // Predicate_load
/* 20634*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->20666
/* 20637*/       OPC_MoveSibling2,
/* 20638*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20641*/       OPC_RecordNode, // #3 = $idx
/* 20642*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20644*/       OPC_CheckTypeI32,
/* 20645*/       OPC_MoveParent,
/* 20646*/       OPC_CheckType, MVT::v4i32,
/* 20648*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20649*/       OPC_EmitMergeInputChains1_1,
/* 20650*/       OPC_EmitInteger32, 0, 
/* 20652*/       OPC_EmitInteger32, 0, 
/* 20654*/       OPC_EmitConvertToTarget3,
/* 20655*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 20666*/      /*SwitchType*/ 29, MVT::i64,// ->20697
/* 20668*/       OPC_MoveSibling2,
/* 20669*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20672*/       OPC_RecordNode, // #3 = $idx
/* 20673*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20675*/       OPC_CheckTypeI32,
/* 20676*/       OPC_MoveParent,
/* 20677*/       OPC_CheckType, MVT::v2i64,
/* 20679*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20680*/       OPC_EmitMergeInputChains1_1,
/* 20681*/       OPC_EmitInteger32, 0, 
/* 20683*/       OPC_EmitInteger32, 0, 
/* 20685*/       OPC_EmitConvertToTarget3,
/* 20686*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 20697*/      0, // EndSwitchType
/* 20698*/     0, /*End of Scope*/
/* 20699*/    /*Scope*/ 11|128,1/*139*/, /*->20840*/
/* 20701*/     OPC_CheckChild1TypeI64,
/* 20702*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20704*/     OPC_Scope, 67, /*->20773*/ // 2 children in Scope
/* 20706*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 20708*/      OPC_CheckTypeI32,
/* 20709*/      OPC_Scope, 30, /*->20741*/ // 2 children in Scope
/* 20711*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20712*/       OPC_MoveSibling2,
/* 20713*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20716*/       OPC_RecordNode, // #3 = $idx
/* 20717*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20719*/       OPC_CheckTypeI32,
/* 20720*/       OPC_MoveParent,
/* 20721*/       OPC_CheckType, MVT::v16i8,
/* 20723*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20724*/       OPC_EmitMergeInputChains1_1,
/* 20725*/       OPC_EmitInteger32, 0, 
/* 20727*/       OPC_EmitInteger64, 0, 
/* 20729*/       OPC_EmitConvertToTarget3,
/* 20730*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20741*/      /*Scope*/ 30, /*->20772*/
/* 20742*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20743*/       OPC_MoveSibling2,
/* 20744*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20747*/       OPC_RecordNode, // #3 = $idx
/* 20748*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20750*/       OPC_CheckTypeI32,
/* 20751*/       OPC_MoveParent,
/* 20752*/       OPC_CheckType, MVT::v8i16,
/* 20754*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20755*/       OPC_EmitMergeInputChains1_1,
/* 20756*/       OPC_EmitInteger32, 0, 
/* 20758*/       OPC_EmitInteger64, 0, 
/* 20760*/       OPC_EmitConvertToTarget3,
/* 20761*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20772*/      0, /*End of Scope*/
/* 20773*/     /*Scope*/ 65, /*->20839*/
/* 20774*/      OPC_CheckPredicate7,  // Predicate_load
/* 20775*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->20807
/* 20778*/       OPC_MoveSibling2,
/* 20779*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20782*/       OPC_RecordNode, // #3 = $idx
/* 20783*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20785*/       OPC_CheckTypeI32,
/* 20786*/       OPC_MoveParent,
/* 20787*/       OPC_CheckType, MVT::v4i32,
/* 20789*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20790*/       OPC_EmitMergeInputChains1_1,
/* 20791*/       OPC_EmitInteger32, 0, 
/* 20793*/       OPC_EmitInteger64, 0, 
/* 20795*/       OPC_EmitConvertToTarget3,
/* 20796*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 20807*/      /*SwitchType*/ 29, MVT::i64,// ->20838
/* 20809*/       OPC_MoveSibling2,
/* 20810*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20813*/       OPC_RecordNode, // #3 = $idx
/* 20814*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20816*/       OPC_CheckTypeI32,
/* 20817*/       OPC_MoveParent,
/* 20818*/       OPC_CheckType, MVT::v2i64,
/* 20820*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20821*/       OPC_EmitMergeInputChains1_1,
/* 20822*/       OPC_EmitInteger32, 0, 
/* 20824*/       OPC_EmitInteger64, 0, 
/* 20826*/       OPC_EmitConvertToTarget3,
/* 20827*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 20838*/      0, // EndSwitchType
/* 20839*/     0, /*End of Scope*/
/* 20840*/    0, /*End of Scope*/
/* 20841*/   /*Scope*/ 114|128,1/*242*/, /*->21085*/
/* 20843*/    OPC_RecordChild1, // #1 = $x
/* 20844*/    OPC_Scope, 104, /*->20950*/ // 4 children in Scope
/* 20846*/     OPC_CheckChild1TypeI32,
/* 20847*/     OPC_Scope, 56, /*->20905*/ // 2 children in Scope
/* 20849*/      OPC_RecordChild2, // #2 = $idx
/* 20850*/      OPC_MoveChild2,
/* 20851*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20854*/      OPC_CheckTypeI32,
/* 20855*/      OPC_Scope, 15, /*->20872*/ // 3 children in Scope
/* 20857*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx16
/* 20859*/       OPC_MoveParent,
/* 20860*/       OPC_CheckType, MVT::v16i8,
/* 20862*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20863*/       OPC_EmitConvertToTarget2,
/* 20864*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20872*/      /*Scope*/ 15, /*->20888*/
/* 20873*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20875*/       OPC_MoveParent,
/* 20876*/       OPC_CheckType, MVT::v8i16,
/* 20878*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20879*/       OPC_EmitConvertToTarget2,
/* 20880*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20888*/      /*Scope*/ 15, /*->20904*/
/* 20889*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20891*/       OPC_MoveParent,
/* 20892*/       OPC_CheckType, MVT::v4i32,
/* 20894*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20895*/       OPC_EmitConvertToTarget2,
/* 20896*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20904*/      0, /*End of Scope*/
/* 20905*/     /*Scope*/ 43, /*->20949*/
/* 20906*/      OPC_MoveChild2,
/* 20907*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20910*/      OPC_MoveParent,
/* 20911*/      OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->20924
/* 20914*/       OPC_EmitInteger32, 0, 
/* 20916*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20924*/      /*SwitchType*/ 10, MVT::v8i16,// ->20936
/* 20926*/       OPC_EmitInteger32, 0, 
/* 20928*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20936*/      /*SwitchType*/ 10, MVT::v4i32,// ->20948
/* 20938*/       OPC_EmitInteger32, 0, 
/* 20940*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20948*/      0, // EndSwitchType
/* 20949*/     0, /*End of Scope*/
/* 20950*/    /*Scope*/ 43, /*->20994*/
/* 20951*/     OPC_CheckChild1TypeI64,
/* 20952*/     OPC_Scope, 21, /*->20975*/ // 2 children in Scope
/* 20954*/      OPC_RecordChild2, // #2 = $idx
/* 20955*/      OPC_MoveChild2,
/* 20956*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20959*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20961*/      OPC_CheckTypeI32,
/* 20962*/      OPC_MoveParent,
/* 20963*/      OPC_CheckType, MVT::v2i64,
/* 20965*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20966*/      OPC_EmitConvertToTarget2,
/* 20967*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 20975*/     /*Scope*/ 17, /*->20993*/
/* 20976*/      OPC_MoveChild2,
/* 20977*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20980*/      OPC_MoveParent,
/* 20981*/      OPC_CheckType, MVT::v2i64,
/* 20983*/      OPC_EmitInteger32, 0, 
/* 20985*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 20993*/     0, /*End of Scope*/
/* 20994*/    /*Scope*/ 44, /*->21039*/
/* 20995*/     OPC_CheckChild1Type, MVT::f32,
/* 20997*/     OPC_Scope, 21, /*->21020*/ // 2 children in Scope
/* 20999*/      OPC_RecordChild2, // #2 = $idx
/* 21000*/      OPC_MoveChild2,
/* 21001*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21004*/      OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 21006*/      OPC_CheckTypeI32,
/* 21007*/      OPC_MoveParent,
/* 21008*/      OPC_CheckType, MVT::v4f32,
/* 21010*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21011*/      OPC_EmitConvertToTarget2,
/* 21012*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 21020*/     /*Scope*/ 17, /*->21038*/
/* 21021*/      OPC_MoveChild2,
/* 21022*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21025*/      OPC_MoveParent,
/* 21026*/      OPC_CheckType, MVT::v4f32,
/* 21028*/      OPC_EmitInteger32, 0, 
/* 21030*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 21038*/     0, /*End of Scope*/
/* 21039*/    /*Scope*/ 44, /*->21084*/
/* 21040*/     OPC_CheckChild1Type, MVT::f64,
/* 21042*/     OPC_Scope, 21, /*->21065*/ // 2 children in Scope
/* 21044*/      OPC_RecordChild2, // #2 = $idx
/* 21045*/      OPC_MoveChild2,
/* 21046*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21049*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 21051*/      OPC_CheckTypeI32,
/* 21052*/      OPC_MoveParent,
/* 21053*/      OPC_CheckType, MVT::v2f64,
/* 21055*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21056*/      OPC_EmitConvertToTarget2,
/* 21057*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 21065*/     /*Scope*/ 17, /*->21083*/
/* 21066*/      OPC_MoveChild2,
/* 21067*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21070*/      OPC_MoveParent,
/* 21071*/      OPC_CheckType, MVT::v2f64,
/* 21073*/      OPC_EmitInteger32, 0, 
/* 21075*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 21083*/     0, /*End of Scope*/
/* 21084*/    0, /*End of Scope*/
/* 21085*/   0, /*End of Scope*/
/* 21086*/  0, /*End of Scope*/
/* 21087*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->21315
/* 21091*/  OPC_Scope, 87, /*->21180*/ // 2 children in Scope
/* 21093*/   OPC_MoveChild0,
/* 21094*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21097*/   OPC_MoveChild0,
/* 21098*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->21139
/* 21102*/    OPC_RecordChild0, // #0 = $lhs
/* 21103*/    OPC_RecordChild1, // #1 = $rhs
/* 21104*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21106*/    OPC_MoveSibling1,
/* 21107*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21110*/    OPC_CheckChild0Integer, 2, 
/* 21112*/    OPC_CheckChild0TypeI32,
/* 21113*/    OPC_MoveParent,
/* 21114*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21116*/    OPC_MoveParent,
/* 21117*/    OPC_CheckChild1Integer, 2, 
/* 21119*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21129
/* 21122*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21129*/    /*SwitchType*/ 7, MVT::v8i16,// ->21138
/* 21131*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21138*/    0, // EndSwitchType
/* 21139*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21179
/* 21142*/    OPC_CheckChild0Integer, 2, 
/* 21144*/    OPC_CheckChild0TypeI32,
/* 21145*/    OPC_MoveSibling1,
/* 21146*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21149*/    OPC_RecordChild0, // #0 = $lhs
/* 21150*/    OPC_RecordChild1, // #1 = $rhs
/* 21151*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21153*/    OPC_MoveParent,
/* 21154*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21156*/    OPC_MoveParent,
/* 21157*/    OPC_CheckChild1Integer, 2, 
/* 21159*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21169
/* 21162*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21169*/    /*SwitchType*/ 7, MVT::v8i16,// ->21178
/* 21171*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21178*/    0, // EndSwitchType
/* 21179*/   0, // EndSwitchOpcode
/* 21180*/  /*Scope*/ 4|128,1/*132*/, /*->21314*/
/* 21182*/   OPC_RecordChild0, // #0 = $lhs
/* 21183*/   OPC_Scope, 84, /*->21269*/ // 2 children in Scope
/* 21185*/    OPC_MoveChild1,
/* 21186*/    OPC_Scope, 24, /*->21212*/ // 5 children in Scope
/* 21188*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21191*/     OPC_MoveChild0,
/* 21192*/     OPC_CheckAndImm, 63, 
/* 21194*/     OPC_RecordChild0, // #1 = $rhs
/* 21195*/     OPC_MoveParent,
/* 21196*/     OPC_MoveParent,
/* 21197*/     OPC_CheckType, MVT::v2i64,
/* 21199*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 21205*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 21212*/    /*Scope*/ 13, /*->21226*/
/* 21213*/     OPC_CheckAndImm, 7, 
/* 21215*/     OPC_RecordChild0, // #1 = $rhs
/* 21216*/     OPC_MoveParent,
/* 21217*/     OPC_CheckType, MVT::v16i8,
/* 21219*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21226*/    /*Scope*/ 13, /*->21240*/
/* 21227*/     OPC_CheckAndImm, 15, 
/* 21229*/     OPC_RecordChild0, // #1 = $rhs
/* 21230*/     OPC_MoveParent,
/* 21231*/     OPC_CheckType, MVT::v8i16,
/* 21233*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21240*/    /*Scope*/ 13, /*->21254*/
/* 21241*/     OPC_CheckAndImm, 31, 
/* 21243*/     OPC_RecordChild0, // #1 = $rhs
/* 21244*/     OPC_MoveParent,
/* 21245*/     OPC_CheckType, MVT::v4i32,
/* 21247*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21254*/    /*Scope*/ 13, /*->21268*/
/* 21255*/     OPC_CheckAndImm, 63, 
/* 21257*/     OPC_RecordChild0, // #1 = $rhs
/* 21258*/     OPC_MoveParent,
/* 21259*/     OPC_CheckType, MVT::v2i64,
/* 21261*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21268*/    0, /*End of Scope*/
/* 21269*/   /*Scope*/ 43, /*->21313*/
/* 21270*/    OPC_RecordChild1, // #1 = $x
/* 21271*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->21282
/* 21274*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21275*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 21282*/    /*SwitchType*/ 8, MVT::v8i16,// ->21292
/* 21284*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21285*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 21292*/    /*SwitchType*/ 8, MVT::v4i32,// ->21302
/* 21294*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21295*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 21302*/    /*SwitchType*/ 8, MVT::v2i64,// ->21312
/* 21304*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21305*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 21312*/    0, // EndSwitchType
/* 21313*/   0, /*End of Scope*/
/* 21314*/  0, /*End of Scope*/
/* 21315*/ /*SwitchOpcode*/ 14|128,4/*526*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21845
/* 21319*/  OPC_Scope, 73|128,1/*201*/, /*->21523*/ // 4 children in Scope
/* 21322*/   OPC_MoveChild0,
/* 21323*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21326*/   OPC_RecordMemRef,
/* 21327*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21328*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21329*/   OPC_Scope, 95, /*->21426*/ // 2 children in Scope
/* 21331*/    OPC_CheckChild1TypeI32,
/* 21332*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21334*/    OPC_Scope, 45, /*->21381*/ // 2 children in Scope
/* 21336*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 21338*/     OPC_CheckTypeI32,
/* 21339*/     OPC_Scope, 19, /*->21360*/ // 2 children in Scope
/* 21341*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21342*/      OPC_MoveParent,
/* 21343*/      OPC_CheckType, MVT::v16i8,
/* 21345*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21346*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21348*/      OPC_EmitMergeInputChains1_0,
/* 21349*/      OPC_EmitInteger32, 0, 
/* 21351*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21360*/     /*Scope*/ 19, /*->21380*/
/* 21361*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21362*/      OPC_MoveParent,
/* 21363*/      OPC_CheckType, MVT::v8i16,
/* 21365*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21366*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21368*/      OPC_EmitMergeInputChains1_0,
/* 21369*/      OPC_EmitInteger32, 0, 
/* 21371*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21380*/     0, /*End of Scope*/
/* 21381*/    /*Scope*/ 43, /*->21425*/
/* 21382*/     OPC_CheckPredicate7,  // Predicate_load
/* 21383*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21404
/* 21386*/      OPC_MoveParent,
/* 21387*/      OPC_CheckType, MVT::v4i32,
/* 21389*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21390*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21392*/      OPC_EmitMergeInputChains1_0,
/* 21393*/      OPC_EmitInteger32, 0, 
/* 21395*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21404*/     /*SwitchType*/ 18, MVT::i64,// ->21424
/* 21406*/      OPC_MoveParent,
/* 21407*/      OPC_CheckType, MVT::v2i64,
/* 21409*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21410*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21412*/      OPC_EmitMergeInputChains1_0,
/* 21413*/      OPC_EmitInteger32, 0, 
/* 21415*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21424*/     0, // EndSwitchType
/* 21425*/    0, /*End of Scope*/
/* 21426*/   /*Scope*/ 95, /*->21522*/
/* 21427*/    OPC_CheckChild1TypeI64,
/* 21428*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21430*/    OPC_Scope, 45, /*->21477*/ // 2 children in Scope
/* 21432*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 21434*/     OPC_CheckTypeI32,
/* 21435*/     OPC_Scope, 19, /*->21456*/ // 2 children in Scope
/* 21437*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21438*/      OPC_MoveParent,
/* 21439*/      OPC_CheckType, MVT::v16i8,
/* 21441*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21442*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21444*/      OPC_EmitMergeInputChains1_0,
/* 21445*/      OPC_EmitInteger32, 0, 
/* 21447*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21456*/     /*Scope*/ 19, /*->21476*/
/* 21457*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21458*/      OPC_MoveParent,
/* 21459*/      OPC_CheckType, MVT::v8i16,
/* 21461*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21462*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21464*/      OPC_EmitMergeInputChains1_0,
/* 21465*/      OPC_EmitInteger32, 0, 
/* 21467*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21476*/     0, /*End of Scope*/
/* 21477*/    /*Scope*/ 43, /*->21521*/
/* 21478*/     OPC_CheckPredicate7,  // Predicate_load
/* 21479*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21500
/* 21482*/      OPC_MoveParent,
/* 21483*/      OPC_CheckType, MVT::v4i32,
/* 21485*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21486*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21488*/      OPC_EmitMergeInputChains1_0,
/* 21489*/      OPC_EmitInteger32, 0, 
/* 21491*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21500*/     /*SwitchType*/ 18, MVT::i64,// ->21520
/* 21502*/      OPC_MoveParent,
/* 21503*/      OPC_CheckType, MVT::v2i64,
/* 21505*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21506*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21508*/      OPC_EmitMergeInputChains1_0,
/* 21509*/      OPC_EmitInteger32, 0, 
/* 21511*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21520*/     0, // EndSwitchType
/* 21521*/    0, /*End of Scope*/
/* 21522*/   0, /*End of Scope*/
/* 21523*/  /*Scope*/ 20|128,1/*148*/, /*->21673*/
/* 21525*/   OPC_RecordChild0, // #0 = $x
/* 21526*/   OPC_Scope, 102, /*->21630*/ // 3 children in Scope
/* 21528*/    OPC_MoveChild0,
/* 21529*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21532*/    OPC_SwitchType /*2 cases */, 80, MVT::i32,// ->21615
/* 21535*/     OPC_MoveParent,
/* 21536*/     OPC_SwitchType /*3 cases */, 37, MVT::v16i8,// ->21576
/* 21539*/      OPC_EmitConvertToTarget0,
/* 21540*/      OPC_EmitConvertToTarget0,
/* 21541*/      OPC_EmitConvertToTarget0,
/* 21542*/      OPC_EmitConvertToTarget0,
/* 21543*/      OPC_EmitConvertToTarget0,
/* 21544*/      OPC_EmitConvertToTarget0,
/* 21545*/      OPC_EmitConvertToTarget0,
/* 21546*/      OPC_EmitConvertToTarget0,
/* 21547*/      OPC_EmitConvertToTarget0,
/* 21548*/      OPC_EmitConvertToTarget0,
/* 21549*/      OPC_EmitConvertToTarget0,
/* 21550*/      OPC_EmitConvertToTarget0,
/* 21551*/      OPC_EmitConvertToTarget0,
/* 21552*/      OPC_EmitConvertToTarget0,
/* 21553*/      OPC_EmitConvertToTarget0,
/* 21554*/      OPC_EmitConvertToTarget0,
/* 21555*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    MVT::v16i8, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21576*/     /*SwitchType*/ 21, MVT::v8i16,// ->21599
/* 21578*/      OPC_EmitConvertToTarget0,
/* 21579*/      OPC_EmitConvertToTarget0,
/* 21580*/      OPC_EmitConvertToTarget0,
/* 21581*/      OPC_EmitConvertToTarget0,
/* 21582*/      OPC_EmitConvertToTarget0,
/* 21583*/      OPC_EmitConvertToTarget0,
/* 21584*/      OPC_EmitConvertToTarget0,
/* 21585*/      OPC_EmitConvertToTarget0,
/* 21586*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    MVT::v8i16, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21599*/     /*SwitchType*/ 13, MVT::v4i32,// ->21614
/* 21601*/      OPC_EmitConvertToTarget0,
/* 21602*/      OPC_EmitConvertToTarget0,
/* 21603*/      OPC_EmitConvertToTarget0,
/* 21604*/      OPC_EmitConvertToTarget0,
/* 21605*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    MVT::v4i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 21614*/     0, // EndSwitchType
/* 21615*/    /*SwitchType*/ 12, MVT::i64,// ->21629
/* 21617*/     OPC_MoveParent,
/* 21618*/     OPC_CheckType, MVT::v2i64,
/* 21620*/     OPC_EmitConvertToTarget0,
/* 21621*/     OPC_EmitConvertToTarget0,
/* 21622*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 21629*/    0, // EndSwitchType
/* 21630*/   /*Scope*/ 30, /*->21661*/
/* 21631*/    OPC_CheckChild0TypeI32,
/* 21632*/    OPC_SwitchType /*3 cases */, 7, MVT::v16i8,// ->21642
/* 21635*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21636*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 21642*/    /*SwitchType*/ 7, MVT::v8i16,// ->21651
/* 21644*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21645*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 21651*/    /*SwitchType*/ 7, MVT::v4i32,// ->21660
/* 21653*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21654*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 21660*/    0, // EndSwitchType
/* 21661*/   /*Scope*/ 10, /*->21672*/
/* 21662*/    OPC_CheckChild0TypeI64,
/* 21663*/    OPC_CheckType, MVT::v2i64,
/* 21665*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21666*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 21672*/   0, /*End of Scope*/
/* 21673*/  /*Scope*/ 103, /*->21777*/
/* 21674*/   OPC_MoveChild0,
/* 21675*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21678*/   OPC_RecordMemRef,
/* 21679*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21680*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21681*/   OPC_Scope, 46, /*->21729*/ // 2 children in Scope
/* 21683*/    OPC_CheckChild1TypeI32,
/* 21684*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21686*/    OPC_CheckPredicate7,  // Predicate_load
/* 21687*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->21708
/* 21690*/     OPC_MoveParent,
/* 21691*/     OPC_CheckType, MVT::v4f32,
/* 21693*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21694*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21696*/     OPC_EmitMergeInputChains1_0,
/* 21697*/     OPC_EmitInteger32, 0, 
/* 21699*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21708*/    /*SwitchType*/ 18, MVT::f64,// ->21728
/* 21710*/     OPC_MoveParent,
/* 21711*/     OPC_CheckType, MVT::v2f64,
/* 21713*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21714*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21716*/     OPC_EmitMergeInputChains1_0,
/* 21717*/     OPC_EmitInteger32, 0, 
/* 21719*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21728*/    0, // EndSwitchType
/* 21729*/   /*Scope*/ 46, /*->21776*/
/* 21730*/    OPC_CheckChild1TypeI64,
/* 21731*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21733*/    OPC_CheckPredicate7,  // Predicate_load
/* 21734*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->21755
/* 21737*/     OPC_MoveParent,
/* 21738*/     OPC_CheckType, MVT::v4f32,
/* 21740*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21741*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21743*/     OPC_EmitMergeInputChains1_0,
/* 21744*/     OPC_EmitInteger32, 0, 
/* 21746*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21755*/    /*SwitchType*/ 18, MVT::f64,// ->21775
/* 21757*/     OPC_MoveParent,
/* 21758*/     OPC_CheckType, MVT::v2f64,
/* 21760*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21761*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21763*/     OPC_EmitMergeInputChains1_0,
/* 21764*/     OPC_EmitInteger32, 0, 
/* 21766*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21775*/    0, // EndSwitchType
/* 21776*/   0, /*End of Scope*/
/* 21777*/  /*Scope*/ 66, /*->21844*/
/* 21778*/   OPC_RecordChild0, // #0 = $x
/* 21779*/   OPC_Scope, 38, /*->21819*/ // 3 children in Scope
/* 21781*/    OPC_MoveChild0,
/* 21782*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 21785*/    OPC_SwitchType /*2 cases */, 16, MVT::f32,// ->21804
/* 21788*/     OPC_MoveParent,
/* 21789*/     OPC_CheckType, MVT::v4f32,
/* 21791*/     OPC_EmitConvertToTarget0,
/* 21792*/     OPC_EmitConvertToTarget0,
/* 21793*/     OPC_EmitConvertToTarget0,
/* 21794*/     OPC_EmitConvertToTarget0,
/* 21795*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   MVT::v4f32, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 21804*/    /*SwitchType*/ 12, MVT::f64,// ->21818
/* 21806*/     OPC_MoveParent,
/* 21807*/     OPC_CheckType, MVT::v2f64,
/* 21809*/     OPC_EmitConvertToTarget0,
/* 21810*/     OPC_EmitConvertToTarget0,
/* 21811*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   MVT::v2f64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 21818*/    0, // EndSwitchType
/* 21819*/   /*Scope*/ 11, /*->21831*/
/* 21820*/    OPC_CheckChild0Type, MVT::f32,
/* 21822*/    OPC_CheckType, MVT::v4f32,
/* 21824*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21825*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 21831*/   /*Scope*/ 11, /*->21843*/
/* 21832*/    OPC_CheckChild0Type, MVT::f64,
/* 21834*/    OPC_CheckType, MVT::v2f64,
/* 21836*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21837*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 21843*/   0, /*End of Scope*/
/* 21844*/  0, /*End of Scope*/
/* 21845*/ /*SwitchOpcode*/ 42|128,1/*170*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->22019
/* 21849*/  OPC_Scope, 103, /*->21954*/ // 2 children in Scope
/* 21851*/   OPC_MoveChild0,
/* 21852*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21855*/   OPC_RecordMemRef,
/* 21856*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21857*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21858*/   OPC_Scope, 46, /*->21906*/ // 2 children in Scope
/* 21860*/    OPC_CheckChild1TypeI32,
/* 21861*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21863*/    OPC_CheckPredicate7,  // Predicate_load
/* 21864*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21885
/* 21867*/     OPC_MoveParent,
/* 21868*/     OPC_CheckType, MVT::v4i32,
/* 21870*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21871*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21873*/     OPC_EmitMergeInputChains1_0,
/* 21874*/     OPC_EmitInteger32, 0, 
/* 21876*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21885*/    /*SwitchType*/ 18, MVT::i64,// ->21905
/* 21887*/     OPC_MoveParent,
/* 21888*/     OPC_CheckType, MVT::v2i64,
/* 21890*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21891*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21893*/     OPC_EmitMergeInputChains1_0,
/* 21894*/     OPC_EmitInteger32, 0, 
/* 21896*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21905*/    0, // EndSwitchType
/* 21906*/   /*Scope*/ 46, /*->21953*/
/* 21907*/    OPC_CheckChild1TypeI64,
/* 21908*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21910*/    OPC_CheckPredicate7,  // Predicate_load
/* 21911*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21932
/* 21914*/     OPC_MoveParent,
/* 21915*/     OPC_CheckType, MVT::v4i32,
/* 21917*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21918*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21920*/     OPC_EmitMergeInputChains1_0,
/* 21921*/     OPC_EmitInteger32, 0, 
/* 21923*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21932*/    /*SwitchType*/ 18, MVT::i64,// ->21952
/* 21934*/     OPC_MoveParent,
/* 21935*/     OPC_CheckType, MVT::v2i64,
/* 21937*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21938*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21940*/     OPC_EmitMergeInputChains1_0,
/* 21941*/     OPC_EmitInteger32, 0, 
/* 21943*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21952*/    0, // EndSwitchType
/* 21953*/   0, /*End of Scope*/
/* 21954*/  /*Scope*/ 63, /*->22018*/
/* 21955*/   OPC_RecordChild0, // #0 = $x
/* 21956*/   OPC_Scope, 27, /*->21985*/ // 4 children in Scope
/* 21958*/    OPC_CheckChild0TypeI32,
/* 21959*/    OPC_SwitchType /*3 cases */, 6, MVT::v16i8,// ->21968
/* 21962*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 21968*/    /*SwitchType*/ 6, MVT::v8i16,// ->21976
/* 21970*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 21976*/    /*SwitchType*/ 6, MVT::v4i32,// ->21984
/* 21978*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 21984*/    0, // EndSwitchType
/* 21985*/   /*Scope*/ 9, /*->21995*/
/* 21986*/    OPC_CheckChild0TypeI64,
/* 21987*/    OPC_CheckType, MVT::v2i64,
/* 21989*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 21995*/   /*Scope*/ 10, /*->22006*/
/* 21996*/    OPC_CheckChild0Type, MVT::f32,
/* 21998*/    OPC_CheckType, MVT::v4f32,
/* 22000*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 22006*/   /*Scope*/ 10, /*->22017*/
/* 22007*/    OPC_CheckChild0Type, MVT::f64,
/* 22009*/    OPC_CheckType, MVT::v2f64,
/* 22011*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 22017*/   0, /*End of Scope*/
/* 22018*/  0, /*End of Scope*/
/* 22019*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->22155
/* 22023*/  OPC_RecordChild0, // #0 = $lhs
/* 22024*/  OPC_Scope, 84, /*->22110*/ // 2 children in Scope
/* 22026*/   OPC_MoveChild1,
/* 22027*/   OPC_Scope, 24, /*->22053*/ // 5 children in Scope
/* 22029*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22032*/    OPC_MoveChild0,
/* 22033*/    OPC_CheckAndImm, 63, 
/* 22035*/    OPC_RecordChild0, // #1 = $rhs
/* 22036*/    OPC_MoveParent,
/* 22037*/    OPC_MoveParent,
/* 22038*/    OPC_CheckType, MVT::v2i64,
/* 22040*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22046*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22053*/   /*Scope*/ 13, /*->22067*/
/* 22054*/    OPC_CheckAndImm, 7, 
/* 22056*/    OPC_RecordChild0, // #1 = $rhs
/* 22057*/    OPC_MoveParent,
/* 22058*/    OPC_CheckType, MVT::v16i8,
/* 22060*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22067*/   /*Scope*/ 13, /*->22081*/
/* 22068*/    OPC_CheckAndImm, 15, 
/* 22070*/    OPC_RecordChild0, // #1 = $rhs
/* 22071*/    OPC_MoveParent,
/* 22072*/    OPC_CheckType, MVT::v8i16,
/* 22074*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22081*/   /*Scope*/ 13, /*->22095*/
/* 22082*/    OPC_CheckAndImm, 31, 
/* 22084*/    OPC_RecordChild0, // #1 = $rhs
/* 22085*/    OPC_MoveParent,
/* 22086*/    OPC_CheckType, MVT::v4i32,
/* 22088*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22095*/   /*Scope*/ 13, /*->22109*/
/* 22096*/    OPC_CheckAndImm, 63, 
/* 22098*/    OPC_RecordChild0, // #1 = $rhs
/* 22099*/    OPC_MoveParent,
/* 22100*/    OPC_CheckType, MVT::v2i64,
/* 22102*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22109*/   0, /*End of Scope*/
/* 22110*/  /*Scope*/ 43, /*->22154*/
/* 22111*/   OPC_RecordChild1, // #1 = $x
/* 22112*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22123
/* 22115*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22116*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22123*/   /*SwitchType*/ 8, MVT::v8i16,// ->22133
/* 22125*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22126*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22133*/   /*SwitchType*/ 8, MVT::v4i32,// ->22143
/* 22135*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22136*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22143*/   /*SwitchType*/ 8, MVT::v2i64,// ->22153
/* 22145*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22146*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22153*/   0, // EndSwitchType
/* 22154*/  0, /*End of Scope*/
/* 22155*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->22291
/* 22159*/  OPC_RecordChild0, // #0 = $lhs
/* 22160*/  OPC_Scope, 84, /*->22246*/ // 2 children in Scope
/* 22162*/   OPC_MoveChild1,
/* 22163*/   OPC_Scope, 24, /*->22189*/ // 5 children in Scope
/* 22165*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22168*/    OPC_MoveChild0,
/* 22169*/    OPC_CheckAndImm, 63, 
/* 22171*/    OPC_RecordChild0, // #1 = $rhs
/* 22172*/    OPC_MoveParent,
/* 22173*/    OPC_MoveParent,
/* 22174*/    OPC_CheckType, MVT::v2i64,
/* 22176*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22182*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22189*/   /*Scope*/ 13, /*->22203*/
/* 22190*/    OPC_CheckAndImm, 7, 
/* 22192*/    OPC_RecordChild0, // #1 = $rhs
/* 22193*/    OPC_MoveParent,
/* 22194*/    OPC_CheckType, MVT::v16i8,
/* 22196*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22203*/   /*Scope*/ 13, /*->22217*/
/* 22204*/    OPC_CheckAndImm, 15, 
/* 22206*/    OPC_RecordChild0, // #1 = $rhs
/* 22207*/    OPC_MoveParent,
/* 22208*/    OPC_CheckType, MVT::v8i16,
/* 22210*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22217*/   /*Scope*/ 13, /*->22231*/
/* 22218*/    OPC_CheckAndImm, 31, 
/* 22220*/    OPC_RecordChild0, // #1 = $rhs
/* 22221*/    OPC_MoveParent,
/* 22222*/    OPC_CheckType, MVT::v4i32,
/* 22224*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22231*/   /*Scope*/ 13, /*->22245*/
/* 22232*/    OPC_CheckAndImm, 63, 
/* 22234*/    OPC_RecordChild0, // #1 = $rhs
/* 22235*/    OPC_MoveParent,
/* 22236*/    OPC_CheckType, MVT::v2i64,
/* 22238*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22245*/   0, /*End of Scope*/
/* 22246*/  /*Scope*/ 43, /*->22290*/
/* 22247*/   OPC_RecordChild1, // #1 = $x
/* 22248*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22259
/* 22251*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22252*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22259*/   /*SwitchType*/ 8, MVT::v8i16,// ->22269
/* 22261*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22262*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22269*/   /*SwitchType*/ 8, MVT::v4i32,// ->22279
/* 22271*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22272*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22279*/   /*SwitchType*/ 8, MVT::v2i64,// ->22289
/* 22281*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22282*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22289*/   0, // EndSwitchType
/* 22290*/  0, /*End of Scope*/
/* 22291*/ /*SwitchOpcode*/ 14|128,5/*654*/, TARGET_VAL(ISD::VSELECT),// ->22949
/* 22295*/  OPC_Scope, 12|128,1/*140*/, /*->22438*/ // 4 children in Scope
/* 22298*/   OPC_MoveChild0,
/* 22299*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 22302*/   OPC_MoveChild0,
/* 22303*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22306*/   OPC_RecordChild0, // #0 = $rhs
/* 22307*/   OPC_SwitchType /*3 cases */, 41, MVT::v4f32,// ->22351
/* 22310*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22312*/    OPC_MoveSibling1,
/* 22313*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22316*/    OPC_RecordChild0, // #1 = $lhs
/* 22317*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22319*/    OPC_MoveParent,
/* 22320*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22322*/    OPC_MoveParent,
/* 22323*/    OPC_CheckType, MVT::v4i32,
/* 22325*/    OPC_Scope, 11, /*->22338*/ // 2 children in Scope
/* 22327*/     OPC_CheckChild1Same, 0,
/* 22329*/     OPC_CheckChild2Same, 1,
/* 22331*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22338*/    /*Scope*/ 11, /*->22350*/
/* 22339*/     OPC_CheckChild1Same, 1,
/* 22341*/     OPC_CheckChild2Same, 0,
/* 22343*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22350*/    0, /*End of Scope*/
/* 22351*/   /*SwitchType*/ 41, MVT::v2f64,// ->22394
/* 22353*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22355*/    OPC_MoveSibling1,
/* 22356*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22359*/    OPC_RecordChild0, // #1 = $lhs
/* 22360*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22362*/    OPC_MoveParent,
/* 22363*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22365*/    OPC_MoveParent,
/* 22366*/    OPC_CheckType, MVT::v2i64,
/* 22368*/    OPC_Scope, 11, /*->22381*/ // 2 children in Scope
/* 22370*/     OPC_CheckChild1Same, 0,
/* 22372*/     OPC_CheckChild2Same, 1,
/* 22374*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22381*/    /*Scope*/ 11, /*->22393*/
/* 22382*/     OPC_CheckChild1Same, 1,
/* 22384*/     OPC_CheckChild2Same, 0,
/* 22386*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22393*/    0, /*End of Scope*/
/* 22394*/   /*SwitchType*/ 41, MVT::v8f16,// ->22437
/* 22396*/    OPC_CheckChild0Type, MVT::v8i16,
/* 22398*/    OPC_MoveSibling1,
/* 22399*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22402*/    OPC_RecordChild0, // #1 = $lhs
/* 22403*/    OPC_CheckChild0Type, MVT::v8i16,
/* 22405*/    OPC_MoveParent,
/* 22406*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22408*/    OPC_MoveParent,
/* 22409*/    OPC_CheckType, MVT::v8i16,
/* 22411*/    OPC_Scope, 11, /*->22424*/ // 2 children in Scope
/* 22413*/     OPC_CheckChild1Same, 0,
/* 22415*/     OPC_CheckChild2Same, 1,
/* 22417*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   MVT::v8i16, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22424*/    /*Scope*/ 11, /*->22436*/
/* 22425*/     OPC_CheckChild1Same, 1,
/* 22427*/     OPC_CheckChild2Same, 0,
/* 22429*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22436*/    0, /*End of Scope*/
/* 22437*/   0, // EndSwitchType
/* 22438*/  /*Scope*/ 45, /*->22484*/
/* 22439*/   OPC_RecordChild0, // #0 = $c
/* 22440*/   OPC_RecordChild1, // #1 = $v1
/* 22441*/   OPC_RecordChild2, // #2 = $v2
/* 22442*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->22453
/* 22445*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 22453*/   /*SwitchType*/ 8, MVT::v8i16,// ->22463
/* 22455*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 22463*/   /*SwitchType*/ 8, MVT::v4i32,// ->22473
/* 22465*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 22473*/   /*SwitchType*/ 8, MVT::v2i64,// ->22483
/* 22475*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 22483*/   0, // EndSwitchType
/* 22484*/  /*Scope*/ 52|128,3/*436*/, /*->22922*/
/* 22486*/   OPC_MoveChild0,
/* 22487*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 22490*/   OPC_RecordChild0, // #0 = $rhs
/* 22491*/   OPC_Scope, 13|128,1/*141*/, /*->22635*/ // 3 children in Scope
/* 22494*/    OPC_CheckChild0Type, MVT::v4f32,
/* 22496*/    OPC_RecordChild1, // #1 = $lhs
/* 22497*/    OPC_Scope, 33, /*->22532*/ // 4 children in Scope
/* 22499*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22501*/     OPC_MoveParent,
/* 22502*/     OPC_CheckType, MVT::v4f32,
/* 22504*/     OPC_Scope, 12, /*->22518*/ // 2 children in Scope
/* 22506*/      OPC_CheckChild1Same, 0,
/* 22508*/      OPC_CheckChild2Same, 1,
/* 22510*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22511*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22518*/     /*Scope*/ 12, /*->22531*/
/* 22519*/      OPC_CheckChild1Same, 1,
/* 22521*/      OPC_CheckChild2Same, 0,
/* 22523*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22524*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22531*/     0, /*End of Scope*/
/* 22532*/    /*Scope*/ 33, /*->22566*/
/* 22533*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22535*/     OPC_MoveParent,
/* 22536*/     OPC_CheckType, MVT::v4f32,
/* 22538*/     OPC_Scope, 12, /*->22552*/ // 2 children in Scope
/* 22540*/      OPC_CheckChild1Same, 0,
/* 22542*/      OPC_CheckChild2Same, 1,
/* 22544*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22545*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22552*/     /*Scope*/ 12, /*->22565*/
/* 22553*/      OPC_CheckChild1Same, 1,
/* 22555*/      OPC_CheckChild2Same, 0,
/* 22557*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22558*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22565*/     0, /*End of Scope*/
/* 22566*/    /*Scope*/ 33, /*->22600*/
/* 22567*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22569*/     OPC_MoveParent,
/* 22570*/     OPC_CheckType, MVT::v4f32,
/* 22572*/     OPC_Scope, 12, /*->22586*/ // 2 children in Scope
/* 22574*/      OPC_CheckChild1Same, 1,
/* 22576*/      OPC_CheckChild2Same, 0,
/* 22578*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22579*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22586*/     /*Scope*/ 12, /*->22599*/
/* 22587*/      OPC_CheckChild1Same, 0,
/* 22589*/      OPC_CheckChild2Same, 1,
/* 22591*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22592*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22599*/     0, /*End of Scope*/
/* 22600*/    /*Scope*/ 33, /*->22634*/
/* 22601*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22603*/     OPC_MoveParent,
/* 22604*/     OPC_CheckType, MVT::v4f32,
/* 22606*/     OPC_Scope, 12, /*->22620*/ // 2 children in Scope
/* 22608*/      OPC_CheckChild1Same, 1,
/* 22610*/      OPC_CheckChild2Same, 0,
/* 22612*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22613*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22620*/     /*Scope*/ 12, /*->22633*/
/* 22621*/      OPC_CheckChild1Same, 0,
/* 22623*/      OPC_CheckChild2Same, 1,
/* 22625*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22626*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 22633*/     0, /*End of Scope*/
/* 22634*/    0, /*End of Scope*/
/* 22635*/   /*Scope*/ 13|128,1/*141*/, /*->22778*/
/* 22637*/    OPC_CheckChild0Type, MVT::v2f64,
/* 22639*/    OPC_RecordChild1, // #1 = $lhs
/* 22640*/    OPC_Scope, 33, /*->22675*/ // 4 children in Scope
/* 22642*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22644*/     OPC_MoveParent,
/* 22645*/     OPC_CheckType, MVT::v2f64,
/* 22647*/     OPC_Scope, 12, /*->22661*/ // 2 children in Scope
/* 22649*/      OPC_CheckChild1Same, 0,
/* 22651*/      OPC_CheckChild2Same, 1,
/* 22653*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22654*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22661*/     /*Scope*/ 12, /*->22674*/
/* 22662*/      OPC_CheckChild1Same, 1,
/* 22664*/      OPC_CheckChild2Same, 0,
/* 22666*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22667*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22674*/     0, /*End of Scope*/
/* 22675*/    /*Scope*/ 33, /*->22709*/
/* 22676*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22678*/     OPC_MoveParent,
/* 22679*/     OPC_CheckType, MVT::v2f64,
/* 22681*/     OPC_Scope, 12, /*->22695*/ // 2 children in Scope
/* 22683*/      OPC_CheckChild1Same, 0,
/* 22685*/      OPC_CheckChild2Same, 1,
/* 22687*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22688*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22695*/     /*Scope*/ 12, /*->22708*/
/* 22696*/      OPC_CheckChild1Same, 1,
/* 22698*/      OPC_CheckChild2Same, 0,
/* 22700*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22701*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22708*/     0, /*End of Scope*/
/* 22709*/    /*Scope*/ 33, /*->22743*/
/* 22710*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22712*/     OPC_MoveParent,
/* 22713*/     OPC_CheckType, MVT::v2f64,
/* 22715*/     OPC_Scope, 12, /*->22729*/ // 2 children in Scope
/* 22717*/      OPC_CheckChild1Same, 1,
/* 22719*/      OPC_CheckChild2Same, 0,
/* 22721*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22722*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22729*/     /*Scope*/ 12, /*->22742*/
/* 22730*/      OPC_CheckChild1Same, 0,
/* 22732*/      OPC_CheckChild2Same, 1,
/* 22734*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22735*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22742*/     0, /*End of Scope*/
/* 22743*/    /*Scope*/ 33, /*->22777*/
/* 22744*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22746*/     OPC_MoveParent,
/* 22747*/     OPC_CheckType, MVT::v2f64,
/* 22749*/     OPC_Scope, 12, /*->22763*/ // 2 children in Scope
/* 22751*/      OPC_CheckChild1Same, 1,
/* 22753*/      OPC_CheckChild2Same, 0,
/* 22755*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22756*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22763*/     /*Scope*/ 12, /*->22776*/
/* 22764*/      OPC_CheckChild1Same, 0,
/* 22766*/      OPC_CheckChild2Same, 1,
/* 22768*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22769*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22776*/     0, /*End of Scope*/
/* 22777*/    0, /*End of Scope*/
/* 22778*/   /*Scope*/ 13|128,1/*141*/, /*->22921*/
/* 22780*/    OPC_CheckChild0Type, MVT::v8f16,
/* 22782*/    OPC_RecordChild1, // #1 = $lhs
/* 22783*/    OPC_Scope, 33, /*->22818*/ // 4 children in Scope
/* 22785*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22787*/     OPC_MoveParent,
/* 22788*/     OPC_CheckType, MVT::v8f16,
/* 22790*/     OPC_Scope, 12, /*->22804*/ // 2 children in Scope
/* 22792*/      OPC_CheckChild1Same, 0,
/* 22794*/      OPC_CheckChild2Same, 1,
/* 22796*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22797*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22804*/     /*Scope*/ 12, /*->22817*/
/* 22805*/      OPC_CheckChild1Same, 1,
/* 22807*/      OPC_CheckChild2Same, 0,
/* 22809*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22810*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22817*/     0, /*End of Scope*/
/* 22818*/    /*Scope*/ 33, /*->22852*/
/* 22819*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 22821*/     OPC_MoveParent,
/* 22822*/     OPC_CheckType, MVT::v8f16,
/* 22824*/     OPC_Scope, 12, /*->22838*/ // 2 children in Scope
/* 22826*/      OPC_CheckChild1Same, 0,
/* 22828*/      OPC_CheckChild2Same, 1,
/* 22830*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22831*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22838*/     /*Scope*/ 12, /*->22851*/
/* 22839*/      OPC_CheckChild1Same, 1,
/* 22841*/      OPC_CheckChild2Same, 0,
/* 22843*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22844*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22851*/     0, /*End of Scope*/
/* 22852*/    /*Scope*/ 33, /*->22886*/
/* 22853*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 22855*/     OPC_MoveParent,
/* 22856*/     OPC_CheckType, MVT::v8f16,
/* 22858*/     OPC_Scope, 12, /*->22872*/ // 2 children in Scope
/* 22860*/      OPC_CheckChild1Same, 1,
/* 22862*/      OPC_CheckChild2Same, 0,
/* 22864*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22865*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22872*/     /*Scope*/ 12, /*->22885*/
/* 22873*/      OPC_CheckChild1Same, 0,
/* 22875*/      OPC_CheckChild2Same, 1,
/* 22877*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22878*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22885*/     0, /*End of Scope*/
/* 22886*/    /*Scope*/ 33, /*->22920*/
/* 22887*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 22889*/     OPC_MoveParent,
/* 22890*/     OPC_CheckType, MVT::v8f16,
/* 22892*/     OPC_Scope, 12, /*->22906*/ // 2 children in Scope
/* 22894*/      OPC_CheckChild1Same, 1,
/* 22896*/      OPC_CheckChild2Same, 0,
/* 22898*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22899*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22906*/     /*Scope*/ 12, /*->22919*/
/* 22907*/      OPC_CheckChild1Same, 0,
/* 22909*/      OPC_CheckChild2Same, 1,
/* 22911*/      OPC_CheckPatternPredicate6, // (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128())
/* 22912*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    MVT::v8f16, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 22919*/     0, /*End of Scope*/
/* 22920*/    0, /*End of Scope*/
/* 22921*/   0, /*End of Scope*/
/* 22922*/  /*Scope*/ 25, /*->22948*/
/* 22923*/   OPC_RecordChild0, // #0 = $c
/* 22924*/   OPC_RecordChild1, // #1 = $v1
/* 22925*/   OPC_RecordChild2, // #2 = $v2
/* 22926*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->22937
/* 22929*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 22937*/   /*SwitchType*/ 8, MVT::v2f64,// ->22947
/* 22939*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 22947*/   0, // EndSwitchType
/* 22948*/  0, /*End of Scope*/
/* 22949*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->22968
/* 22952*/  OPC_RecordChild0, // #0 = $src
/* 22953*/  OPC_CheckChild0Type, MVT::v16i8,
/* 22955*/  OPC_RecordChild1, // #1 = $mask
/* 22956*/  OPC_CheckChild1Type, MVT::v16i8,
/* 22958*/  OPC_CheckType, MVT::v16i8,
/* 22960*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22961*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 22968*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->23010
/* 22971*/  OPC_RecordChild0, // #0 = $v
/* 22972*/  OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->22982
/* 22975*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22976*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 22982*/  /*SwitchType*/ 7, MVT::v8i16,// ->22991
/* 22984*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22985*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 22991*/  /*SwitchType*/ 7, MVT::v4i32,// ->23000
/* 22993*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22994*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 23000*/  /*SwitchType*/ 7, MVT::v2i64,// ->23009
/* 23002*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23003*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 23009*/  0, // EndSwitchType
/* 23010*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->23037
/* 23013*/  OPC_RecordChild0, // #0 = $lhs
/* 23014*/  OPC_RecordChild1, // #1 = $rhs
/* 23015*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23026
/* 23018*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23019*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23026*/  /*SwitchType*/ 8, MVT::v8i16,// ->23036
/* 23028*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23029*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23036*/  0, // EndSwitchType
/* 23037*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->23064
/* 23040*/  OPC_RecordChild0, // #0 = $lhs
/* 23041*/  OPC_RecordChild1, // #1 = $rhs
/* 23042*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23053
/* 23045*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23046*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23053*/  /*SwitchType*/ 8, MVT::v8i16,// ->23063
/* 23055*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23056*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23063*/  0, // EndSwitchType
/* 23064*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->23101
/* 23067*/  OPC_RecordChild0, // #0 = $lhs
/* 23068*/  OPC_RecordChild1, // #1 = $rhs
/* 23069*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23080
/* 23072*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23073*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23080*/  /*SwitchType*/ 8, MVT::v8i16,// ->23090
/* 23082*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23083*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23090*/  /*SwitchType*/ 8, MVT::v4i32,// ->23100
/* 23092*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23093*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23100*/  0, // EndSwitchType
/* 23101*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->23138
/* 23104*/  OPC_RecordChild0, // #0 = $lhs
/* 23105*/  OPC_RecordChild1, // #1 = $rhs
/* 23106*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23117
/* 23109*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23110*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23117*/  /*SwitchType*/ 8, MVT::v8i16,// ->23127
/* 23119*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23120*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23127*/  /*SwitchType*/ 8, MVT::v4i32,// ->23137
/* 23129*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23130*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23137*/  0, // EndSwitchType
/* 23138*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->23175
/* 23141*/  OPC_RecordChild0, // #0 = $lhs
/* 23142*/  OPC_RecordChild1, // #1 = $rhs
/* 23143*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23154
/* 23146*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23147*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23154*/  /*SwitchType*/ 8, MVT::v8i16,// ->23164
/* 23156*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23157*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23164*/  /*SwitchType*/ 8, MVT::v4i32,// ->23174
/* 23166*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23167*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23174*/  0, // EndSwitchType
/* 23175*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->23212
/* 23178*/  OPC_RecordChild0, // #0 = $lhs
/* 23179*/  OPC_RecordChild1, // #1 = $rhs
/* 23180*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->23191
/* 23183*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23184*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23191*/  /*SwitchType*/ 8, MVT::v8i16,// ->23201
/* 23193*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23201*/  /*SwitchType*/ 8, MVT::v4i32,// ->23211
/* 23203*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23204*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23211*/  0, // EndSwitchType
/* 23212*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->23227
/* 23215*/  OPC_RecordChild0, // #0 = $vec
/* 23216*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23218*/  OPC_CheckType, MVT::v4i32,
/* 23220*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23221*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23227*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->23242
/* 23230*/  OPC_RecordChild0, // #0 = $vec
/* 23231*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23233*/  OPC_CheckType, MVT::v4i32,
/* 23235*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23236*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23242*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->23281
/* 23245*/  OPC_RecordChild0, // #0 = $vec
/* 23246*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23258
/* 23249*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23251*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23252*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23258*/  /*SwitchType*/ 9, MVT::v4i32,// ->23269
/* 23260*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23262*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23263*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23269*/  /*SwitchType*/ 9, MVT::v2i64,// ->23280
/* 23271*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23273*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23274*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23280*/  0, // EndSwitchType
/* 23281*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->23320
/* 23284*/  OPC_RecordChild0, // #0 = $vec
/* 23285*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23297
/* 23288*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23290*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23291*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23297*/  /*SwitchType*/ 9, MVT::v4i32,// ->23308
/* 23299*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23301*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23302*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23308*/  /*SwitchType*/ 9, MVT::v2i64,// ->23319
/* 23310*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23312*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23313*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23319*/  0, // EndSwitchType
/* 23320*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->23359
/* 23323*/  OPC_RecordChild0, // #0 = $vec
/* 23324*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23336
/* 23327*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23329*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23330*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23336*/  /*SwitchType*/ 9, MVT::v4i32,// ->23347
/* 23338*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23340*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23341*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23347*/  /*SwitchType*/ 9, MVT::v2i64,// ->23358
/* 23349*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23351*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23352*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23358*/  0, // EndSwitchType
/* 23359*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->23398
/* 23362*/  OPC_RecordChild0, // #0 = $vec
/* 23363*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->23375
/* 23366*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23368*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23369*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23375*/  /*SwitchType*/ 9, MVT::v4i32,// ->23386
/* 23377*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23379*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23380*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23386*/  /*SwitchType*/ 9, MVT::v2i64,// ->23397
/* 23388*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23390*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23391*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23397*/  0, // EndSwitchType
/* 23398*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->23432
/* 23401*/  OPC_RecordChild0, // #0 = $left
/* 23402*/  OPC_SwitchType /*2 cases */, 12, MVT::v16i8,// ->23417
/* 23405*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23407*/   OPC_RecordChild1, // #1 = $right
/* 23408*/   OPC_CheckChild1Type, MVT::v8i16,
/* 23410*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 23417*/  /*SwitchType*/ 12, MVT::v8i16,// ->23431
/* 23419*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23421*/   OPC_RecordChild1, // #1 = $right
/* 23422*/   OPC_CheckChild1Type, MVT::v4i32,
/* 23424*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 23431*/  0, // EndSwitchType
/* 23432*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->23447
/* 23435*/  OPC_RecordChild0, // #0 = $vec
/* 23436*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23438*/  OPC_CheckType, MVT::v2f64,
/* 23440*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23441*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23447*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->23462
/* 23450*/  OPC_RecordChild0, // #0 = $vec
/* 23451*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23453*/  OPC_CheckType, MVT::v2f64,
/* 23455*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23456*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23462*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->23477
/* 23465*/  OPC_RecordChild0, // #0 = $vec
/* 23466*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23468*/  OPC_CheckType, MVT::v4f32,
/* 23470*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23471*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 23477*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->23492
/* 23480*/  OPC_RecordChild0, // #0 = $vec
/* 23481*/  OPC_CheckChild0Type, MVT::v4f32,
/* 23483*/  OPC_CheckType, MVT::v2f64,
/* 23485*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23486*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 23492*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 23494 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 342
  // #OPC_RecordNode                           = 285
  // #OPC_RecordChild                          = 736
  // #OPC_RecordMemRef                         = 41
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 294
  // #OPC_MoveSibling                          = 285
  // #OPC_MoveParent                           = 580
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 147
  // #OPC_CheckPatternPredicate                = 711
  // #OPC_CheckPredicate                       = 532
  // #OPC_CheckOpcode                          = 503
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 522
  // #OPC_SwitchType                           = 178
  // #OPC_CheckChildType                       = 450
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 107
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 153
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 322
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 349
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 311
  // #OPC_EmitMergeInputChains                 = 432
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 32
  // #OPC_MorphNodeTo                          = 1209

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 3: return (!Subtarget->hasAddr64());
  case 4: return (Subtarget->hasAddr64());
  case 5: return (Subtarget->hasReferenceTypes());
  case 6: return (Subtarget->hasHalfPrecision()) && (Subtarget->hasSIMD128());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemory());
  case 13: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 14: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasExceptionHandling());
  case 16: return (Subtarget->hasHalfPrecision());
  case 17: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 18: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_8
    // Predicate_atomic_load_and_8
    // Predicate_atomic_load_or_8
    // Predicate_atomic_load_sub_8
    // Predicate_atomic_load_xor_8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_16
    // Predicate_atomic_load_and_16
    // Predicate_atomic_load_or_16
    // Predicate_atomic_load_sub_16
    // Predicate_atomic_load_xor_16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_32
    // Predicate_atomic_load_and_32
    // Predicate_atomic_load_or_32
    // Predicate_atomic_load_sub_32
    // Predicate_atomic_load_xor_32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_atomic_cmp_swap_64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_64
    // Predicate_atomic_load_and_64
    // Predicate_atomic_load_or_64
    // Predicate_atomic_load_sub_64
    // Predicate_atomic_load_xor_64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 7: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 8: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 9: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 12: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 13: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 14: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 15: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 16: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 17: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 18: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
